<?php // -*- coding:utf-8 -*-
// parameters:
// lang=xx    : only tranlates language 'xx',
//              if not given all languages are translated
// comments   : generate all comments (equal to close&module)
// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made
// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)
// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer
// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)
// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)
// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate langauage 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate langauage 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release 


$lang=Array(
"This script cannot be called directly" => "اين دستخط(script) نمي‌تواند مستقيما فراخواني شود",
"Cannot write to this file:" => "نمي‌توانم در اين پرونده بنويسم:",
"Cannot upload this file maximum upload size exceeded" => "حجم اين پرونده از حد مجاز بيشتري است. نمي‌توانم آن را بارگذاري كنم.",
"Re:" => "در پاسخ به:",
"Missing title or body when trying to post a comment" => "عنوان يا متن هنكام الصاق مفقود شده است",
"The copyright management feature is not enabled." => "خصيصه‌ي مديريت حق انحصاري چاپ(copyright) فعال نيست.",
"You do not have permission to use this feature." => "شما حق دسترسي كافي براي استفاده از اين خصيصه را نداريد.",
"You must supply all the information, including title and year." => "بايد تمام اطلاعات را فراهم كنيد، اين اطلاعات شامل سال و عنوان نيز هستند.",
"You do not have permission to use this feature" => "متاسفانه نمي‌توانيد از اين خصيصه استفاده كنيد.",
"The text in RED is" => "متن قرمز عبارتست از",
"character(s) too long - please edit it." => "تعداد حروف بيش از حد است. لطفا اصلاح كنيد.",
"Algeria" => "الجزاير",
"American_Samoa" => "ساموآي آمريكايي",
"Angola" => "آنگولا",
"Antigua" => "آنتيگا",
"Argentina" => "آرژانتين",
"Armenia" => "ارمنستان",
"Australia" => "استراليا",
"Austria" => "اتريش",
"Bahamas" => "باهاماس",
"Bahrain" => "بحرين",
"Bangladesh" => "بنگلادش",
"Barbados" => "باربادوس",
"Belarus" => "بلاروس",
"Belgium" => "بلژيك",
"Bermuda" => "برمودا",
"Bolivia" => "بوليوي",
"Brazil" => "برزيل",
"Brunei" => "برونئي",
"Canada" => "كانادا",
"Cayman_Islands" => "جزاير كايمن",
"Colombia" => "كلمبيا",
"Cook_Islands" => "جزاير كوك",
"Costa_Rica" => "كاستاريكا",
"Croatia" => "كرواسي",
"Cuba" => "كوبا",
"Cyprus" => "قبرس",
"Czech_Republic" => "جمهوري چك",
"Denmark" => "دانمارك",
"Dominican_Republic" => "جمهوري دمنيكن",
"Ecuador" => "اكوادور",
"Egypt" => "مصر",
"El_Salvador" => "El Salvador",
"Estonia" => "استووني",
"Federated_States_of_Micronesia" => "Federated States of Micronesia",
"Fiji" => "جزاير فيجي",
"Finland" => "فنلاند",
"France" => "فرانسه",
"French_Polynesia" => "پلینزی فرانسه",
"Germany" => "آلمان",
"Greece" => "يونان",
"Guam" => "گوآم",
"Guatemala" => "گوانتانامو",
"Haiti" => "هائیتی",
"Honduras" => "هندوراس",
"Hungary" => "مجارستان",
"Chile" => "شيلي",
"China" => "چين",
"Iceland" => "ايسلند",
"India" => "هند",
"Indonesia" => "اندونزي",
"Iran" => " ايران (جمهوري اسلامي)",
"Iraq" => "عراق",
"Ireland" => "ايرلند",
"Israel" => "فلستين اشغالي",
"Italy" => "ايتاليا",
"Ivory_Coast" => "ساحل عاج",
"Jamaica" => "جامائيكا",
"Japan" => "ژاپن",
"Jordan" => "اردن",
"Kazakstan" => "قزاقستان",
"Kenya" => "كنيا",
"Kiribati" => "كريباتي",
"Kuwait" => "كويت",
"Latvia" => "لتوني",
"Lebanon" => "لبنان",
"Lithuania" => "ليتواني",
"Luxemburg" => "لوكرامبورگ",
"Malawi" => "مالاوی",
"Malaysia" => "مالزي",
"Malta" => "مالت",
"Marshall_Islands" => "جزاير مارشال",
"Mauritius" => "موريس",
"Mexico" => "مكزيك",
"Morocco" => "مراكش",
"Mozambique" => "موزامبيك",
"Nauru" => "ناورو",
"Nepal" => "نپال",
"Netherlands" => "هلند",
"New_Caledonia" => "اسكاتلند جديد",
"New_Zealand" => "زلاند نو",
"Nicaragua" => "نيكاراگوئه",
"Nigeria" => "نيجريه",
"Niue" => "نیووی",
"None" => "هيچكدام",
"Norway" => "نروژ",
"Other" => "ساير",
"Pakistan" => "پاكستان",
"Panama" => "پاناما",
"Papua_New_Guinea" => "پاپوآ گینه نو",
"Paraguay" => "پاراگوئه",
"Peru" => "پرو",
"Phillippines" => "فيليپين",
"Poland" => "لهستان",
"Portugal" => "پرتقال",
"Puerto_Rico" => "پورتوریکو",
"Quatar" => "قطر",
"Romania" => "روماني",
"Russia" => "روسيه",
"Samoa" => "ساموآ",
"Saudi_Arabia" => "عربستان صعنودي",
"Singapore" => "سنگاپور",
"Slovakia" => "اسلواكي",
"Slovenia" => "اسلوني",
"Solomon_Islands" => "جزاير سليمان",
"Somalia" => "سومالي",
"South_Africa" => "آفريقاي جنوبي",
"South_Korea" => "كره‌ي جنوبي",
"Spain" => "اسپانيا",
"Sri_Lanka" => "سريلانكا",
"St_Vincent_Grenadines" => "سنت وينسنت و گرانادينز",
"Surinam" => "سورينام",
"Sweden" => "سوئد",
"Switzerland" => "سوئيس",
"Taiwan" => "تايوان",
"Thailand" => "تايلند",
"Tonga" => "تانگو",
"Trinidad_Tobago" => "تريناداد و توباگو",
"Turkey" => "تركيه",
"Tuvalu" => "تووالو",
"Ukraine" => "اوكراين",
"United_Arab_Emirates" => "امارات متحده عربي",
"United_Kingdom" => "انگلستان",
"United_States" => "ايالات متحده آمريكا",
"Uruguay" => "اروگوئه",
"Vanuatu" => "فانواتو",
"Venezuela" => "ونزوئلا",
"Wales" => "ولز",
"Yugoslavia" => "يوگوسلاوي",
"Zambia" => "زامبيا",
"Zimbabwe" => "زيمباوه",
"Arabic" => "عربي",
"Simplified Chinese" => "چيني ساده‌شده",
"Czech" => "چك",
"Danish" => "دانماركي",
"German" => "آلماني",
"English" => "انگليسي",
"English British" => "انگليسي(انگلستاني)",
"Spanish" => "اسپانايي",
"Greek" => "يواناني",
"French" => "فرانسوي",
"Hebrew" => "عبري",
"Croatian" => "كرواسيايي",
"Italian" => "ايتاليايي",
"Japanese" => "ژاپني",
"Korean" => "كره‌اي",
"Hungarian" => "مجارستاني",
"Dutch" => "هلندي",
"Norwegian" => "نروژي",
"Polish" => "لهستاني",
"Português" => "پرتقالي",
"Brazilian Portuguese" => "پرتقالي برزيلي",
"Russian" => "روسي",
"Slovak" => "اسواكي‌اي",
"Serbian" => "صربي",
"Serbian Latin" => "صربي لاتين",
"Swedish" => "سوئدي",
"Tuvaluan" => "تاوالان",
"Traditional Chinese" => "چيني سنتي",
"Ukrainian" => "اوكرايني",
"Chinese" => "چيني",
"Catalan" => "كاتالان",
"This instance of activity is already complete" => "اين نمونه از فعاليت هم‌اكنون تكميل شده است‌‌‌",
"Fatal error: cannot execute automatic activity \$activityId" => "يك خطاي مهلك رخ داد: نمي‌توانم فعاليت خودكار \$activityId را اجرا كنم.",
"Fatal error: setting next activity to an unexisting activity" => "يك خطاي مهلك رخ داد: سعي در قرار دادن فعاليتي كه وجود ندارد به عنوان فعاليت بعدي.",
"Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "يك خطاي مهلك رخ داد: در مسيريابي خودكار فعاليع‌ها، هيچ نامزد مناسبي به عنوان فعاليت بعدي(nextActivitu) پيدا نشد.",
"Fatal error: non-deterministic decision for autorouting activity" => "يك خطاي مهلك رخ داد: تصميم غيرقطعي براي فعاليت مسيريابي خودكار",
"Fatal error: trying to send an instance to an activity but no transition found" => "يك خطاي مهلك رخ داد: هنگام تلاش براي ارسال يك نمونه به يك فعاليت، هيچ تراكنشي يافت نشد.",
"Cannot add transition only split activities can have more than one outbound transition" => "نمي‌توانم تراكنش را اضافه كنم. تنها فعاليت‌هاي انشعابي(split) مي‌توانند بيش از يك تراكنش خروجي داشته باشند.",
"Circular reference found some activity has a transition leading to itself" => "حلقه‌ي بازگشتي پيدا شد. برخي از فعاليت‌ها تراكنشي دارند كه به خود آن‌ها باز مي‌گردد!",
"Process does not have a start activity" => "فرايند، فعاليت آغازين ندارد!",
"Process does not have exactly one end activity" => "فرايند بايد تنها يك تراكنش پاياني داشته باشد!",
"End activity is not reachable from start activity" => "فعاليت پاياني از طريق فعاليت آغازين قابل دسترس نيست!",
"Activity" => "فعاليت",
" is interactive but has no role assigned" => " تعاملي است، اما هيچ قانوني به آن تخصيص داده نشده است!",
" is non-interactive and non-autorouted but has no role assigned" => " غيرتعاملي وبا مسيريابي دستي(غير خودكار) است اما هيچ قانوني به آن تخصيص داده نشده است!",
" is standalone but has transitions" => " خودمختار(standalone) است اما شامل تراكنش شده است!",
"Role" => "قانون",
" is not mapped" => " نگاشت نشده است.",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "فعاليت '.\$res['name'].' خودمختار است و از شيئ \$instance بهره مي‌گيرد.",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "فعاليت '.\$res['name'].' تعاملي است و بايد ازاسلوب \$instance->complete() استفاده كند.",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "فعاليت غيرتعاملي‌است لذا نبايد از اسلوب استفاده كند",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "فعاليت '.\$res['name'].' انتخاب(switch) شده‌است لذا بايد از اسلوب \$instance->setNextActivity(\$actname) استفاده كند.",
"Process %d has been activated" => "فرايند %d فعال شد",
"Process %d has been deactivated" => "فرايند %d غيرفعال شد",
"Process %s is imported" => "فرايند %s وارد شد",
"Process %s removed" => "فرايند %s حذف شد",
"Process %s has been updated" => "فرايند %s بروز رساني شد",
"Process %s has been created" => "فرايند %s فعال شد",
"by" => "به‌وسيله‌ي",
"continued" => "ادامه دارد",
"click to edit" => "ويرايش",
"click to view" => "نمايش",
"in" => "ميان",
"new image uploaded by" => "تصوير جديد، بارگذاري شده به‌وسيله‌ي:",
"uploaded by" => "بارگذاري شده به‌وسيله‌ي",
"new item in tracker" => "يك فقره‌ي جديد در tracker",
"new subscriptions" => "اشتراك جديد",
"not specified" => "نامشخص",
"Anonymous" => "بي‌نام",
"Use this thread to discuss the %s page." => "از اين رگه براي مطرح كردن صفحه‌ي %s استفاده كنيد",
"WikiDiff::apply: line count mismatch: %s != %s" => "تغييرات ويكي::apply:تعداد خطوط همخواني ندارد:%s != %s",
"WikiDiff::_check: failed" => "تغييرات ويكي::_check:ناموق بود",
"WikiDiff::_check: edit sequence is non-optimal" => "تغييرات ويكي::_check: ترتيب ويرايش بهينه نيست.",
"WikiDiff Okay: LCS = %s" => "تغييرات ويكي صحيح است:LCS= %s",
"Versions are identical" => "نسخ مشابه‌اند.",
"Line:" => "خط:",
"Lines:" => "خطوط:",
"Newsletter subscription information at " => "اطلاعات مربوط به اشتراك خبرنامه در",
"There was a problem with your upload." => "مشكلي در بارگذاري شما بوجود آمده است.",
"The file you are trying to upload is too big." => "پرونده‌اي كه مي‌خواهيد بارگذاري كنيد، بسيار حجيم است",
"The file you are trying to upload was only partially uploaded." => "پرونده‌اي كه مي‌خواستيد بارگذاري كنيد، نيمه‌كاره بارگذاري شد!",
"You must select a file for upload." => "شما بايد يك پرونده براي بارگذاري انتخاب كنيد.",
"Wiki Home" => "مبدا ويكي",
"Home" => "مبدا",
"Blogs" => "بلاگ‌ها",
"posted on" => "الصاق شده در",
"Continue" => "ادامه",
"Articles" => "مقالات",
"previous page" => "صفحه‌ي قبل",
"next page" => "صفحه‌ي بعد",
"By:" => "به‌وسيله‌ي:",
"Read" => "خوانده‌شده‌ها",
"List articles" => "فهرست مقالات",
" line " => " خط ",
"Error: No" => "خطاي شماره‌ي:",
"permission." => "حقوق دسترسي.",
"Error: Invalid" => "خطا: بي اعتباري",
"Error: Call to hw_page_fetch_by_id failed!" => "خطا: صدازدن hw_page_fetch_by_id موفق نبود!",
"No image yet, sorry." => "متاسفم، هنوز هيچ تصويري وجود ندارد.",
"No valid ogr2ogr executable" => "ogr2ogr غيرقابل اجرا",
"This feature is disabled" => "اين خصلت غيرفعال است",
"Could not create \$tdo.mif in data directory" => "نمي‌توانم \$tdo.mif را در پوشه‌ي داده‌ها ايجاد كنم",
"Could not create \$tdo.mid in data directory" => "نمي‌توانم \$tdo.mid را در پوشه‌ي داده‌ها ايجاد كنم",
"unknown" => "ناشناخته",
"User Map Generated in:" => "نقشه‌ي كاربر توليد شده در:",
"Image Map Generated in:" => "تصوير كاربر ساخته شده در:",
"NONE" => "هيچكدام",
"File %s not found" => "پرونده‌ي %s يافت نشد",
"File %s is not a valid archive" => "پرونده‌ي %s يك بايگاني معتبر نيست",
"%s is an empty archive file" => "%s يك پرونده‌ي بايگاني خالي است",
"Invalid remote file on url %s" => "پرونده‌ي راه‌دور در آدرس %s معتبر نيست",
"Impossible to open %s : %s" => "باز كردن %s غيرممكن است: %s",
"Project Group for " => "گروه پروژه براي ",
"Project Admin Group for " => "گروه مديريت پروژه براي ",
"Wiki top pages" => "بهترين صفحات ويكي",
"Hits" => "ضربت‌ها(Hits)",
"Most relevant pages" => "مرتبط‌ترين صفحات",
"Relevance" => "رابطه",
"Wiki last pages" => "آخرين صفحات ويكي",
"Modified" => "تغيير كرده در:",
"Forums last topics" => "آخرين عناوين انجمن‌ها",
"Topic date" => "تاريخ عنوان",
"Forums last posts" => "آخرين الصاقات انجمن‌ها",
"Forums most read topics" => "پرخواننده‌ترين انجمن‌ها",
"Reads" => "تعداد دفعات مشاهده",
"Forums best topics" => "بهترين عناوين انجمن‌ها",
"Score" => "امتيازدهي",
"Forums most visited forums" => "پربيننده‌ترين انجمن‌ها",
"Visits" => "بازديدها",
"Forums with most posts" => "پر الصاق ترين پربيننده‌ترين",
"Posts" => "الصاق‌ها",
"Wiki top galleries" => "سرسراهاي برتر ويكي",
"Wiki top file galleries" => "سرسرهاي برتر پرونده‌هاي",
"Wiki top images" => "تصاوير برتر ويكي",
"Wiki top files" => "پرونده‌هاي برتر ويكي",
"Downloads" => "دريافت‌ها",
"Wiki last images" => "آخرين تصاوير ويكي",
"Upload date" => "تاريخ بارگذاري",
"Wiki last files" => "خرين پرونده‌هاي ويكي",
"Wiki top articles" => "برترين مقالات ويكي",
"Most visited blogs" => "پربيننده‌ترين بلاگ‌ها",
"Most active blogs" => "فعال‌ترين بلاگ‌ها",
"Blogs last posts" => "آخرين الصاق بلاگ",
"Post date" => "تاريخ الصاق",
"Wiki top authors" => "برترين مؤلفان ويكي",
"Pages" => "صفحات",
"Top article authors" => "برترين مؤلفان مقالات",
"Login" => "ورود",
"See other user's profile" => "مشاهده‌ي نمايه‌ي(profile) ساير كاربران",
"Have your profile seen" => " مشاهده‌ي نمايه‌ي(profile) خود توسط ديگر كاربران",
"Make friends" => "رفيق شدن",
"Receive message" => "دريافت پيغام",
"Send message" => "ارسال پپغام",
"Read an article" => "خواندن يك مقاله",
"Publish an article" => "انتشار يك مقاله",
"Have your article read" => "خوانده شدن مقاله",
"Create new file gallery" => "ايجاد يك سرسراي پرونده‌ي جديد",
"Upload new file to gallery" => "بارگذاري پرونده‌ي جديد به سرسرا",
"Download other user's file" => "دريافت پرونده‌هاي ساير كاربران",
"Have your file downloaded" => "دريافت شدن پرونده‌هاي بارگذاري شده",
"Create a new image gallery" => "ايجاد يك سرسراي جديد",
"Upload new image to gallery" => "بارگذاري تصوير جديد در سرسرا",
"See other user's gallery" => "مشاهده‌ي سرسراي تصاوير ديگر كاربران",
"See other user's image" => "مشاهده‌ي تصاوير ساير كاربران",
"Have your gallery seen by other user" => "مشاهده‌ي سرسراي خود به‌وسيله‌ي ديگر كاربران",
"Have your image seen" => "ديده‌شدن تصوير خود",
"Create new blog" => "يك بلاگ جديد ايجاد كن",
"Post in a blog" => "الصاق در يك بلاگ",
"Read other user's blog" => "خواندن بلاگ‌هاي ساير كاربران",
"Have your blog read" => "خوانده‌شدن بلاگ توسط ساير كاربران",
"Create a new wiki page" => "ساخت يك ويكي جديد",
"Edit an existing page" => "ويرايش يك صفحه‌ي موجود",
"Attach file" => "ضميمه كردن پرونده",
"Tracker" => "Tracker",
"Unknown" => "ناشناخته",
"Trackeritem" => "فقره‌ي tracker",
"Image Gallery" => "سرسراي تصاوير",
"Image" => "تصوير",
"Blog" => "بلاگ",
"Article" => "مقاله",
"Wiki" => "ويكي",
"Directory category" => "طبقه‌ي پوشه",
"Directory" => "پوشه",
"FAQ" => "سئوالات متداول",
"Forum" => "انجمن",
"Gallery" => "سرسرا",
"File" => "پرونده",
"Blog post" => "الصاق بلاگ",
"Link" => "پيوند",
"help" => "كمك",
"The text is" => "متن عبارت است از",
"Text cut here" => "متن اين‌جا قطع مي‌شود",
"Task" => "وظيفه",
"from" => "از",
"for" => "براي",
"Priority" => "اولويت",
"Start date:" => "تاريخ شروع:",
"End date:" => "تاريخ پايان:",
"%A %d of %B, %Y" => "%A %d از %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d از %B, %Y[%H:%M:%S %Z]",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"%a %d of %b, %Y" => "%a %d از %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d از %b, %Y[%H:%M %Z]",
"%H:%M %Z" => "%H:%M %Z",
"Friend" => "رفيق",
"Last seen on " => "آخرين بار روئيت شده در",
"(idle for %s seconds)" => "(بيكار براي %s ثانيه)",
"User information - Click for more info" => "اطلاعات كاربر – براي اطلاعات بيشتر اين‌جا را كليك كنيد",
"More info about \$other_user" => "اطلاعات بيشتر درخصوص \$other_user",
"(idle for \$idletime seconds)" => "(بيكار بري \$idletime ثانيه)",
"locked" => "قفل شده",
"unlocked" => "قفل نشده",
"created from structure" => "ايجاد شده از ساختار",
"Use this tree to copy the structure" => "از اين درختواره براي كپي ساختار استفاده كن",
"You are not logged in" => "شما به سامانه وارد نشده‌ايد",
"Permission denied" => "دسترسي غيرممكن",
"An error occured in a database query!" => "خطايي در يكي از درخواست‌ها به بانك اطلاعاتي رخ داد!",
"You are banned from" => "دسترسي شما به اين بخش ممنوع شده است:",
"wiki" => "ويكي",
"img-g" => "تصوير-g",
"file-g" => "پرونده-g",
"faqs" => "سئوالات متداول",
"quizzes" => "آزمون‌ها",
"arts" => "هنرها",
"blogs" => "بلاگ‌ها",
"forums" => "انجمن‌ها",
"games" => "بازي‌ها",
"no description" => "بدون شرح",
"picture not found" => "تصوير پيدا نشد",
"drawing not found" => "نقاشي پيدا نشد",
"Click to edit dynamic variable" => "براي ويرايش متغيير پويا اين‌جا را كليك كنيد",
"Update variables" => "به‌روز رساني متغييرها",
"%d points" => " امتياز%d",
"Removed" => "حذف شد",
"Created" => "ايجاد شده در:",
"__WARNING__: No such module \$plugin! " => "__اخطار__: چنين ماژولي وجود ندارد \$plugin! ",
"new" => "جديد",
"Create page:" => "ساخت صفحه:",
"Updated" => "به‌روز رساني شد",
"Unknown language" => "زبان ناشناخته",
"Click here to confirm your action" => "براي تاييد اين دكمه را بفشاريد",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF)  كشف شدو عمليات مسدود شد.",
"Tracker was modified at " => "Tracker در اين‌جا تغيير كرد  ",
"Item Modification" => "تغيير فقره",
"Item" => "قلم",
"Item creation" => "ايجاد فقره",
"Rating" => "رتبه‌بندي",
"checkbox" => "جعبه انتخاب(checkbox)",
"Checkbox options: put 1 if you need that next field is on the same row." => "انتخاب: برابر يك قرار دهيد اگر اين گزينه در همان ستون است.",
"numeric field" => "ستون عددي",
"Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "اختيارات: 1، size، prepend،append،max. حجم(size)، به تعداد حرف؛ افزودن به ابتدا(prepend)، اطلاعات را به ابتداي ستون اضافه مي‌كند؛ افزودن به انتها(append)، اطلاعات را به انتهاي ستون اضافه مي‌كند؛ بيشينه(max)، بيشينه تعداد حروفي كه مي‌تواند ذخيره شود. 1 اوليه مشخص كننده‌ي اين مطلب كه ستون بعدي در همين سطر است",
"text field" => "رشته‌ي متني",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "اختيارات رشته‌ي متني: 1، size، prepend،append،max. حجم(size)، به تعداد حرف؛ افزودن به ابتدا(prepend)، اطلاعات را به ابتداي ستون اضافه مي‌كند؛ افزودن به انتها(append)، اطلاعات را به انتهاي ستون اضافه مي‌كند؛ بيشينه(max)، بيشينه تعداد حروفي كه مي‌تواند ذخيره شود. 1 اوليه مشخص كننده‌ي اين مطلب كه ستون بعدي در همين سطر است",
"textarea" => "متن",
"Textarea options: quicktags,width,height,max,listmax - Use Quicktags is 1 or 0, widthis indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax isthe maximum number of characters that are displayed in list mode." => "اختيارات متني: options,width,height,max Option 0 يا 1 است، widthوheight حجم به حرف و خط هستند و max بيشينه مقدار تعداد حروف است كه مي‌توان ذخيره كرد.",
"drop down" => "كركره‌اي",
"Dropdown options: list of items separated with commas." => "اختيارات ستون كركره‌اي: فهرست اقلام با كاما جدا مي‌شوند.",
"user selector" => "انتخاب كاربران",
"User Selector: use options for automatic field feeding : you can use 1 for author login or 2 for modificator login." => "اختيارات: از اختيارات براي تغذيه‌ي خودكار ستون استفاده كنيد. مي‌توانيد از 1 براي مولف و 2 براي تغييردهنده استفاده كنيد.",
"group selector" => "انتخاب گروه كاربري",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "اختيارات: از اختياراتبراي تغذيه‌ي خودكار ستون استفاده كنيد. مي‌توانيد از 1 براي گروه كاربري ايجاد كننده و 2 براي گروه كاربري تغييردهنده استفاده كنيد. گروه اگر گروه كاربري پيش‌فرض تنظيم نشده باشد، اولين گروه كاربري براي هر كاربر استفاده مي‌شود و يا گروه پيش‌فرض 'ثبت‌نام كرده‌هاست'.",
"date and time" => "زمان و تاريخ",
"jscalendar" => "تقويم JS",
"image" => "تصوير",
"Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels." => "اختيارات: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale همه به پيكسل.",
"action" => "عمل",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "اختيارات: Label,post,tiki-index.php,page. page:نام پرونده، highlight=متن",
"header" => "سرصفحه",
"category" => "طبقه",
"Category options: parentId" => "اختيارات: parentId",
"item link" => "پيوند به فقره",
"Item Link options: trackerId,fieldId,linkToItem links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing" => "اختيارات: trackerId,fieldId,linkToItem پيوند به اقلامي از trackerid هستند كه fielded معادل محتويات اين ستون است. linkToItem 0و1 براي ايجاد يك پيوند به فقره در حالت نمايش و تغيير.",
"items list" => "فهرست اقلام",
"Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing" => "اختيارات: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere  نمايش‌گر فهرست displayFieldIdThere هستند كه اقلام در tracker مشخص‌شده با trackerId، كه fieldIdThere معادل fieldIdHere باشد.",
"email" => "پست الكترونيكي",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "اختيارات: 0،1و2. كه 0 آدرس را با عنوان متن ساده قرار مي‌دهد، 1 يك پست با كدهاي شانزده‌تايي قرار مي‌دهد(براي spamها و spiderها كار مشكل‌تر مي‌شود)، و 2 يك كد mailto با صورت عادي href قرار مي‌دهد.",
"system" => "سامانه",
"open" => "باز",
"pending" => "معلق",
"closed" => "بسته",
"message" => "پيغام",
"No extra information for that attached file. " => "هيچ اطلاعات اضافي در خصوص پرونده‌ي ضميمه‌شده وجود ندارد ",
"child categories" => "طبقات فرزند",
"objects in category" => "اشياء در طبقه",
"(AT)" => "(AT)",
"(DOT)" => "(DOT)",
"Include all post in a blog" => "شامل تمام الصاق‌هاي يك بلاگ",
"Date" => "تاريخ",
"Title" => "عنوان",
"Author" => "مؤلف",
"Include a page" => "شامل يك صفحه است",
"Displays browser client info" => "نمايش اطلاعات مرورگر ارباب رجوع",
"Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor" => "يك پيوند به يك لنگر(anchor) در صفحه‌اي از ويكي قرار مي‌دهد. در اتحاد با pluginاي كه نام و مكان لنگر را مشخص مي‌كند(ANAME) استفاده شود.",
"linktext" => "متن پيوند",
"Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor" => "يك پيوند به يك لنگر(anchor) در صفحه‌اي از ويكي قرار مي‌دهد. در اتحاد با pluginاي كه پيوندبه لنگر را مي‌سازد(ALINK) استفاده شود.",
"Include an article" => "شامل يك مقاله",
"~np~{~/np~ARTICLES(max=>3,topic=>topicName)}{ARTICLES} Insert articles into a wikipage" => "~np~{~/np~ARTICLES(max=>3,topic=>topicName)}{ARTICLES} درج مقاله‌ها در يك صفحه‌ي ويكي",
"no such attachment on this page" => "چنين پميمه‌اي در اين صفحه وجود ندارد",
"Displays an attachment or a list of them" => "يك ضميمه يا فهرستي از آن‌ها نمايش مي‌دهد",
"comment" => "ايراد نظر",
"num is optional and is the order number of the attachment in the list. If not provided, a list of all attachments is displayed.  Inline makes the comment be the text of the link." => "شماره(num) اختياري است و ترتيب ضمايم را در فهرست مشخص مي‌كند. اگر وارد نشود، فهرستي از تمام ضمايم نمايش داده مي‌شود. Inline باعث مي‌شود نظر به متن پيوند تبديل شود.",
"Displays the user Avatar" => "شكلك كاربر رو نمايش بده",
"username" => "نام كاربري",
"List all pages which link to specific pages" => "تمام صفحاتي كه به يك صفحه‌ي خاص اشاره مي‌كنند را فهرست مي‌كند",
"Page cannot be found" => "چنين صفحه‌اي پيدا نشد",
"No pages links to" => "هيچ صفحه‌اي به اين مورد پيوند ندارد",
"One page links to" => "يك صفحه به اين مورد پيوند دارد",
"pages link to" => "صفحاتي كه به اين مورد پيوند دارند",
"Insert theme styled box on wiki page" => "جعبه‌ي سبك قيافه در صفحه‌ي ويكي قرار بگيرد",
"text" => "متن",
"Insert list of items for the current/given category into wiki page" => "در صفحات ويكي، فهرست اقلام طبقه‌ي جاري/انتخابي را درج كن",
"Categories are disabled" => "طبقات غيرفعال‌اند",
"Display Tiki objects that have not been categorized" => "اشياء تيكي كه طبقه‌بندي نشده‌اند را نمايش بده",
"Insert the full category path for each category that this wiki page belongs to" => "آدرس كامل طبقه را براي هر طبقه كه اين صفحه‌ي ويكي به آن تعلق دارد درج كن",
"Centers the plugin content in the wiki page" => "محتويات plugin را در مركز صفحه‌ي ويكي قرار بده",
"Displays a snippet of code" => "يه تيكه از كد را نمايش بده",
"code" => "دستورالعمل",
"note: colors and ln are exclusive" => "نكته: رنگ‌ها و ln اختصاصي هستند",
"Insert copyright notices" => "اطلاعيه‌ي حقوق انحصاري چاپ(copyright) را درج كن",
"Example" => "مثال",
"days" => "روز",
"hours" => "ساعت",
"minutes" => "دقيقه",
"and" => "و-با-",
"seconds" => "ثانيه",
"Insert a division block on wiki page" => "يك بلاك تقسيم در صفحه‌ي ويكي قرار بده",
"Creates a definition list" => "يك فهرست تعريف تهيه كن",
"term" => "دوره",
"definition" => "معني",
"one definition per line" => "يك معني در هر خط",
"Displays the data using the Tikiwiki odd/even table style" => "اطلاعات را با استفاده از سبك جدول زوج/فرد تيكي-ويكي نمايش بده",
"cells" => "سلول(ها)",
"heads and cells separated by ~|~" => "راس‌ها و سلول‌ها با  ~|~ از هم جدا مي‌شوند",
"Displays a SWF on the wiki page" => "نمايش يك پرونده‌ي SWF در صفحه‌ي ويكي",
"Displays a graphical GAUGE" => "يك پيمانه‌ي ترسيمي(Graphical GAUGE) نمايش بده",
"description" => "شرح",
"Displays the text only if the language matchs" => "فقط درصورتي كه زبان همخواني داشت متن را نمايش مي‌دهد",
"Displays an miniquiz" => "يك نيم‌چه آزمون نمايش مي‌دهد",
"Please choose a module" => "لطفا يك ماژول انتخاب كنيد",
"to be used as argument" => "براي استفاده به‌عنوان آرگومان",
"Displays a module inlined in page" => "يك ماژول را در ميان صفحه نمايش مي‌دهد",
"Sorry no such module" => "متاسفانه چنين ماژولي وجود ندارد",
"Displays the data using a monospace font" => "داده‌ها را با استفاده از يك قلم monospace نمايش مي‌دهد",
"Provides a list of plugins on this wiki." => "يك فهرست از pluginهاي اين ويكي را نمايش مي‌دهد.",
"No version indicated" => "هيچ نسخه‌اي مشخص نشده است",
"No arguments indicated" => "هيچ آرگوماني مشخص نشده است",
"Displays the output of a poll, fields are indicated with numeric ids." => "خروجي يك راي‌گيري را نمايش مي‌دهد، ستون‌ها را اعداد مشخص مي‌شوند",
"missing poll ID for plugin POLL" => "شناسه‌ي راي‌گيري براي plugin راي‌گيري مفقود شده است",
"Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "عبارت regex را مي‌گيرد و محتواي بين تگ‌هاي آن را تجزيه كرده با متن جايگزين مي‌كند",
"data" => "داده‌ها",
"one data per line" => "يك داده در هر خط",
"~np~{~/np~RSS(id=>feedId,max=>3,date=>1,body=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId,max=>3,date=>1,body=>1)}{RSS} درج خروجي تغذيه‌ي RSS در يك صفحه‌ي ويكي",
"Automatically creates a link to the appropriate SourceForge object" => "به‌صورت خودكار يك پيوند به شيء مناسب در SourceForge ايجاد كن",
"TikiSheet" => "ورق‌‌هاي تيكي",
"Sheet Heading" => "سرصفحه‌ي ورق",
"List wiki pages" => "فهرست صفحات ويكي",
"Last modified by" => "آخرين بار به‌وسيله‌ي ايشان تغيير كرده است",
"The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "pluin مربوط به SNARF، خود را جايگزين متن HTML مربوط به آن URL مي‌كند. Regex به‌صورت دلخواه",
"This data is put in a CODE caption." => "Plugin مربوط به SNARF خود را جايگزين بدنه‌ي HTML يك URL مي‌كند. جايگزيني Regex نيز با استفاده از regex يا regexres در محتوا ممكن خواهد بود كه مورد دوم به عنوان آرگوماني براي preg_replace استفاده خواهد شد.",
"Missing url parameter for SNARF plugin." => "پارامتر URL براي SNARF مفقود شده است",
"Sorts the plugin content in the wiki page" => "مربت كردن محتواي يك plugin در صحفه‌ي ويكي",
"Split a page into rows and columns" => "انشعاب يك صفحه به سطرها و ستون‌ها",
"row1col1" => "سطر 1، ستون 1",
"row1col2" => "سطر 1، ستون 2",
"row2col1" => "سطر 2، ستون 1",
"row2col2" => "سطر 2، ستون 2",
"Missing db param" => "پارامتر بانك اطلاعاتي مفقود است",
"Run a sql query" => "اجراي يك جستار SQL",
"sql query" => "جستار SQL",
"Displays text in subscript." => "متن را در پانويس نمايش مي‌دهد",
"Displays the thumbnail for an image" => "تصويرك يك تصوير را نمايش مي‌دهد",
"Search the titles of all pages in this wiki" => "عناوين تمام صفحه‌هاي اين ويكي را جستجو كن",
"No pages found for title search" => "هيچ صفحه‌اي براي اين جستجو در عناوين يافت نشد",
"One page found for title search" => "يك صفحه در جستجوي عناوين يافت شد",
" pages found for title search" => " صفحه در جستجوي عناوين يافت شد",
"Displays an input form for tracker submit" => "يك فرم ورودي براي ارائه‌ي tracker نمايش مي‌دهد",
"Save" => "ذخيره كن",
"You need to supply information for : " => "شما بايد در اين خصوص اطلاعات بيشتري فراهم كنيد: ",
"Fields marked with a * are mandatory." => "پركردن مواردي كه با * علامت زده شده‌اند اجباري است.",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "خروجي محتواي يك tracker را نمايش مي‌دهد، ستون‌ها با اعداد مشخص شده‌اند",
"missing tracker ID for plugin TRACKER" => "براي Plugin مربوط به tracker، شناسه‌ي tracker مفقود است",
"missing fields list" => "فهرست ستون‌ها مفقود است",
"at" => "راس ساعت",
"Error in tracker ID" => "خطا در شناسه‌ي tracker",
"No field indicated" => "هيچ ستوني مشخص نشده است",
"Links to a translated content" => "به يك محتواي ترجمه شده پيوند مي‌زند",
"Displays the number of registered users" => "تعداد كاربران ثبت‌نام كرده را نمايش مي‌دهد",
"Split the text in parts visible only under some conditions" => "تنها در شرايط خاص، متن منشعب در بخش‌ها قابل روئيت است",
"Plugin " => "Plugin مربوط به ",
"failed" => "ناموفق بود",
"ERROR: Either the subject or body must be non-empty" => "خطا: هيچ‌كدام از متن و موضوع نبايد خالي باشند",
"ERROR: No valid users to send the message" => "خطا: هيچ كاربر معتبري براي ارسال پيغام يافت نشد",
"Invalid user" => "كاربر نامعتبر است",
"Message will be sent to: " => "پيغام براي اين كاربران ارسال خواهد شد:",
"User \$a_user can not receive messages" => "كاربر \$a_user نتوانست پيغام را دريافت كند",
"Invalid user: \$a_user" => "كاربر: \$a_user معتبر نيست",
"No more messages" => "پيغام‌هاي بيشتر مقدور نيست",
"move %s in %s" => "%s را به %s منتقل كن",
"Please provide an Id" => "لطفا يك شناسه فراهم كنيد",
"no object here yet" => "هنوز هيج شئيي اين‌جاي نيست",
"This module requires parameters trackerId and name set" => "اين ماژول نياز به تنظيم پارامترهاي trackerid و name دارد",
"edit" => "ويرايش",
"Quick edit a Wiki page" => "ويرايش سريع يك صفحه‌ي ويكي",
"Since your last visit" => "از آخرين بازديد شما...",
"Changes" => "تغييرات",
"since" => "از",
"Changes since" => "تغييرات از",
"new comments" => "نظرات جديد",
"wiki pages changed" => "صفحه‌ي ويكي تغيير كرده‌اند",
"new articles" => "مقاله‌ي جديد",
"new FAQs" => "FAQ جديد",
"new blogs" => "بلاگ‌هاي جديد",
"new blog posts" => "الصاق‌هاي جديد بلاگ",
"new image galleries" => "سراسراهاي تصوير جديد",
"new images" => "تصاوير جديد",
"new file galleries" => "سراسراهاي پرونده‌ي جديد",
"new files" => "پرونده‌هاي جديد",
"new polls" => "راي‌گيري‌هاي جديد",
"new users" => "كاربران جديد",
"no such file" => "چنين فايلي وجود نداشت",
"Error" => "خطا",
"The task title must have at least 3 characters" => "موضوع وظيفه، بايد حدااقل 3 حرف باشد",
"List of attached files" => "فهرست پرونده‌هاي ضميمه شده",
"name" => "نام",
"desc" => "توضيحات",
"uploaded" => "بارگذاري شده",
"size" => "اندازه",
"delete" => "حذف",
"Remove" => "حذف",
"Upload file" => "بارگذاري پرونده",
"attach" => "ضميمه",
"debug" => "اشكال‌زدايي",
"Fatal error" => "خطاي مهلك",
"Categorize" => "طبقات",
"show categories" => "طبقات را نمايش بده",
"hide categories" => "طبقات را مخفي كن",
"Tip: hold down CTRL to select multiple categories" => "نكته: براي انتخاب چندين طبقه، دكمه‌ي CTRL را نگه‌داريد‌‌",
"categorize this object" => "اين شيء را طبقه‌بندي كن",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "نكته: براي از طبقه‌بندي در آوردن اين شيء، گزينه‌ي بالا را رفع انتخاب كنيد",
"No categories defined" => "هيچ طبقه‌اي تعريف نشده است",
"Admin categories" => "مديريت طبقات",
"author" => "مؤلف",
"stars" => "شروع",
"user level" => "سطح كاربر",
"private message" => "پيغام شخصي",
"send email to user" => "ارسال پست الكترونيكي به كاربر",
"user online" => "كاربر روي خط است",
"user offline" => "كاربر خارج خط است",
"on" => "در",
"score" => "امتياز",
"Vote" => "اخذ راي",
"Edit" => "ويرايش",
"reply" => "پاسخ",
"attachment" => "ضميمه",
"Moderator actions" => "اعمال ناظم",
"delete selected" => "انتخاب شده‌ها را حذف كن",
"Move to topic:" => "به اين موضوع منتقلش كن:",
"move" => "انتقال",
"reported:" => "گزارش داده شده:",
"queued:" => "درصف قرار گرفته:",
"Posted messages" => "پيغام‌هاي الصاق شده",
"Messages" => "پيغام",
"All" => "همه",
"Style" => "سبك",
"Plain" => "ساده",
"Threaded" => "مانند نخ كشيده",
"Headers Only" => "فقط سرفصل",
"Sort" => "مرتب بر اساس",
"Newest first" => "ابتدا جديدترها",
"Oldest first" => "ابتدا قديمي‌ترها",
"Threshold" => "آستانه",
"Find" => "دنبال اين بگرد",
"set" => "تغيير بده",
"Top" => "فوقاني",
"replies" => "پاسخ داده‌شده",
"below your current threshold" => "پايين‌تر از حد آستانه‌ي شما",
"prev" => "قبلي",
"Page" => "صفحه‌ي",
"next" => "بعدي",
"new reply" => "پاسخ جديد",
"Editing reply" => "ويرايش پاسخ",
"Reply to the selected post" => "پاسخ به الصاق‌هاي انتخاب شده",
"Post new reply" => "الصاق يك پاسخ جديد",
"Editing comment" => "ويرايش نظر",
"Comment on the selected post" => "ايراد نظر درمورد الصاق انتخاب شده",
"Post new comment" => "ايراد نظر جديد",
"Preview" => "پيش‌نمايش",
"Reply to parent post" => "پاسخ به نظر مادر",
"preview" => "پيش‌نمايش",
"post" => "الصاق",
"cancel" => "لغو",
"Required" => "(اجباري)",
"Smileys" => "صورتك‌ها",
"Reply" => "پاسخ",
"Comment" => "نظر",
"Posting replies" => "الصاق پاسخ",
"Posting comments" => "نظرهاي الصاقات",
"Use" => "استفاده كنيد",
"or" => "يا",
"for links" => "براي پيوندها، از",
"HTML tags are not allowed inside posts" => "كدهاي HTML داخل الصاق‌ها مجاز نيستند",
"Go back" => "به جاي قبلي بازگرد",
"Return to home page" => "به صفحه‌ي مبدا بازگرد",
"Copyrights" => "حقوق انصحاري چاپ",
"Year" => "سال",
"Authors" => "مولفين",
"add" => "اضافه كن",
"Syntax" => "نحو",
"Page generation debugging log" => "ثبت رويداد اشكال‌زدايي توليد صفحه",
"Features state" => "آمار خصايص",
"Total" => "مجموع",
"features matched" => "خصايص هم‌خواني دارند",
"Watchlist" => "فهرست ديده‌بان‌ها",
"There are no wiki pages similar to '{\$page}'" => "هيج صفحه‌ي ويكي مشابه '{\$page}' وجود ندارد",
"Click here to create it" => "براي ساخت اين‌جا را كليك كنيد",
"Close Window" => "پنچره را ببند",
"Last update from CVS" => "آخرين به‌روز رساني از CVS",
"RSS Wiki" => "RSS براي ويكي",
"RSS Blogs" => "RSS براي بلاگ‌ها",
"RSS Articles" => "RSS براي مقالات",
"RSS Image Galleries" => "RSS براي سرسراهاي تصاوير",
"RSS File Galleries" => "RSS براي سرسراهاي تصاوير",
"RSS Forums" => "RSS برا انجمن‌ها",
"RSS Maps" => "RSS براي نقشه‌ها",
"RSS Directories" => "RSS براي پوشه‌ها",
"Hi {\$mail_user} has sent you this link:" => "سلام، {\$mail_user} براي شما اين پيوند را ارسال كرده است",
"Blog post:" => "الصاق بلاگ:",
"at:" => "در:",
"Somebody or you tried to subscribe this email address at our site:" => "شما يا شخص ديگري، سعي در مشترك كردن اين پست الكترونيكي در اين پايگاه داشته‌اند:",
"To the event:" => "به اين رويداد:",
"Description:" => "شرح:",
"In order to confirm your subscription you must access the following URL:" => "براي تاييد اشتراك خود، بايد اين پيوند را دنبال كنيد:",
"To the newsletter:" => "به خبرنامه‌ي:",
"Bye bye!" => "خداحافظ!",
"This email address has been removed to the list of subscriptors of:" => "اين پست الكترونيكي به از فهرست مشتركين اين بخش حذف شد:",
"Event:" => "رويداد:",
"Bye bye from %s at %s" => "از %s در %s خداحافظ",
"You can unsubscribe from this event following this link" => "با دنبال كردن اين پيوند، مي‌توانيد از اين رويداد لغو اشتراك كنيد",
"Welcome to our event!" => "به رويدادهاي ما خوش‌آمديد!",
"This email address has been added to the list of subscriptors of:" => "اين آدرس پست الكترونيكي اضافه شد به فهرست اشتراك‌هاي:",
"You can always cancel your subscription using:" => "شما همواره مي‌توانيد اشتراك خود را بدين‌طريق لغو نماييد:",
"Welcome to %s at %s" => "به %s در %s خوش‌آمديد",
"A new message was posted to forum" => "يك پيغام جديد به انجمن الصاق شده است",
"New topic:" => "عنوان جديد:",
"Topic:" => "عنوان:",
"Message" => "پيغام",
"You sent a request with the subject:" => "شما يك درخواست با اين موضوع فرستاده‌ايد:",
"Use the subject to indicate the operation to apply:" => "از موضوع براي مشخص كردن عملي كه بايد اجرا شود استفاده كنيد:",
"GET:WikiName to get a wiki page" => "GET:'نام ويكي'، براي گرفتن نام صفحه‌ي ويكي",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:'نام ويكي'، براي به‌روز رساني/ايجاد يك صفحه‌ي ويكي (از بدنه(body) براي اطلاعات صفحه استفاده كنيد)",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:'نام ويكي'، براي افزودن داده به يك صفحه‌ي ويكي (از بدنه(body) براي اطلاعات صفحه استفاده كنيد)",
"PREPEND:WikiName to append the data at the top" => "PREPEND:'نام ويكي'، براي افزودن داده با بالاي صفحه",
"Tiki mail-in instructions" => "دستورالعمل 'كنترل با پست الكترونيكي' تيكي",
"Tiki mail-in auto-reply." => "پاسخ خودكار 'كنترل با پست الكترونيكي' تيكي.",
"Page not found:" => "صفحه پيدا نشد:",
"Hi," => "سلام،",
"A new message was posted to you at {\$mail_machine}" => "يك پست الكترونيكي در {\$mail_machine} براي شما ارسال شده است",
"From" => "از طرف",
"Subject" => "موضوع",
"New message arrived from %s" => " يك پيغام جديد ازطرف %s دريافت شد",
"Hi" => "سلام",
"has requested an account on" => "درخواست يك حساب در اين‌جا كرده است",
"To validate that account, please follow the link:" => "براي معتبر ساخت آن حساب، لطفا اين پيوند را دنبال كنيد:",
"best regards" => "با احترام",
"your Tikiwiki" => "تيكي-ويكي شما",
"Tiki User Registration Request" => "درخواست عضويت كاربر در تيكي",
"The user" => "كاربر",
"registered at your site" => "در پايگاه شما ثبت‌نام كرد",
"New user registration" => "ثبت‌نام كاربر جديد",
"Newsletter:" => "خبرنامه:",
"You can unsubscribe from this newsletter following this link" => "با دنبال كردن اين پيوند، شما مي‌توانيد عضويت خود را از اين خبرنامه لغو كنيد",
"Welcome to our newsletter!" => "به خبرنامه‌ي ما خوش‌آمديد!",
"Tiki email notification" => "آگاه‌ساز پست الكترونيكي تيكي",
"someone coming from IP Address" => "كسي از اين آدرس مي‌آيد",
"requested a reminder of the password for the" => "درخواست يادآوري كلمه‌ي عبور براي",
"account" => "حساب",
"since this is your registered email address we inform that the" => "از آن‌جايي كه اين آدرس پست الكترونيكي ثبت شده‌ي شما است، به اطلاع مي‌رساند كه",
"password for this account is" => "كلمه‌ي عبور اين حساب عبارت است از",
"Your Tiki account information for %s" => "اطلاعات حساب تيكي شما براي %s",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "يك مقاله‌ي جديد به‌وسيله‌ي {\$mail_user} به {\$mail_site} در {\$mail_date|tiki_short_datetime} ارسال شد",
"You can edit the submission following this link:" => "با دنبال كردن اين پيوند مي‌تواند مورد ارسال شده را ويرايش كنيد:",
"Title:" => "عنوان:",
"Heading:" => "سرصفحه:",
"Body:" => "متن:",
"New article submitted at %s" => "مقاله‌ي جديد در %s ثبت شد",
"View the tracker item at:" => "فقره‌ي tracker را در اين‌جا مشاهده كنيد:",
"Information:" => "اطلاعات:",
"you or someone registered this email address at" => "شما يا شخص ديگري اين آدرس پست الكترونيكي را در اين‌جا ثبت كرده است:",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "درصورتي كه مي‌خواهيد در اين پايگاه ثبت‌نام كنيد، بايد از اين پيوند براي اولين ورود استفاده نماييد:",
"Enjoy the site!" => "از اين پايگاه لذت ببريد!",
"Your Tiki information registration" => "اطلاعات ثبت‌نام تيكي شما",
"You will receive an email with information to login for the first time into this site" => "شما يك پست الترونيكي با اطلاعات كافي براي اولين ورود به اين پايگاه دريافت خواهيد كرد",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Your account request has been stored and will be activated by the admin as soon as possible.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "الصاق مقاله‌ي جديد: {\$mail_title} به‌وسيله‌ي {\$mail_user} در {\$mail_date|tiki_short_datetime}",
"View the article at:" => "مقاله را در اين‌جا مشاهده كنيد:",
"If you don't want to receive these notifications follow this link:" => "درصورتي كه نمي‌خواهيد اين اطلاعيه‌ها را دريافت كنيد، اين پيوند را دنبال نماييد:",
"New article post at %s" => "الصاق مقاله‌ي جديد در %s",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "الصاق جديد در بلاگ: {\$mail_title}, \"{\$mail_post_title}\", به‌وسيله‌ي {\$mail_user} در {\$mail_date|tiki_short_datetime}",
"View the blog at:" => "بلاگ را در اين‌جا مشاهده كنيد:",
"New blog post at %s" => "الصاق جديد بلاگ در %s",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "نقشه‌ي {\$mail_page} به‌وسيله‌ي {\$mail_user} در {\$mail_date|tiki_short_datetime} تغيير كرد",
"You can view the updated map following this link:" => "با دنبال كردن اين پيوند، مي‌توانيد نقشه‌ي به‌روز رساني شده را مشاهده كنيد:",
"You can edit the map following this link:" => "با دنبال كردن اين پيوند، مي‌توانيد نقشه را ويرايش كنيد:",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "صفحه‌ي {\$mail_page} به‌وسيله‌ي  {\$mail_user} در {\$mail_date|tiki_short_datetime} ايجاد شد",
"Comment:" => "ايراد نظر:",
"You can view the page by following this link:" => "مي‌توانيد با دنبال كردن اين پيوند، صفحه را مشاهده كنيد:",
"You can view a diff back to the previous version by following this link:" => "مي‌توانيد اختلاف با نسخه‌ي قبل را با دنبال كردن اين پيوند مشاهده كنيد:",
"The new page content follows below." => "محتواي جديد صفحه در ادامه است.",
"Wiki page %s changed" => "صفحه‌ي %s ويكي تغيير كرده است",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "نظر {\$mail_date|tiki_short_datetime} به صفحه‌ي {\$mail_page} توسط {\$mail_user} ايراد شد",
"Thank you for you registration. You may log in now." => "از ثبت‌نام شما سپاس‌گزاريم. هم‌اكنون شما مي‌توانيم وارد سامانه شويد.",
"The page {\$mail_page} was changed by {\$mail_user} at\n{\$mail_date|tiki_short_datetime}" => "صفحه‌ي {\$mail_page} به‌وسيله‌ي{\$mail_user}  در\n{\$mail_date|tiki_short_datetime} تغيير كرد",
"You can view the page by following this link:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}" => "با دنبال كردن اين پيوند، مي‌توانيد اين صفحه را مشاهده كنيد:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}",
"You can edit the page by following this link:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}" => "با دنبال كردن اين پيوند مي‌توانيد اين صفحه را ويرايش كنيد::\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}",
"You can view a diff back to the previous version by following\nthis link:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}" => "با دنبال كردن اين پيوند مي‌توانيد تفاوت اين نسخه با نسخه‌ي قبلي را مشاهده كنيد \nاين صفحه:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}",
"click on the map to zoom or pan, do not drag" => "براي بزرگنمايي يا حركت در نقشه، فقط كليك كنيد، نكشيد",
"Scale" => "مقياس",
"Zoom out x4" => "بزرگنمايي 4برابر",
"Zoom out x3" => "بزرگنمايي 3برابر",
"Zoom out x2" => "بزرگنمايي 2برابر",
"Query" => "جستار",
"Pan" => "حركت طولي-عرضي",
"Zoom in x2" => "بزرگنمايي 2برابر",
"Zoom in x3" => "بزرگنمايي 3برابر",
"Zoom in x4" => "بزرگنمايي 4برابر",
"Redraw" => "دوباره بكش",
"select zoom/pan/query and image size" => "اندازه‌ي تصوير و بزرگنمايي/حركت/جستار را انتخاب كنيد",
"Go" => "بگرد",
"View the Map Only" => "تنها نقشه را نمايش بده",
"Reset Map" => "نقشه را بازنشاني كن",
"Click on the map or click redraw" => "روي نقشه يا دكمه‌ي 'دوباره بكش' كليك كنيد",
"Help" => "كمك",
"Comments" => "نظرات",
"Overview" => "نمايش",
"Legend" => "علائم اختصاري",
"Layer Manager" => "مدير لايه‌ها",
"Layer" => "لايه",
"On" => "در",
"Label" => "برچسب",
"Download" => "دريافت",
"Download Layer" => "دريافت لايه",
"you have requested to download the layer:" => "شما درخواست دريافت اين لايه را داده‌ايد:",
"from\nthe mapfile:" => "از \nthe پرونده‌ي نقشه‌ي:",
"Here are the files to download, do not forget to rename them:" => "پرونده‌ها براي دريافت آماده‌اند، فراموش نكنيد كه نام آن‌ها را تغيير دهيد.",
"Mapfiles" => "پرونده‌هاي نقشه",
"Mapfile" => "پرونده‌ي نقشه",
"Available mapfiles" => "پرونده‌هاي نقشه‌ي موجود",
"Actions" => "اقدامات",
"monitor this map" => "اين نقشه را ديده‌باني كن",
"stop monitoring this map" => "ديده‌باني اين نقشه را متوقف كن",
"No records found" => "هيچ ركوردي يافت نشد.",
"Create a new mapfile" => "ساخت يك پرونده‌ي نقشه‌ي جديد",
"create" => "ايحاد كن",
"Mapfile listing" => "فهرست پرونده‌هاي نقشه‌ها",
"Reload" => "باركردن مجدد",
"History" => "تاريخچه",
"save" => "ذخيره كن",
"You can view this map in your browser using" => "با استفاده از اين مي‌توانيد اين نقشه را در مرورگر خود مشاهده كنيد",
"Mapfile History" => "تاريخچه‌ي پرونده‌ي نقشه",
"of" => "از",
"DATE-of" => "ام",
"Version" => "نسخه",
"compare" => "مقايسه كن",
"Comparing version {\$old.version} with version {\$new.version}" => "مقايسه‌ي نسخه‌ي {\$old.version} با نسخه‌ي {\$new.version}",
"Version:" => "نسخه:",
"view" => "مشاهده اطلاعات",
"current" => "جاري",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-خطوط: {\$oldd}به +خطوط: {\$newd} تغيير كرد",
"Legend:" => "علائم:",
"v=view" => "v=مشاهده‌ي اطلاعات",
"c=compare" => "c=مقايسه",
"d=diff" => "d=تفاوت‌ها",
"Side-by-side diff" => "اختلافات پهلو به پهلو",
"Full side-by-side diff" => "اختلافات پهلو به پهلوي كامل",
"Unified diff" => "اختلافات يك‌جهته",
"Side-by-side view" => "مشاهده‌ي پهلو به پهلو",
"User" => "كاربر",
"Ip" => "آدرس اينترنتي(IP)",
"Action" => "عمل",
"diff" => "تغييرات",
"older version" => "نسخ قبلي",
"Directories" => "پوشه‌ها",
"back to" => "برگشت به",
"Files" => "پرونده‌ها",
"Upload From Disk:" => "بارگذاري از دستگاه:",
"Upload Files" => "بارگذاري پرونده",
"Bytes maximum" => "بيشينه",
"Create Directory:" => "ايجاد پوشه:",
"Create" => "بساز",
"index file (.shp):" => "پرونده‌ي ايندكس(.shp):",
"files to index (regexp):" => "پرونده‌ها براي ايندكس‌گذاري(regexp):",
"Broadcast message" => "پيغام را براي همه ارسال كن",
"Message Broadcast" => "ارسال همگاني پيغام",
"edit template" => "ويرايش الگو",
"Group" => "نام گروه",
"All users" => "تمام كاربران",
"Lowest" => "كم‌ترين ارزش",
"Low" => "كم",
"Normal" => "عادي",
"High" => "زياد",
"Very High" => "خيلي زياد",
"send" => "بفرست",
"Compose message" => "ايجاد پيغام",
"Compose Message" => "ايجاد پيغام",
"To" => "به",
"CC" => "رونشت",
"BCC" => "رونوشت تاريك",
"Edit template" => "ويرايش الگو",
"Unread" => "نخوانده",
"Flagged" => "علامت زده‌شده",
"Unflagged" => "بدون علامت",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"Containing" => "شامل",
"filter" => "فيلتر",
"Mark as unread" => "به عنوان خوانده‌نشده",
"Mark as read" => "به عنوان خوانده‌شده",
"Mark as unflagged" => "به عنوان بدون علامت",
"Mark as flagged" => "به عنوان علامت‌دار",
"mark" => "علامت بزن",
"subject" => "موضوع",
"date" => "تاريخ",
"No messages to display" => "هيچ پيغامي براي نمايش وجود ندارد.",
"Mailbox" => "صندوق پستي",
"Compose" => "ايجاد پيغام",
"Broadcast" => "ارسال همگاني",
"Read message" => "خواندن پيغام",
"Prev" => "قلي",
"Next" => "بعدي",
"Return to mailbox" => "بازگشت به صندوق پستي",
"replyall" => "پاسخ به همه",
"Unflag" => "بدون علامت",
"Flag this message" => "اين پيغام را علامت بزن",
"Cc" => "رونشت",
"'name' parameter for tikimodule missed" => "پارامتر 'نام'(name) براي ماژول‌هاي تيكي مفقود شده است.",
"Move module up" => "ماژول را بالا ببر",
"up" => "انتقال به بالا",
"Move module down" => "ماژول را پايين ببر",
"down" => "انتقال به پايين",
"Move module to opposite side" => "ماژول را به طرف مقابل ببر",
"opp side" => "طرف مقابل",
"Unassign this module" => "اين ماژول را از انتصاي در بياور",
"Are you sure you want to unassign this module?" => "آيا از خروج انتصاب را تاييد مي‌كنيد؟",
"remove" => "حذفش كن",
"Admin Menu" => "مديريت منو",
"Live support" => "پشتيباني زنده",
"Banning" => "تحريم كردن",
"Users" => "كاربران",
"Groups" => "گروه‌هاي كاربري",
"Cache" => "نهان‌ها(Cache)",
"Modules" => "ماژول‌ها",
"Links" => "پيوندها",
"Hotwords" => "واژگان آتشين",
"RSS modules" => "ماژول‌هاي RSS",
"Menus" => "فهرست‌هاي انتخاب",
"Polls" => "راي‌گيري‌ها",
"Backups" => "پشتيبان‌گيري",
"Mail notifications" => "آگاه‌ساز‌هاي پستي",
"Search stats" => "آمار جستجو‌ها",
"QuickTags" => "تگ‌هاي سريع",
"Chat" => "گپ‌زني(chat)",
"Categories" => "طبقات",
"Banners" => "درفش‌ها",
"Edit templates" => "ويرايش الگوها",
"Admin drawings" => "مديريت Drawings",
"Dynamic content" => "محتوي پويا",
"Cookies" => "كوكي‌ها",
"Mail-in" => "كنترل با پست الكترونيكي",
"Content templates" => "الگوهاي محتوا",
"HTML pages" => "صفحات HTML",
"Shoutbox" => "فريادگاه",
"Shoutbox Words" => "كلمات فريادگاه",
"Referer Stats" => "آمار مراجعات",
"Import PHPWiki Dump" => "وارد كردن  PHPWiki Dump",
"phpinfo" => "اطلاعات php",
"Admin dsn" => "مديريت DSNها",
"External wikis" => "ويكي‌هاي خارجي",
"System Admin" => "مديريت سامانه",
"Security Admin" => "مديريت امنيت",
"Syntax highlighting" => "برجسته‌سازي نحو",
"Menu" => "منو",
"Contact us" => "تماس با ما",
"Stats" => "آمار",
"Games" => "بازي‌ها",
"Calendar" => "تقويم",
"MyMenu" => "فهرست‌هاي انتخاب من",
"MyTiki" => "تيكي من",
"MyTiki home" => "مبدا تيكي من",
"Preferences" => "تنظيمات",
"Tasks" => "وظايف",
"Bookmarks" => "صفحه‌ياب‌ها",
"Newsreader" => "اخبارگو",
"Webmail" => "پست تحت وب",
"Notepad" => "دفترچه يادداشت",
"My files" => "پرونده‌هاي من",
"User menu" => "منوي كاربر",
"Mini calendar" => "تقويم جيبي",
"My watches" => "ديده‌بان‌هاي من",
"WfMenu" => "منوي WF",
"Workflow" => "گردش كار",
"Admin processes" => "مديريت فرايندها",
"Monitor processes" => "ديده‌باني فرايندها",
"Monitor activities" => "ديده‌باني فعاليت‌ها",
"Monitor instances" => "ديده‌باني نمونه‌ها",
"User processes" => "فرايندهاي كاربر",
"User activities" => "فعاليت‌هاي كاربر",
"User instances" => "نمونه‌هاي كاربر",
"FriendsMenu" => "منو رفيقان",
"Community" => "اجتماع",
"User list" => "فهرست كاربران",
"Friendship Network" => "شبكه‌ي رفاقت",
"WikiMenu" => "منو ويكي",
"Last changes" => "آخرين تغييرات",
"Dump" => "تخليه(dump)",
"Rankings" => "رتبه‌بندي‌ها",
"List pages" => "فهرست صفحات",
"Orphan pages" => "صفحات يتيم",
"Sandbox" => "دست‌گرمي",
"Print" => "چاپ",
"Send pages" => "ارسال صفحات",
"Received pages" => "صفحات دريافت شده",
"Structures" => "ساختارها",
"Projects Menu" => "منوي پروژه‌ها",
"Projects" => "پروژه‌ها",
"Register New Project" => "ثبت پروژه‌ي جديد",
"HomeworkMenu" => "منوي مشق شب",
"Homework" => "مشق شب",
"Assignments" => "انتصاب‌ها",
"Last Changes" => "آخرين تغييرات",
"GalMenu" => "منوي سرسراها",
"Image Galleries" => "سرسراهاي تصاوير",
"Galleries" => "سرسراها",
"Upload image" => "بارگذاري تصوير",
"System gallery" => "سرسراي سامانه",
"Articles home" => "مبدا مقالات",
"Submit article" => "ارائه‌ي مقاله",
"View submissions" => "مشاهده‌ي ارائه‌ها",
"Edit article" => "ويرايش مقاله",
"Send articles" => "مقالات را بفرست",
"Received articles" => "مقالات دريافت شده",
"Admin topics" => "مديريت عناوين",
"Admin types" => "مديريت انواع",
"List blogs" => "فهرست بلاگ‌ها‌",
"Create/Edit blog" => "ساخت/ويرايش بلاگ‌",
"Post" => "الصاق",
"Admin posts" => "الصاق‌هاي سرپرست",
"ForMenu" => "منوي انجمن",
"Forums" => "انجمن‌ها",
"List forums" => "فهرست انجمن‌ها",
"Admin forums" => "مديريت انجمن‌ها",
"DirMenu" => "منوي پوشه",
"Submit a new link" => "ارائه‌ي يك پيوند جديد",
"Browse directory" => "مرور پوشه",
"Admin directory" => "مديريت پوشه",
"FileGalMenu" => "منوي سرسراي پرونده",
"File Galleries" => "سرسراهاي پرونده‌ها",
"List galleries" => "فهرست سرسراها",
"FAQs" => "سئوالات متداول",
"List FAQs" => "فهرست سئوالات متداول",
"Admin FAQs" => "مديريت سئوالات متداول",
"Maps" => "نقشه‌ها",
"Layer management" => "مديريت لايه‌ها",
"QuizMenu" => "منوي آزمون",
"Quizzes" => "آزمون‌ها",
"List quizzes" => "فهرست آزمون‌ها",
"Quiz stats" => "‌وضعيت آزمون‌ها",
"Admin quiz" => "مديريت آزمون‌ها",
"List Courses" => "فهرست دوه‌ها",
"ShtMenu" => "منوي كوتا",
"TrkMenu" => "منوي tracker",
"Trackers" => "Trackerها",
"List trackers" => "فهرست trackerها",
"Admin trackers" => "مديريت trackerها",
"SrvMenu" => "منوي نظرسنجي",
"Surveys" => "نظرسنجي‌ها",
"List surveys" => "فهرست نظرسنجي‌ها",
"Admin surveys" => "مديريت نظرسنجي‌ها",
"Newsletters" => "خبرنامه‌ها",
"Send newsletters" => "ارسال خيرنامه‌ها",
"Admin newsletters" => "مديريت خبرنامه‌ها",
"Events" => "رويدادها",
"Send events" => "رويدادهاي را بفرست",
"Admin events" => "مديريت رويدادها",
"EphMenu" => "منوي سالمانه",
"Ephemerides" => "سالنامه",
"Ephemerides Admin" => "مديريت سالنامه",
"ChartMenu" => "فهرست نمودار",
"Charts" => "نمودارها",
"Charts Admin" => "مديريت نمودارها",
"AdmMenu" => "منو سرپرست",
"Admin" => "سرپرستي",
"Admin home" => "مديريت",
"Debugger Console" => "كنسول اشكال‌زدايي",
"Theme control" => "تنظيم قيافه(Theme)",
"Drawings" => "نقاشي‌ها",
"Edit languages" => "ويرايش زبان‌ها",
"Integrator" => "كامل كننده",
"DSN" => "DSNها",
"Mods Admin" => "مديريت ماژول‌ها",
"UsrMenu" => "منو كاربر",
"Click here to manage your personal menu" => "براي مديريت منو شخصي خود، اين‌جا را كليك كنيد.",
"User Menu" => "منو براي هر كاربر",
"Tikiwiki Assistant" => "دستيار تيكي‌ويكي",
"Thank you for installing Tikiwiki" => "از اينكه تيكي‌ويكي را نصب كرده‌ايد متشكريم",
"Click the :: options in the Menu for more options." => "براي اختيارهاي بيشتر روي اختيار :: در منو كليك كنيد",
"Please, also see" => "لطفا نگاهي هم بياندازيد به",
"for more setup details." => "براي جزئيات بيشتر نصب و برپاسازي.",
"You can remove this module in" => "اين ماژول را مي‌توانيد در اين‌جا حذف كنيد",
"Admin->Modules" => "مديريت -> ماژول‌ها",
"Recently visited pages" => "صفحاتي كه به تازگي روئيت شده‌اند",
"January" => "ژانويه",
"February" => "فوريه",
"March" => "مارس",
"April" => "آوريل",
"May" => "مي",
"June" => "جون",
"July" => "جولاي",
"August" => "اگوست",
"September" => "سپتامبر",
"October" => "اكتبر",
"November" => "نوامبر",
"December" => "دسامبر",
"Monday" => "دو شنبه",
"Tuesday" => "سه شنبه",
"Wednesday" => "چهار شنبه",
"Thursday" => "پنج شنبه",
"Friday" => "جمعه",
"Saturday" => "شنبه",
"Sunday" => "يك شنبه",
"Filter" => "فيلتر",
"Today" => "امروز",
"none" => "هيچكدام",
"Received objects" => "اشياء دريافت شده",
"Pages:" => "صفحه:",
"Last `\$module_rows` Sites" => "آخرين پايگاه‌هاي `\$module_rows`",
"Last Sites" => "آخرين پايگاه‌ها",
"Directory Stats" => "آمار پوشه",
"Sites" => "پايگاه‌ها",
"Sites to validate" => "پايگاهي كه بايد تعيين اعتبار شود",
"Searches" => "جستجوها",
"Visited links" => "پيوندهاي مشاهده شده",
"Top \$module_rows Sites" => "\$module_rows پايگاه برتر",
"Top Sites" => "پايگاه‌هاي برتر",
"Featured links" => "پيوندهاي خاص",
"Top `\$module_rows` topics" => "موضوعات `\$module_rows` فوقاني",
"Top topics" => "برترين عناوين",
"Last `\$module_rows` forum posts" => "آخرين `\$module_rows` الصاق انجمن",
"Last forum posts" => "آخرين الصاق‌هاي انجمن",
"Last `\$module_rows` forum topics" => "آخرين `\$module_rows` موضوعات انجمن",
"Last forum topics" => "آخرين موضوعات انجمن",
"Most commented forums" => "انجمن‌هايي با بيشترين نظرات",
"Most read topics" => "پربيننده‌ترين الصاق‌ها",
"Most visited forums" => "پربيننده‌ترين انجمن‌ها",
"Google Search" => "جستجوي گوگل",
"Last `\$module_rows` actions" => "آخرين `\$module_rows` عمل",
"Last actions" => "آخرين اعمال",
"Last `\$module_rows` articles" => "آخرين `\$module_rows` مقاله",
"Last articles" => "آخرين مقالات",
"Last `\$module_rows` blog posts" => "آخرين `\$module_rows` الصاق بلاگ",
"Last blog posts" => "آخرين الصاق‌هاي بلاگ",
"Last" => "آخرين",
"Last `\$module_rows` Created blogs" => "آخرين `\$module_rows` بلاگ‌ها ساخته شده",
"Last Created blogs" => "آخرين بلاگ ساخته شده‌",
"Last `\$module_rows` Created FAQs" => "آخرين `\$module_rows` FAQي ايجاد شده",
"Last Created FAQs" => "آخرين FAQهاي ايجاد شده",
"Last `\$module_rows` Created Quizzes" => "آخرين `\$module_rows` آزمون ايجاد شده",
"Last Created Quizzes" => "آخرين آزمون‌هاي ايجاد شده",
"Last `\$module_rows` modified file galleries" => "آخرين `\$module_rows` سرسراي پرونده‌ي تغيير يافته",
"Last modified file galleries" => "آخرين سرسراهاي پرونده‌ي تغيير يافته",
"Last `\$module_rows` Files" => "`\$module_rows` پرونده‌ي آخر",
"Last Files" => "آخرين پرونده‌ها",
"Last `\$module_rows` galleries" => "`\$module_rows` سرسراي آخر",
"Last galleries" => "آخرين سرسراها",
"Last `\$module_rows` Images" => "`\$module_rows` تصوير آخر",
"Last Images" => "آخرين تصاوير",
"Last `\$module_rows` modified events" => "آخرين `\$module_rows` رويداد تغيير كرده",
"Last modifed events" => "آخرين رويدادهاي تغيير كرده",
"Last `\$module_rows` changes" => "`\$module_rows` تغيير آخر",
"Last `\$module_rows` Modified Items" => "آخرين `\$module_rows` اقلام تغيير كرده",
"Last Modified Items" => "اقلام تغيير كرده",
"Last `\$module_rows` Modified blogs" => "آخرين `\$module_rows` بلاگ تغيير كرده‌",
"Last Modified blogs" => "آخرين بلاگ‌هاي تغيير كرده‌",
"Last `\$module_rows` submissions" => "`\$module_rows` ارائه‌ي آخر",
"Last submissions" => "آخرين ارائه‌ها",
"Last `\$module_rows` Items" => "`\$module_rows` فقره‌ي آخر",
"Last Items" => "آخرين اقلام",
"Last `\$module_rows` visitors" => "`\$module_rows` بازديد كننده‌ي آخر",
"Last visitors" => "آخرين بازديد كنندگان",
"Open operator console" => "ميركار پشتيبان را باز كن",
"Online users" => "كاربران روي خط",
"We have" => "داريم",
"online users" => "كاربران روي خط",
"logged as" => "وارد شده با عنوان",
"Logout" => "خروج",
"user" => "كاربر",
"Login through CAS" => "ورود به سامانه اطلاعات طريق CAS",
"Login as admin" => "ورورد با عنوان 'سرپرست'",
"pass" => "كلمه عبور",
"login" => "ورود",
"Remember me" => "مرا به خاطر داشته باش",
"Click here to register" => "براي ثبت‌نام اين‌جا را كليك كنيد‍",
"register" => "ثبت‌نام",
"Click here if you've forgotten your password" => "اگر كلمه‌ي عبور خود را فراموش كرده‌ايد اين‌جا را كليك كنيد",
"I forgot my pass" => "من كلمه‌ي عبورم را فراموش كرده‌ام",
"Click here to login using the default security protocol" => "براي ورود با استفاده از پروتكل امنيتي پيش‌فرض، اين‌جا را كليك كنيد",
"standard" => "معمولي",
"Click here to login using a secure protocol" => "براي ورود به‌كمك يك پروتوكل امن، اين‌جا را كليك كنيد",
"secure" => "امن",
"stay in ssl mode" => "در باب ssl بمان",
"Tiki Logo" => "علامت تيكي",
"You have" => "شما",
"new messages" => "پيغام‌هاي جديد داريد",
"new message" => "پيغام جديد داريد",
"You have 0 new messages" => "شما هيچ پيغام جديدي نداريد",
"Waiting Submissions" => "درخواست‌هاي در صف انتظار",
"submissions waiting to be examined" => "درخواست‌هايي كه منتظر بررسي هستند",
"Old articles" => "مقالات قديمي",
"Random Pages" => "صفحات تصادفي",
"Register as a new user" => "ثبت‌نام به عنوان كاربر جديد",
"Your email could not be validated; make sure you email is correct and click register below." => "آدرس پست الكترونيكي شما نمي‌تواند تاييد اعتبار شود؛ اطلاعات صحت آدرس خود اطمينان حاصل كنيد و روي 'ثبت‌نام' در پايين كليك كنيد",
"Your registration code:" => "كد ثبت‌نام شما:",
"Random Image" => "تصوير تصادفي",
"Username" => "نام كاربري",
"Passcode to register (not your user password)" => "كدعبور براي ثبت‌نام(اين كلمه‌ي عبور شما نيست)",
"Registration code" => "كد ثبت‌نام",
"Password" => "كلمه‌ي عبور",
"Repeat password" => "تكرار ‌كلمه‌ي عبور",
"Email" => "پست الكترونيكي",
"Generate a password" => "يك كلمه‌ي عبور توليد كن ",
"Search" => "جستجو",
"in:" => "در:",
"Entire Site" => "تمام پايگاه",
"Wiki Pages" => "صفحات ويكي",
"Image Gals" => "سالن‌هاي تصاوير",
"Images" => "تصاوير",
"Blog Posts" => "الصاقات بلاگ",
"go" => "برو",
"Search Wiki PageName" => "جستجو در نام صفحات ويكي",
"Read More" => "اطلاعات بيشتر",
"Since your last visit on" => "از آخرين بازديد شما در",
"Language: " => "زبان: ",
"Language" => "زبان",
"Most Active blogs" => "فعال‌ترين بلاگ‌ها",
"Top `\$module_rows` articles" => "`\$module_rows` مقاله‌ي برتر",
"Top articles" => "برترين مقالات",
"Top `\$module_rows` File Galleries" => "`\$module_rows` سرسراي پرونده‌ي برتر",
"Top File Galleries" => "برترين سرسراهاي پرونده",
"Top `\$module_rows` files" => "`\$module_rows` پرونده‌ي برتر",
"Top files" => "پرونده‌هاي برتر",
"Top `\$module_rows` Forum Posters" => "`\$module_rows` آگهي برتر انجمن",
"Top Forum Posters" => "آگهي‌هاي برتر انجمن‌ها",
"Top `\$module_rows` games" => "`\$module_rows` بازي برتر",
"Top games" => "بازي‌هاي برتر",
"Top `\$module_rows` galleries" => "Top `\$module_rows` Galleries",
"Top galleries" => "سرسراهاي برتر",
"Top `\$module_rows` Images" => "`\$module_rows` تصوير برتر",
"Top Images" => "تصاوير برتر",
"Top `\$module_rows` Pages" => "`\$module_rows` صفحات برتر",
"Top Pages" => "برترين صفحات",
"Top `\$module_rows` Quizzes" => "`\$module_rows` آزمون برتر",
"Top Quizzes" => "برترين آزمون‌ها",
"Most `\$module_rows` visited blogs" => "بيشترين `\$module_rows` بلاگ‌هاي ديده‌شده",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` FAQ پربيننده",
"Top Visited FAQs" => "پربيننده‌ترين FAQها",
"My blogs" => "بلاگ‌هاي من",
"cache" => "زمان نگهداري در نهانگان(Cache)",
"My galleries" => "سرسراهاي من",
"My Pages" => "صفحات من",
"User tasks" => "وظايف كاربر",
"done" => "انجام شد",
"del" => "حذف",
"Public tasks" => "وظايف عمومي",
"select" => "انتخاب",
"User informations" => "اطلاعات كاربر",
"Group informations" => "اطلاعات گروه‌ها",
"Top users" => "برترين كاربران",
 "Whats related" => "What's related",
"online user" => "كاربر روي‌خط",
"Send a message to" => "ارسال پيغام براي",
"Last `\$module_rows` wiki comments" => "`\$module_rows` نظر آخرين ويكي",
"Last wiki comments" => "آخرين نظرات ويكي",
"vote" => "راي دادن",
"Sent editions" => "نسخ ارسال شده",
"find" => "بياب",
"newsletter" => "خبرنامه",
"users" => "كاربران",
"sent" => "ارسال شده در",
"use" => "استفاده از ساختار",
"Structures:" => "ساختارها:",
"show structures" => "ساختارها را نمايش بده",
"hide structures" => "ساختارها را پنهان كن",
"Manage structures" => "مديريت ساختارها",
"Create this page" => "اين صفحه را ايجاد كن",
"Are you sure you want to remove this module?" => "آيا مطمئن هستيد مي‌خواهيد اين ماژول را حذف كنيد؟",
"Powered by" => "فراهم شده به‌وسيله‌ي",
"Image galleries" => "سرسراهاي تصاوير",
"File galleries" => "سرسراهاي پرونده‌ها",
"Execution time" => "زمان اجرا",
"secs" => "ثانيه",
"Memory usage" => "ميزان استفاده از حافظه",
"database queries used" => "درخواست ارسالي به بانك اطلاعاتي",
"Server load" => "بار سرور",
"locked by" => "قفل شده به‌وسيله‌ي",
"refresh" => "بازيابي كن",
"print" => "چاپش كن",
"create pdf" => "ساخت PDF",
"pdf" => "PDF",
"Save to notepad" => "ذخيره در دفترچه‌ي يادداشت",
"monitor this page" => "اين صفحه را ديده‌باني كن",
"stop monitoring this page" => "ديده‌باني اين صفحه را متوقف كن",
"backlinks" => "پيوند به‌عقب‌ها",
"Previous page" => "صفحه‌ي قبلي",
"Parent page" => "صفحه‌ي مادر",
"Next page" => "صفحه‌ي بعدي",
"First page" => "اولين صفحه",
"page" => "صفحه",
"Last page" => "آخرين صفحه",
"Created by" => "ايجاد شده توسط",
"last modification" => "آخرين تغييرات",
"To edit the copyright notices" => "براي ويرايش اخطاريه‌ي حق انحصاري چاپ",
"click here" => "اين‌جا را كليك كنيد",
"The content on this page is licensed under the terms of the" => "محتواي اين صفحه تحت اين شرايط قرار دارد",
"The original document is available at" => "مستند اصلي در اين‌جا قابل دسترسي است",
"rename" => "تغيير نام",
"unlock" => "بازكردن قفل",
"lock" => "قفلش كن",
"perms" => "حقوق دسترسي‌ها",
"history" => "تاريخچه",
"similar" => "مشابهات",
"undo" => "برگشت عمل",
"slides" => "اسلايدها",
"export" => "صدور",
"discuss" => "بحث",
"add comment" => "افزودن نظريه",
"1 comment" => "1 نظر",
"comments" => "نظرات",
"attach file" => "ضميمه‌كردن پرونده",
"1 file attached" => "1 پرونده ضميمه شد",
"{\$atts_cnt} files attached" => "{\$atts_cnt} پرونده ضميمه شد",
"translation" => "ترجمه",
"3d browser" => "مرورگر 3بعدي",
"Page generated in" => "صفحه توليد شده در",
"The newsletter was sent to {\$sent} email addresses" => "خبرنامه براي پست‌هاي الكترونيكي {\$sent} ارسال شد.",
"This newsletter will be sent to {\$subscribers} email addresses." => "اين خبرنامه براي پست‌هاي الكترونيكي {\$subscribers} ارسال خواهد شد.",
"Prepare a newsletter to be sent" => "آماده‌سازي يك خبرنامه براي ارسال",
"Newsletter" =>  "خبرنامه",
"Apply template" => "الگوي اعمالي",
"Data" => "داده‌ها",
"Send Newsletters" => "ارسال خبرنامه‌ها",
"User List" => "فهرست كاربران",
"attachments" => "ضمايم",
"Click" => "كليك",
"User files" => "پرونده‌هاي كاربر",
"Favorites" => "علاقه‌مندي‌ها",
"Watches" => "ديده‌بان‌ها",
"home" => "مبدا",
"chat" => "گپ‌زني(chat)",
"contact us" => "تماس با ما",
"stats" => "آمار",
"categories" => "طبقه",
"calendar" => "تقويم",
"Member list" => "فهرست اعضا",
"last changes" => "آخرين تغييرات",
"dump" => " تخليه(dump)",
"rankings" => "رتبه‌بندي‌ها",
"list pages" => "فهرست صفحات",
"orphan pages" => "صفحات يتيم",
"sandbox" => "دست‌گرمي",
"received pages" => "صفحات دريافت شده",
"structures" => "ساختارها",
"Articles Home" => "مبدا مقالات",
"Create/Edit Blog" => "ساخت/ويرايش بلاگ‌",
"Browse Directory" => "مرور پوشه(شايدم پوشه‌ي مرور!)",
"List Quizzes" => "فهرست آزمون‌ها",
"List Trackers" => "فهرست trackerها",
"List Surveys" => "فهرست نظرسنجي‌ها",
"Prefs" => "تنظيمات",
"MyFiles" => "پرونده‌هاي من",
"back to homepage" => "بازگشت به صفحه‌ي مبدا",
"Please" => "لطفا",
"log in" => "به برنامه وارد شويد",
"to access full functionalities" => "تا به تمام خصايص دسترسي پيدا كنيد",
"This page is being edited by" => "اين صفحه در حال ويرايش شدن است، توسط:",
"Proceed at your own peril" => "با مسئوليت خودتان ادامه دهيد",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "'دست‌گرمي' صفحه‌اي است كه شما مي‌توانيد مهارت ويرايش خود را تمرين كنيد. از خصيصه‌ي 'پيش‌نمايش' براي روئيت شماي صفحه استفاده كنيد، هيچ نسخه‌اي براي اين صفحه نگهداري نمي‌شود.",
"Description" => "شرح",
"My Footnotes" => "تبصره‌هاي من",
"Copyright" => "حق انحصاري چاپ",
"Year:" => "سال:",
"Authors:" => "مولفين:",
"Allow HTML" => "HTML مجاز است ",
"Spellcheck" => "بررسي املايي",
"Import page" => "وارد كردن صفحه",
"export all versions" => "تمام نسخ را صادر كن",
"Upload picture" => "بارگذاري تصوير",
"no cache" => "بدون cache",
"minute" => "دقيقه",
"hour" => "ساعت",
"Anti-Bot verification code" => "كد بازبيني ضد ماشيني(Anti-bot)",
"Enter the code you see above" => "كدي كه در بالا مي‌بينيد را وارد كنيد",
"License" => "پروانه",
"Important" => "مهم",
"Minor" => "كوچك",
"cancel edit" => "تغييرات را لغو كن",
"dls" => "تعداد دريافت",
"No attachments for this page" => "اين صفحه، ضميمه‌اي ندارد",
"This is" => "اين يك",
"by the" => "توسط",
"My Tiki" => "تيكي من",
"User Pages" => "صفخات كاربران",
"List pages where I am a creator" => "فهرست صفحاتي را كه من ايجاد كرده‌ام، نمايش بده",
"by creator" => "به‌وسيله‌ي ايجاد كننده",
"List pages where I am a modificator" => "فهرست صفحاتي را كه من تغيير داده‌ام، نمايش بده",
"by modificator" => "به‌وسيله‌ي تغيير دهنده",
"User Galleries" => "سرسراهاي كاربر",
"Assigned items" => "اقلام تخصيص داده شده",
"at tracker" => "در tracker",
"Unread Messages" => "پيغام‌هاي خوانده نشده",
"User Blogs" => "بلاگ‌هاي كاربر",
"Skip to navigation" => "پرش به ناوبري",
"left/right" => "چپ/راست",
"Unassign module" => "ماژول تخصيص داده نشده",
"debugger console" => "ميزكار اشكال زدايي",
"Mini Calendar" => "تقويم جيبي",
"Edit mapfiles" => "ويرايش پرونده‌هاي نقشه",
"on:" => "در:",
"reads" => "تعداد دفعات مشاهده",
"Article image" => "تصوير مقالات",
"Topic image" => "تصوير سرفصل",
"Refresh" => "بازيابي كن",
"cached" => "cache شده",
"Child" => "فرزند",
"Add Page" => "افزودن صفحه",
"Translate in" => "ترجمه شده به",
"babelfish it" => "با babelfish ترجمه‌اش كن",
"User Bookmarks" => "صفحه‌ياب براي هر كاربر",
"Welcome to" => "خير مقدم",
"Enlarge area height" => "ارتفاع محدوده را اضافه كن",
"Reduce area height" => "ارتفاع محدوده را كاهش بده",
"Features" => "خصيصه‌ها",
"General" => "عمومي",
"Jukebox" => "Jukebox",
"RSS" => "RSS",
"Meta Tags" => "فرا برچسب‌ها(meta tags)",
"Site Identity" => "عينيت پايگاه",
"Site Calendar" => "تقويم پايگاه",
"Tip" => "نكته",
"to add/remove blogs, go to \"Create/Edit blog\" under \"Blogs\" on the application menu, or" => "براي اضافه/حذف بلاگ‌ها، در فهرست استفاده به قسمت 'ساخت/ويرايش بلاگ' در بخش 'بلاگ‌ها' برويد، ويا",
"Blog settings" => "تنظيمات بلاگ",
"Home Blog (main blog)" => "بلاگ مبدا(بلاگ اصلي)",
"ok" => "قبول",
"Blog features" => "خصيصه‌هاي بلاگ",
"Blog level comments" => "دسترسي براي دادن نظر(comment) در سطح بلاگ‌",
"Post level comments" => "دسترسي براي دادن نظر(comment) در سطح هر الصاق",
"Spellchecking" => "بررسي املايي",
"Not Installed" => "نصب نشده است",
"Default ordering for blog listing" => "ترتيب پيش‌فرض در فهرست بلاگ‌ها",
"Creation date (desc)" => "بر اساس تاريخ ايجاد (نزولي)",
"Last modification date (desc)" => "بر اساس آخرين تغيير (نزولي)",
"Blog title (asc)" => "عنوان بلاگ (صعودي)",
"Number of posts (desc)" => "تعداد الصاق‌ها (نزولي)",
"Visits (desc)" => "روئيت‌ها (نزولي)",
"Activity (desc)" => "فعاليت (نزولي)",
"Change preferences" => "تغيير تنظيمات",
"Blog listing configuration (when listing available blogs)" => "پيگربندي فهرست بلاگ(در بلاگ‌هاي قابل فهرست شدن)",
"Creation date" => "تاريخ ايجاد",
"Last modification time" => "زمان آخرين تغييرات",
"Disabled" => "غيرفعال",
"Plain text" => "متن ساده",
"Link to user information" => "متصل به اطلاعات كاربر",
"User avatar" => "شكلك كاربر",
"Blog comments settings" => "تنظيمات 'نظرات' بلاگ",
"Default number of comments per page" => "پيش‌فرض تعداد نظرات در هر صفحه",
"Comments default ordering" => "ترتيب پيش‌فرض نظرات",
"Points" => "امتياز",
"Users see and add events in their timezone" => "كاربران رويدادها را در ساعت محلي خود ببينند و ايجاد كننده",
"look under \"Articles\" on the application menu for links to" => "براي پيوندهايي اين‌چنين، بخش \"مقالات\" را پيوييد",
"Article/CMS settings" => "تنظيمات مقالات/سامانه‌ي مديريت محتوا",
"CMS features" => "خصيصه‌هاي سامانه‌ي مديريت محتوا(CMS)",
"Submissions" => "ارائه‌ها",
"Use templates" => "از الگوها استفاده كن",
"Maximum number of articles in home" => "بيشينه تعداد مقالات در صفحه‌ي مبدا",
"Article comments settings" => "تنظيمات مربوط 'نظرات' مقالات",
"Fields to display on page" => "موارد نمايش داده شده در صفحه‌ي ",
"Type" => "گونه:",
"Topic" => "موضوع",
"Publish Date" => "تاريخ انتشار",
"Expire Date" => "تاريخ انقضا",
"Visible" => "قابل رؤيت",
"Size" => "حجم",
"Img" => "تصوير",
"Community settings" => "تنظيمات اجتماعات",
"User identity features" => "خصيصه‌هاي عينيت كاربر",
"Show user's info on mouseover" => "هنگام اشاره‌ي موش‌واره، اطلاعات كاربر را نمايش بده",
"Name" => "نام",
"Picture" => "تصوير",
"Number of friends" => "تعداد دوستان",
"Country" => "كشور",
"E-mail" => "آدرس پست الكترونيكي",
"Last login" => "آخرين ورود",
"Friendship network" => "شبكه‌ي رفاقت",
"Allow permissions for friendship network" => "حقوق دسترسي براي شبكه‌ي رفاقت اعمال شود",
"Max friendship distance" => "حداكثر فاصله‌ي رفاقت",
"to configure your directory, find \"Admin directory\" under \"Directory\" on the application menu, or" => "براي پيكربندي پوشه‌ي خود،  \"مديريت پوشه\" را تحت  \"پوشه\" در منوي برنامه بيابيد، يا",
"Number of columns per page when listing categories" => "تعداد ستون‌ها در هر صفحه هنگام نمايش فهرست طبقه‌بندي‌ها",
"Links per page" => "پيوندها در هر صفحه",
"Validate URLs" => "URLها را تاييد اعتبار كن",
"Method to open directory links" => "روش باز كردن پيوندهاي پوشه‌ها",
"replace current window" => "در همين صفحه‌ي كنوني",
"new window" => "پنجره‌ي جديد",
"inline frame" => "قاب دروني (inline frame)",
"to add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "براي حذف/اضافه‌ي FAQ	ها، دنبال \"مديريت FAQها\" تحت \"FAQها\" در منوي برنامه بگرديد، يا",
"FAQs settings" => "تنظيمات FAQ",
"FAQ comments" => "نظرات مربوط به بخش سئوالات متداول",
"Tiki sections and features" => "خصيصه‌ها و بخش‌هاي تيكي",
"Featured Help" => "كمك خاص",
"Workflow engine" => "موتور گردش كار",
"Live Support" => "پشتيباني زنده",
"Live support system" => "سامانه‌ي پشتيباني زنده",
"Help System" => "سامانه‌ي كمك رساني",
"Show Category Path" => "آدرس طبقه را نشان بده",
"Show Babelfish Translation URLs" => "از URLهاي ترجمه‌ي Babelfish استفاده كن",
"Show Category Objects" => "اشياء طبقه را نمايش بده",
"Show Babelfish Translation Logo" => "از نماد ترجمه‌ي Babelfish استفاده كن",
"Show Module Controls" => "كنترل‌هاي ماژول‌ها را نمايش بده",
"Tiki Calendar" => "تقويم تيكي",
"Template Viewing" => "مشاهده‌ي الگوها",
"Tiki Template Viewing" => "مشاهده‌ي الگوهاي تيكي",
"PHPLayers" => "PHP Layers Menu System",
"PhpLayers Dynamic menus" => "منو پوياي لايه‌هايPHP",
"JsCalendar" => "تقويم js",
"tikiwiki.org help" => "كمك در tikiwiki.org",
"TikiTabs" => "برگه‌هاي تيكي",
"Use Tabs" => "استفاده از برگه‌ها(tabs)",
"Tiki Sheet" => "صفحات تيكي",
"Multilingual" => "چند زبانه‌اي",
"Best language" => "بهترين زبان",
"Site Logo and Identity" => "هويت و نماد پايگاه",
"Tiki Projects" => "پروژه‌هاي تيكي",
"Content Features" => "خصيصه‌هاي محتوا",
"Edit Templates" => "ويرايش الگوها",
"Hotwords in New Windows" => "واژگان آتشين در صفحات جديد",
"Edit CSS" => "ويرايش CSSها",
"Custom Home" => "مبدا قابل متناسب‌سازي",
"HTML Pages" => "صفحات HTML",
"Dynamic Content System" => "سامانه‌ي محتواي پويا",
"Allow Smileys" => "استفاده از صورتك‌ها(Smiley) مجاز است",
"AutoLinks" => " پيوندهاي خودكار (AutoLinks)",
"Administration Features" => "خصيصه‌هاي مديريتي",
"Banning System" => "سامانه‌ي تحريم‌",
"Banning system" => "سامانه‌ي تحريم",
"Debugger Console" => "ميزكار اشكال‌زدايي",
"Communications (send/receive objects)" => "ارتباطات (ارسال/دريافت اشيائ)",
"Theme Control" => "تنظيم قيافه(Theme)",
"XMLRPC API" => "رابط برنامه نويسي XMLRPC",
"Referer stats" => "آمار مراجعات",
"Contact Us" => "تماس با ما",
"Contact Us (Anonymous)" => "تماس با ما(بي‌نام)",
"User Features" => "خصيصه‌هاي كاربران",
"User Preferences Screen" => "صفحه‌ي تنظيمات براي هر كاربر",
"Users can Configure Modules" => "كاربر مي‌تواند ماژول‌ها را پيكربندي كند",
"User Watches" => "ديده‌بان‌هاي كاربر",
"User Messages" => "سامانه‌ي پيغام براي هر كاربر",
"User Tasks" => "سامانه‌ي وظايف براي هر كاربر",
"User Notepad" => "صفحه‌ي يادداشت‌برداري براي هر كاربر",
"User Files" => "پرونده براي هر كاربر",
"General Layout options" => "تنظيمات نماي عمومي",
"Left column" => "ستون سمت چپ",
"Layout per section" => "هر بخش، نماي مخصوص به خود را داشته باشد",
"Right column" => "ستون سمت راست",
"Admin layout per section" => "مديريت نماهاي هر بخش",
"Top bar" => "نوار بالا",
"Bottom bar" => "نوار پايين",
"to add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "براي حذف/اضافه كردن سرسراها، به 'سرسراهاي پرونده' در منو برنامه مراجعه كنيد، يا",
"Home Gallery (main gallery)" => "سرسراي مبدا (سرسراي اصلي)",
"Galleries features" => "خصيصه‌هاي سرسراها",
"Allow same file to be uploaded more than once" => "بارگذاري يك پرونده‌ي پيش از يك بار مجاز است",
"Use database to store files" => "از بانك اطلاعاتي براي نگهداري پرونده‌ها استفاده كن",
"Use a directory to store files" => "از يك پوشه براي نگهداري پرونده‌ها استفاده كن",
"Directory path" => "آدرس پوشه",
"Uploaded filenames must match regex" => "نام پرونده‌هاي بارگذاري شده بايد با اين اصطلاح همخواني داشته باشد",
"Uploaded filenames cannot match regex" => "نام پرونده‌هاي بارگذاري شده نبايد با اين اصطلاح همخواني داشته باشد",
"please read" => "لطفا بخوانيد",
"Gallery listing configuration" => "پيكربندي فهرست تصاوير",
"Last modified" => "آخرين تغيير",
"File galleries comments settings" => "تنظيمات 'نظرات' سرسراهاي پرونده‌ها",
"File galleries search indexing" => "ساخت راهنماي جستجوي سرسراهاي پرونده‌ها",
"Leave command blank to delete handler" => "خط فرمان را براي حذف handler، خالي بگذاريد",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => " از %1 براي جابگزيني نام پرونده‌هاي دروني استفاده كنيد (مثال: براي تبديل سند به متن با كمك دستور unix، از اين فرمان استفاده كنيد: \"strings %1\")",
"Enable auto indexing on file upload or change" => "راهنماي جسنجو(indexing) براي پرونده‌هاي بارگذاري شده يا تغيير كرده فعال باشد",
"Reindex all files for search" => "تمام پرونده‌ها را براي جستجو مجددا index گزاري كن",
"to add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "براي حذف/اضافه كردن انجمن‌ها دنبال \"مديريت انجمن\" زير \"انجمن‌ها\"در منوي برنامه بگرديد، يا",
"Forums settings" => "تنظيمات انجمن‌ها",
"Home Forum (main forum)" => "انجمن مبدا (انجمن اصلي)",
"Accept wiki syntax" => "نحو ويكي(wiki syntax) قابل قبول است",
"Forum quick jumps" => "پرش سريع(quick jump) در انجمن",
"Ordering for forums in the forum listing" => "ترتيب انجمن‌ها در فهرست انجمن‌ها",
"Creation Date (desc)" => "تاريخ ايجاد (نزولي)",
"Topics (desc)" => "عناوين (نزولي)",
"Threads (desc)" => "رگه(thread)ها (نزولي)",
"Last post (desc)" => "آخرين الصاق (نزولي)",
"Name (desc)" => "نام (نزولي)",
"Name (asc)" => "نام (صعودي)",
"Forum listing configuration" => "پيكربندي فهرست انجمن‌ها",
"Topics" => "عناوين",
"Posts per day" => "الصاق‌ها در روز",
"Last post" => "آخرين الصاق",
"to add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "براي حذف/اضافه كردن سرسراهاي تصاوير، سراغ \"سرسراهاي تصاوير\" در منوي برنامه برويد، يا",
"Use database to store images" => "تصاوير را در بانك اطلاعاتي نگهدار",
"Use a directory to store images" => "از يك پوشه(directory) براي نگهداري تصاوير استفاده كن",
"Library to use for processing images" => "كتابخانه‌ي مورد استفاده براي پردازش تصاوير",
"Uploaded image names must match regex" => "نام تصاوير بارگذاري شده بايد با اين اصطلاح همخواني داشته باشد",
"Uploaded image names cannot match regex" => "نام تصاوير بارگذاري شده نبايد با اين اصطلاح همخواني داشته باشد",
"Set features" => "تنظيمات اعمال شوند",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "تصاويري از سرسراي سامانه كه در صفحات ويكي، مقالات و الصاق‌هاي بلاگ‌ها استفاده نمي‌شوند را حذف كن",
"Image galleries comments settings" => "تنظيمات مربوط به توضحيات سرسراهاي تصوير",
"General preferences and settings" => "تنظيمات  عمومي",
"General Preferences" => "تنظيمات  عمومي",
"Theme" => "قيافه(Theme)",
"Change style only" => "فقط سبك(Style) رو تغيير بده",
"Slideshows theme" => "قيافه(Theme) نمايش اسلايدها",
"Use group homepages" => "استفاده از صفحات مبدا براي گروه‌ها",
"Use URI as Home Page" => "از اين URI به‌عنوان صحفه‌ي مبدا استفاده كن",
"Home page" => "صحفه‌ي مبدا",
"File Gallery" => "سرسراي پرونده",
"Custom home" => "متناسب‌سازي مبدا",
"Detect browser language" => "زبان مرورگر را تشخيص بده",
"Use database for translation" => "از بانك اطلاعاتي براي ترجمه استفاده كن",
"Record untranslated" => "ركورد ترجمه نشده است",
"OS" => "سيستم عامل",
"Unix" => "يونيكس(Unix)",
"Windows" => "ويندوز(Windows)",
"Unknown/Other" => "نامشخص يا غيره",
"PHP error reporting level for non-admin:" => "سطح گزارش خطاي PHP براي غير سرپرست‌ها",
"No error reporting" => "بدون گزارش خطا",
"Report all PHP errors" => "تمام خطاهاي PHP رو گزارش بده",
"Report all errors except notices" => "بجز آگاه‌سازها(Notices)، تمام خطاها را گزارش بده",
"Report PHP errors only for admin" => "خطاهاي PHP رو فقط براي سرپرست گزارش بده",
"Default charset for sending mail:" => "كاراكتر سي پيش‌فرض براي ارسال پست الكترونيكي:",
"Mail end of line:" => "انتهاي خط در پست‌هاي الكترونيكي:",
"(standard)" => "(استاندارد)",
"(some Unix MTA)" => "(برخي از MTAهاي يونيكس)",
"General Settings" => "تنظيمات عمومي",
"Disallow access to the site (except for those with permission)" => "دسترسي به اين پايگاه را -مگر براي كساني كه دسترسي دارند- ممكن نساز",
"Message to display when site is closed" => "پيغامي كه بايد هنگام تعطيل بودن پايگاه نمايش داده شود",
"Disallow access when load is above the threshold (except for those with permission)" => "هنگامي كه بار پايگاه پيش از حد مجاز مي‌شود، دسترسي به اين پايگاه را -مگر براي كساني كه دسترسي دارند- ممكن نساز",
"Max average server load threshold in the last minute" => "بيشينه بار متوسط سرور(Server Load) در دقيقه‌ي گذشته",
"Message to display when server is too busy" => "پيغامي كه بايد هنگام مشغول بودن بيش‌از حد سرور نمايش داده شود",
"Open external links in new window" => "پيوند(link)هاي خارجي را در پنجره‌ي جديد باز كن",
"Display modules to all groups always" => "همواره ماژول‌ها را تمام گروه‌ها نشان بده",
"Use cache for external pages" => "صفحات خارجي را در حافظه‌ي خود نگه‌دار",
"Use cache for external images" => "تصاوير خارجي را در حافظه‌ي خود نگه‌دار",
"Use direct pagination links" => "دنباله‌هاي صفحه‌گذاري‌هاي مستقيم استفاده كن",
"Display menus as folders" => "منوها را مانند پوشه‌ها نمايش بده",
"Tikiwiki.org help" => "كمك در tikiwiki.org",
"Use gzipped output" => "از خروجي‌ها gzipped استفاده كن",
"output compression is active." => "فشرده‌يسازي خروجي‌ها فعال است.",
"compression is handled by" => "فشرده‌سازي بدين‌وسيله اداره مي‌شود",
"Count admin pageviews" => "مشاهده‌ي صفحات سرپرست را بشمار",
"Hide anonymous-only modules from registered users" => "ماژول‌هاي كاربران بي‌نام را از كاربران ثبت‌نام كرده مخفي كن",
"Server name (for absolute URIs)" => "نام سرور(server)-(براي URIهاي مطلق)",
"HTTPS Server" => "سرور HTTPS",
"Automatic (uses HTTPS variable)" => "خودكار (از متغييرهاي HTTPS استفاده كن)",
"No" => "خير",
"Yes" => "بله",
"Browser title" => "عنوان مرورگر",
"Wiki_Tiki_Title" => "عنوان تيكي‌ويكي",
"Temporary directory" => "پوشه‌ي موقت",
"Sender Email" => "پست الكترونيكي فرستنده",
"Contact user" => "كاربر مورد تماس",
"Allow anonymous users to \"Contact Us\"" => "بي‌نام، امكان 'تماس با ما' را فراهم كن",
"contact feature disabled" => "امكان 'تماس' غيرفعال شد",
"Store session data in database" => "اطلاعات session را در بانك اطلاعاتي نگه‌دار",
"Session lifetime in minutes" => "عمر session به دقيقه",
"Use proxy" => "از پروكسي(proxy) استفاده كن",
"Proxy Host" => "ميزبان پروكسي",
"Proxy port" => "درگاه(port) پروكسي",
"Maximum number of records in listings" => "بيشينه تعداد ركوردها در فهرست‌برداري‌ها",
"Help URL" => "URL كمك",
"Date and Time Formats" => "شكل زمان و تاريخ",
"Long date format" => "شكل تاريخ طويل",
"Short date format" => "شكل تاريخ كوتاه",
"Long time format" => "شكل زمان طويل(long time)",
"Short time format" => "شكل زمان كوتا(short time)",
"Date and Time Format Help" => "كمك در زمينه‌ي شكل زمان و تاريخ",
"Register this site at tikiwiki.org" => "اين پايگاه رو در tikiwiki.org ثبت كن",
"Click here for more details." => "براي جزئيات بيشتر اين‌جا را كليك كنيد",
"Change admin password" => "تغيير كلمه‌ي عبور سرپرست",
"New password" => "كلمه‌ي عبور جديد",
"Change password" => "كلمه‌ي عبور را تغيير بده",
"Jukebox settings" => "تنظيمات jukebox",
"Jukebox tracks location" => "محل آثار(tracks)‌‌ jukebox",
"Jukebox features" => "خصيصه‌ها jukebox",
"Default ordering for album listing" => "ترتيب پيش‌فرض براي فهرست كردن آلبوم‌ها",
"Album title (asc)" => "تيتر آلبوم(صعودي)",
"Number of tracks (desc)" => "تعداد آثار(tracks) (نزولي)",
"In album listing show user as" => "در فهرست آلبوم‌ها، كاربر را با اين عنوان نشان بده",
"Jukebox listing configuration (when listing available albums)" => "پيكربندي فهرست جوك‌باكس (هنگامي كه آلبوم‌هاي موجود فهرست مي‌شوند)",
"Tracks" => "Trackها",
"Genre" => "قسم",
"Sections" => "بخش‌ها",
"Users &amp; groups" => "كاربران و تيم‌هاي كاري",
"Admin groups" => "سرپرستي گروه‌هاي كاربران",
"Admin users" => "سرپرستي كاربران",
"User registration and login" => "ثبت‌نام كاربران و ورود آن‌ها",
"Authentication method" => "نحوه‌ي تصديق هويت",
"Just Tiki" => "فقط تيكي",
"Web Server" => "سرور وب(Web Server)",
"Tiki and PEAR::Auth" => " تيكي و تصديق هويت كمكي",
"Tiki and PAM" => "تيكي و PAM",
"CAS (Central Authentication Service)" => "خدمات تصديق هويت متمركز(CAS)",
"Tiki and HTTP Auth" => "تيي و تصديق هويت HTTP",
"Use WebServer authentication for Tiki" => "براي تيكي از تصديق هويت وب‌سرور استفاده كن",
"Users can register" => "كاربران مي‌توانند ثبت‌نام كنند",
"... but need admin validation" => "…اما به تاييد اعتبار مديريت نياز دارند",
"Create a group for each user <br />(with the same\nname as the user)" => "براي هر كاربر، يك گروه همنام خودش بساز",
"Use tracker for more user information" => "از پيوندننده(tracker) براي اطلاعات بيشتر در مورد كاربران استفاده كن",
"Use tracker for more group information" => " از پيوندننده(tracker) براي اطلاعات بيشتر در مورد گروه‌ها استفاده كن ",
"Request passcode to register" => "براي ثبت‌نام درخواست اسم رمز(passcode) كن",
"Prevent automatic/robot registration" => "از ثبت‌نام خودكار(ماشيني) جلوگيري كن",
"Validate users by email" => "به كمك پست الكترونيكي، كاربر را تاييد اعتبار كن",
"Validate email address (may not work)" => "آدرس پست الكترونيكي را تاييد اعتبار كن(ممكن است كار نكند)",
"Remind passwords by email" => "كلمه‌ي عبور را به كمك پست الكترونيكي يادآوري كن",
"Reg users can change password" => "كاربران ثبت‌نام كرده، مي‌توانند كلمات عبور خود را تغير دهند",
"Reg users can change theme" => "كاربران ثبت‌نام كرده، مي‌توانند قيافه(theme)ي خود را تغيير دهند",
"Restrict available themes" => "قيافه(theme)هاي موجود را محدود كن",
"Available styles:" => "شيوه‌هاي موجود:",
"Reg users can change language" => "كاربان ثبت‌نام كرده، مي‌توانند زبان مربوط به خود را تغيير دهند",
"Restrict available languages" => "زبان‌هاي موجود را محدود كن",
"Available languages:" => "زبان‌هاي موجود:",
"Store plaintext passwords" => "كلمات عبور را به‌صورت كدنشده نگهداري كن",
"Use challenge/response authentication" => "از تصديق هويت رقابت/پاسخي استفاده كن",
"Force to use chars and nums in passwords" => "استفاده از اعداد و حروف در كلمه‌ي عبور اجباري است",
"Minimum password length" => "حداقل طول كلمه‌ي عبور",
"Password invalid after days" => "تعداد روزهاي معتبر بودن كلمه‌ي عبور",
"Require HTTP Basic authentication" => "نياز به تصديق هويت ابتدايي HTTP است",
"Allow secure (https) login" => "ورود امن (https) مجاز است",
"Require secure (https) login" => " ورود امن (https) ضروري است ",
"HTTP server name" => "نام خدمت رسان HTTP",
"HTTP port" => "درگاه HTTP",
"HTTP URL prefix" => "پيشوند آدرس URL مربوط به HTTP",
"HTTPS server name" => "نام خدمت‌رسان HTTPS",
"HTTPS port" => "درگاه HTTPS",
"HTTPS URL prefix" => " پيشوند آدرس URL مربوط به HTTPS ",
"Remember me feature" => "خصيصه‌ي 'مرا به‌خاطر بسپار' فعال باشد",
"Only for users" => "تنها براي كاربران",
"Users and admins" => "كاربران و مديران",
"Duration:" => "در طول:",
"day" => "روز",
"week" => "هفته",
"Remember me name" => "نام 'مرا به‌خاطر بسپار'",
"Remember me domain" => "domain  'مرا به‌خاطر بسپار'",
"Remember me path" => "آدرس 'مرا به‌خاطر بسپار'",
"Protect against CSRF with a confirmation step" => "به كمك يك مرحله تصديق، در برابر CSRF حفاظت كن",
"Protect against CSRF with a ticket" => "به كمك يك بليط، در برابر CSRF حفاظت كن",
"Highlight Group" => "گروه برجسته",
"choose a group ..." => "يك گروه انتخاب كنيد...",
"PEAR::Auth" => "تصديق هويت كمكي",
"LDAP" => "LDAP",
"Create user if not in Tiki?" => "كاربر را بساز، اگر در تيكي نبود",
"Create user if not in Auth?" => "كاربر را بساز، اگر در Auth نبود",
"Just use Tiki auth for admin?" => "تنها از تصديق هويت تيكي براي مديران استفاده كن",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(اگر تنظيم شود، ميزبان و درگاه مذكور در پايين را باطل مي‌كند)",
"LDAP Host" => "ميزبان LDAP",
"LDAP Port" => "درگاه LDAP",
"LDAP Scope" => " محدوده -scope- براي LDAP ",
"LDAP Base DN" => "DN پايه در LDAP",
"LDAP User DN" => "DN كاربر در LDAP",
"LDAP User Attribute" => " خصوصيت(Attribute) كاربر در LDAP ",
"LDAP User OC" => "OC كاربر در LDAP",
"LDAP Group DN" => "DN  گروه در LDAP",
"LDAP Group Attribute" => " خصوصيت(Attribute) گروه در LDAP ",
"LDAP Group OC" => " OC گروه در LDAP ",
"LDAP Member Attribute" => " خصوصيت(Attribute) عضو در LDAP ",
"LDAP Member Is DN" => "اعضاي LDAP در DN",
"LDAP Admin User" => "نام كاربري سرپرست LDAP",
"LDAP Admin Pwd" => "كلمه‌ي عبور سرپرست LDAP",
"PAM" => "PAM",
"PAM service" => "خدمات PAM",
"Currently unused" => "هم‌اكنون استفاده نمي‌شود",
"CAS server version" => "نسخه‌ي سرور CAS",
"Version 1.0" => "نسخه‌ي 1.0",
"Version 2.0" => "نسخه‌ي 2.0",
"CAS server hostname" => "نام سرور ميزبان CAS",
"CAS server port" => "درگاه سرور CAS",
"CAS server path" => "آدرس سرور CAS",
"Change CAS preferences" => "تنظيمات CAS را اعمال كن",
"full path to mapfiles" => "آدرس كامل پرونده‌هاي نقشه",
"default mapfile" => "پرونده‌ي نقشه پيش‌فرض",
"Wiki Page for Help" => "صفحه‌ي ويكي براي كمك",
"Wiki Page for Comments" => "صفحه‌ي ويكي براي نظرات",
"Full path to gdaltindex" => "آدرس كامل به gdaltindex",
"Full path to ogr2ogr" => "آدرس كامل به ogr2ogr",
"Map Zone" => "قلمرو نقشه",
"Generate User Map" => "نقشه‌ي كاربر را توليد كن",
"<b>Item</b>" => "<b>مورد</b>",
"<b>Value</b>" => "<b>مقدار</b>",
"Meta Keywords" => "كليدواژه",
"Meta Description" => "فرا شرح(meta desc)",
"Meta Author" => "مؤلف",
"geo.position" => "موقعيت جغرافيايي",
"geo.region" => "منطقه‌ي جغرافيايي",
"geo.placename" => "نام جغرافيايي محلي",
"meta robots" => "دستگاه خودكار",
"revisit after" => "مشاهده‌ي مجدد بعد از",
"to add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "براي حذف/اضافه كردن 'راي‌گيري‌ها'، دنبال \"راي‌گيري‌ها\" تحت بخش \"مديريت\" در منوي برنامه برويد، يا",
"Poll settings" => "تنظيمات راي‌گيري‌ها",
"Poll comments settings" => "تنظيمات 'نظرات' راي‌گيري‌ها",
"Allow Anonymous Poll Voting" => "كاربران بي‌نام هم اجازه‌ي راي‌دادن دارند",
"Users choose project categories" => "كاربران طبقات پروژه را انتخاب مي‌كنند",
"Prefix for Project Admin groups" => "پيشوند براي گروه‌هاي مديريت پروژه",
"Prefix for Project groups" => "پيشوند براي گروه‌هاي پروژه",
"Prefix for Wiki project home page" => "پيشوند براي صفحه‌ي مبدا پروژه‌ي ويكي",
"Prefix for File Galleries" => "پيشنود براي سرسراهاي پرونده",
"Project Admins group template" => "الگوي گروه‌هاي مديريت پروژه",
"Create New Group" => "ساخت گروه جديد",
"Project Members group template" => "الگوي گروه‌هاي اعضاي پروژه",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS modules\" on the application menu, or" => "اين صفحه براي پيكربندي تنظيمات تغذيه‌هاي توليد/صادر شده به‌وسيله‌ي تيكي است. براي خواندن/وارد كردن تغذيه‌هاي RSS، به دنبال \"ماژول‌هاي RSS\" در منوي برنامه بگرديد. يا",
"RSS feeds" => "تغذيه‌ي RSS",
"<b>Feed</b>" => "<b>تغذيه</b>",
"<b>enable/disable</b>" => "<b>فعال/غيرفعال</b>",
"<b>Max number of items</b>" => "<b>بيشينه تعداد اقلام</b>",
"<b>Title</b>" => "<b>عنوان</b>",
"<b>Description</b>" => "<b>شرح</b>",
"Feed for Articles" => "تغذيه براي مقالات",
"Feed for Weblogs" => "تغذيه براي وبلاگ‌ها",
"Feed for Image Galleries" => "تغذيه براي سرسراهاي تصاوير",
"Feed for File Galleries" => "تغذيه براي سرسراهاي پرونده‌ها",
"Feed for the Wiki" => "تغذيه براي ويكي",
"Feed for individual Image Galleries" => "تغذيه براي تك تك سرسرهاي تصوير",
"Feed for individual File Galleries" => "تغذيه براي تك تك سرسرهاي پرونده",
"Feed for individual weblogs" => "تغذيه براي تك تك وبلاگ‌ها",
"Feed for forums" => "تغذيه براي انجمن‌ها",
"Feed for individual forums" => "تغديه براي تك تك انجمن‌ها",
"Feed for mapfiles" => "تغذيه براي پرنده‌هاي نقشه",
"Feed for directories" => "تغذيه براي پوشه‌ها",
"Default RDF version" => "نسخه‌ي پيش‌فرض RDF",
"Specification" => "مشخصات",
"Append CSS file to feed urls" => "پرونده‌هاي CSS را به URLهاي تغذيه، اضافه كن",
"Documentation" => "مستندات",
"Publisher" => "ناشر",
"Creator" => "ايجاد كننده",
"Editor" => "ويراستار",
"Webmaster" => "كارفرماي وب(webmaster)",
"you can see users rank by score in the module users_rank, for that go to" => "مي‌توانيد رتبه‌ي كاربران را امتياز آن‌ها در ماژول users_rank ببينيد، براي اين‌كار به اين‌جا مراجعه كنيد",
"Admin modules" => "مديريت ماژول‌ها",
"Score settings" => "تنظيمات امتيازدهي‌ها",
"Expiration" => "انقضا",
"Search settings" => "تنظيمات جستجو",
"Search features" => "خصيصه‌هاي جستجو",
"Full Text Search" => "جستجوي متني كامل",
"SearchStats" => "آمار جستجو",
"Performance issues" => "موارد كارايي",
"Search may show forbidden results. Much better performance though." => "جستجو شامل موارد ممنوع هم باشد. كارايي به شدت افزايش مي‌يابد",
"Ignore individual object permissions" => "حقوق دسترسي انفرادي اشياء را ناديده بگير",
"Ignore category viewing restrictions" => "محدوديت‌هاي مشاهده‌ي طبقات را ناديده بگير",
"Settings for searching content" => "تنظيمات محتواي جستجو",
"Search refresh rate" => "نرخ تازه‌كردن جستجو",
"Minimum length of search word" => "حداقل طول كلمه‌ي جستو شده",
"Max. number of words containing a syllable" => "بيشينه تعداد كلماتي كه يك هجا را مي‌سازند",
"Max. age in hours of syllable search cache" => "بيشينه عمر cache جستجوي هجا به ساعت",
"LRU list purging rate" => "نرخ پاك‌سازي فهرست LRU",
"LRU list length" => "طول فهرست LRU",
"Dont forget to use feature you will need to enable it on the <a href=\"tiki-admin.php?page=features\">Features</a> icon." => "فراموش نكنيد كه از اين خصيصيه استفاده كنيد، بايد آن را در  <a href=\"tiki-admin.php?page=features\">خصيصه‌ها</a> فعال كنيد.",
"Site Identity Settings" => "تنظيمات هويت پايگاه",
"Custom code" => "كد متناسب‌سازي",
"Content" => "محتوا",
"Publish" => "منتشر شود",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "بيشينه مقدار حروف ويكي در بانك اطلاعاتي، به‌صورت پيش‌فرض 250 حرف تعيين گرديده است كه به محتواي كد متناسب‌سازي شده نيز اعمال مي‌شود. اگر مي‌خواهيد بيش از از اين تعداد حرف وارد كنيد، اين گزينه را انتخاب كنيد. (گرچه افزايش اين مقدار بر روي mysql آزمايش شده و نتيجه‌ي مطلوبي داشته، پيشنهاد مي‌شود كه قبل از تغيير در بانك اطلاعاتي، به‌صورت دستي از اطلاعات خود نسخه‌ي پشتيبان تهيه كنيد.)",
"Site location bar" => "نوار مكان پايگاه",
"Site logo" => "نماد پايگاه",
"Site logo source" => "آدرس پرونده‌ي نماد پايگاه",
"Site logo background color" => "رنگ پيش‌ضمينه‌ي نماد پايگاه",
"Site logo title (on mouse over)" => "عنوان نماد پايگاه (هنگام اشاره‌ي موش‌واره)",
"Alt. description (e.g. for text browsers)" => " شرح جايگزين (مثلا براي مرورگرهاي مبتني بر متن)",
"Site ads and banners" => "درفش‌ها و تنليغات پايگاه",
"to configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "براي پيكربندي trackerهاي خود، به دنبال \"مديريت trackerها\" تحت \"trackerها\" در منوي برنامه بگرديد، يا",
"Path" => "مسير",
"Attachments" => "ضمايم",
"Storage" => "انباره",
"change" => "تغيير بده",
"Change all to db" => "همه را به بانك اطلاعاتي ببر",
"Change all to file" => "همه را به‌صورت پرونده در پوشه‌ها بگذار",
"Quota (Mb)" => "سهميه‌ي حجمي (به مگابايت)",
"Use database to store userfiles" => "براي نگهداري پرونده‌هاي كاربران از بانك اطلاعاتي استفاده كن",
"Use a directory to store userfiles" => "براي نگهداري پرونده‌هاي كاربران از يك پوشه استفاده كن",
"Allow viewing HTML mails?" => "اجازه‌ي مشاهده‌ي پست‌هاي الكترونيكي HTML رو بده",
"Maximum size for each attachment" => "بيشينه حجم هر ضميمه",
"Wiki settings" => "تنظيمات ويكي",
"Dumps" => " تخليه(dump)",
"Generate dump" => "نسخه‌ي تخليه(dump) را بساز",
"Download last dump" => "دريافت آخرين تثمال كامل تهيه‌ي شده",
"Create a Tag for the Current Wiki" => "براي ويكي كنوني يك برچسب درست كن",
"Tag name" => "نام برچسب",
"Restore the Wiki" => "بازگرداني(restore) ويكي",
"restore" => "برگردان",
"Remove a Tag" => "حذف يك برچسب",
"Wiki Comments Settings" => "تنظيمات 'نظرات' ويكي",
"Export Wiki Pages" => "صادرات صفحات ويكي",
"Export" => "صدور اطلاعات",
"Manage attachment preferences" => "مديريت تنظيمات ضمايم",
"Remove unused pictures" => "حذف عكس‌هاي استفاده نشده",
"Wiki Home Page" => "صفحه‌ي مبدا ويكي",
"Wiki Discussion" => "مناظره‌ي ويكي",
"Discuss pages on forums" => "در خصوص صفحات در انجمن‌ها بحث شود",
"Wiki Link Format" => "شكل پيوندهاي ويكي",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "از دو پرانتز براي تشخيص دنباله‌هاي ويكي استفاده مي‌شود <i>((نام صفحه))</i>.",
"complete" => "كامل",
"latin" => "لاتين",
"english" => "انگليسي",
"Wiki page list configuration" => "پيكربندي فهرست صفحات ويكي",
"Last modification date" => "تاريخ آخرين تغييرات",
"Last version" => "آخرين نسخه",
"Status" => "وضعيت",
"Versions" => "نسخه",
"Backlinks" => "پيوندهاي معكوس",
"Wiki 3D Browser Configuration" => "پيكربندي مرورگر 3بعدي ويكي",
"Enable wiki 3D browser" => "مرورگر 3بعدي ويكي فعال باشد",
"Browser width" => "عرض مرورگر",
"Browser height" => "ارتفاع مرورگر",
"Navigation depth" => "‘عمق مرور",
"Feed animation interval (milisecs)" => "فرجه‌ي تغذيه‌ي انگيزش (ميلي ثانيه)",
"Existing page node color" => "رنگ گره‌ي صفحه‌ي موجود",
"Missing page node color" => " رنگ گره‌ي صفحه‌ي مفقود",
"Wiki Features" => "خصيصه‌هاي ويكي",
"HTML in Wiki Pages" => "HTML در صفحات ويكي",
"Anonymous editors must input anti-bot code" => "ويراستاران بي‌نام، بايد كدهاي ضد-روباتيكي را وارد كنند",
"Like pages" => "پيوند صفحات",
"Undo" => "برگشت عمل",
"MultiPrint" => "چاپ چندگانه",
"PDF generation" => "توليد PDF",
"Warn on edit conflict" => "هنگام بهوجود آمدن تضاد در ويرايش‌ها، هشدار بده",
"Edit idle timeout" => "مهلت ويرايش",
"mins" => "دقيقه",
"Pictures" => "عكس",
"Use page description" => "از شرح صفحه استفاده كن",
"Show page title" => "عنوان صفحه را نمايش بده",
"Cache wiki pages (global)" => "صفحات ويكي را cache كن(عمومي)",
"Individual cache" => "cache تك-تك",
"Users can lock pages (if perm)" => "كاربران مي‌توانند صفحات را قفل كنند(اگر دسترسي داشته باشند)",
"Use WikiWords" => "از ويكي-كلمه استفاده كن",
"Accept dashes and underscores in WikiWords" => "خط تيره و زيرخط در ويكي -كلمه‌ها مجاز است",
"Link plural WikiWords to their singular forms" => "ويكي-كلمات جمع را به مفرد آن‌ها متصل كن",
"Use Wiki paragraph formatting" => "از شكل‌سازي پاراگراف‌هاي ويكي استفاده كن",
"Page creators are admin of their pages" => "سازنده‌هاي صفحات، همان مالكان آن‌ها هستند",
"Tables syntax" => "نحو جداول",
"|| for rows" => "|| براي سطرها",
"\\n for rows" => "\\n براي ستون‌ها",
"Automonospaced text" => "متون autospaceشده‌ي خودكار",
"Uses Slideshow" => "از نمايش صفحه به صفحه استفاده كن(slideshow)",
"Open page as structure" => "صفحه را به عنوان ساختار باز كن",
"Use external link icons" => "از تمثال پيوند خارجي استفاده كن",
"User's Page" => "صفحات كاربران",
"UserPage prefix" => "پيشوند صفحات كاربران",
"Wiki History" => "تارخچه‌ي ويكي",
"Maximum number of versions for history" => "بيشينه تعداد نسخ براي تاريخچه",
"unlimited" => "نامحدود",
"Never delete versions younger than days" => "هرگز صفحات جديدتر از اين تعداد روز را حذف نكن",
"Diff style" => "سبك تفاوت",
"Only with last version" => "تنها با آخرين نگارش",
"Any 2 versions" => "هر 2 نسخه",
"Copyright Management" => "مديريت حق چاپ",
"Enable Feature" => "فعال باشد",
"License Page" => "صفحه‌ي پروانه",
"Submit Notice" => "اخطار ارائه شود",
"Wiki Watch" => "ديده‌بان ويكي",
"Create watch for author on page creation" => "براي ويراستار هنگام ساخت صفحات، ديده‌بان بساز",
"Enable watches on comments" => "ديده‌بان در 'نظرات' فعال باشد",
"Enable watch events when I am the editor" => "هنگامي كه من ويراستار هستم، ديده‌بان رويدادها فعال باشد",
"Set" => "تنظيم",
"Wiki attachments" => "ضمايم ويكي",
"Administration" => "سرپرستي",
"View tpl" => "مشاهده‌ي الگو",
"admin banning tpl" => "الگوي مديريت تحريم‌ها",
"Add or edit a rule" => "ايجاد يا تغيير قوانين",
"Rule title" => "عنوان قانون",
"Username regex matching" => "تطبيق نام كاربري",
"IP regex matching" => "تطبيق آدرس اينترنتي(IP)",
"Banned from sections" => "محروم از اين منابع",
"Rule activated by dates" => "قانون باتوجه به تاريخ فعال مي‌شود",
"Rule active from" => "قاتون از اين تارخ فعال است",
"Rule active until" => "قانون تا اين تاريخ فعال است",
"Custom message to the user" => "پيغام متناسب‌شده براي كاربر",
"Rules" => "قوانين",
"x" => "حذف",
"User/IP" => "كاربر/آدرس اينترنتي(IP)",
"Admin Calendars" => "مديريت تقويم‌ها",
"List Calendars" => "فهرست تقويم‌ها",
"Create/edit Calendars" => "ايجاد/ويرايش تقويم",
"List of Calendars" => "فهرست تقويم‌ها",
"ID" => "شناسه",
"loc" => "مكان",
"cat" => "طبقه",
"lang" => "زبان",
"prio" => "اولويت",
"event" => "رويداد",
"perso" => "شخصي",
"permissions" => "دسترسي‌ها",
"Custom Locations" => "مكان‌هاي متناسب",
"yes" => "بله",
"no" => "خير",
"Custom Categories" => "طبقه‌بندي‌هاي متناسب",
"Custom Languages" => "زبان‌هاي متناسب",
"Custom Priorities" => "اولويت‌هاي متناسب",
"Custom Events" => "رويدادهاي متناسب",
"Personal Calendar" => "تقويم شخصي",
"admin categories" => "مديريت طبقه‌بندي‌ها",
"admin categories tpl" => "الگوي مديريت طبقه‌بندي‌ها",
"browse category" => "مرور طبقه",
"Current category" => "طبقه‌ي جاري",
"Child categories" => "طبقات فرزند",
"Edit this category:" => "اين طبقه را ويرايش كن:",
"create new" => "ساخت جديد",
"Add new category" => "افزودن طبقه‌ي جديد",
"Parent" => "منشا",
"Perms inherited from closest parent if possible or from global perms" => "درصورت امكان، حقوق دسترسي از نزديك‌ترين والد به ارث مي‌رسد، وگرنه از حقوق دسترسي‌هاي عمومي",
"Assign permissions automatically" => "حقوق دسترسي را به‌صورت خودكار اختصاص بده",
"recommended for best performance" => "براي دستيابي به بهترين عملكر، پيشنهاد مي‌شود",
"Objects in category" => "اشياء در طبقه‌ي",
"type" => "نوع",
"Add objects to category" => "افزودن شيء به طبقه",
"article" => "مقاله",
"blog" => "بلاگ",
"directory" => "پوشه",
"image gal" => "سرسراي تصوير",
"file gal" => "سرسراي پرونده",
"forum" => " انجمن",
"poll" => "راي‌گيري",
"faq" => "faq",
"tracker" => "tracker",
"quiz" => "آزمون",
"Admin chart items" => "مديريت اقلام نمودارها",
"charts" => "نمودارها",
"edit chart" => "ويرايش نمودار",
"Add or edit an item" => "افزودن يا ويرايش يك قلم",
"URL" => "آدرسي اينترنتي",
"update" => "به‌روز رساني كن",
"Chart items" => "اقلام نمودار",
"No items defined yet" => "هنوز هيچ فقره‌اي تعريف نشده است.",
"Admin charts" => "نمودارهاي سرپرست",
"View template" => "مشاهده‌ي الگو",
"admin charts template" => "مديريت الگوي نمودارها",
"Add or edit a chart" => "افزوردن يا تغيير يك نمودار",
"Active" => "فعال",
"Users can vote for only one item from this chart per period" => "كاربران مي‌توانند در هر دوره تنها به يك قلم از اين نمودار راي دهند",
"Prevent users from voting for the same item more than once" => "از راي دادن بيش از يك‌بار كاربران به يك قلم جلوگيري كن",
"Users can suggest new items" => "كاربران مي‌توانند قلم جديدي را پيشنهاد كنند",
"Auto validate user suggestions" => "اعتبار پيشنهادات كاربران را به صورت خودكار كنترل كن",
"Ranking shows" => "نمايش رتبه بندي‌ها",
"All items" => "تمام اقلام",
"Top 10 items" => "10 قلم برتر",
"Top 20 items" => "20 قلم برتر",
"Top 40 items" => "40 قلم برتر",
"Top 50 items" => "50 قلم برتر",
"Top 100 items" => "100 قلم برتر",
"Top 250 items" => "250 قلم برتر",
"Voting system" => "سامانه‌ي راي گيري",
"Vote items" => "اقلام راي",
"Rank 1..5" => "امتياز 5..1 ",
"Rank 1..10" => "امتياز 10..1",
"Ranking frequency" => "تناوب امتيازدهي",
"Realtime" => "در لحظه",
"Each 5 minutes" => "هر 5 دقيقه",
"Daily" => "روزانه",
"Weekly" => "هفتگي",
"Monthly" => "ماهانه",
"Show Average" => "متوسط را نمايش بده",
"Show Votes" => "راي‌ها را نمايش بده",
"Use Cookies for unregistered users" => "كوكي‌هاي كاربران ثبت‌نام نكرده را نمايش بده",
"Users can vote again after" => "بعد از چه مدت كاربران مي‌توانند مجدداد راي دهند؟",
"Anytime" => "مهم نيست",
"5 minutes" => "5 دقيقه",
"1 day" => "1 روز",
"1 week" => "1 هفته",
"1 month" => "1 ماه",
"Items" => "اقلام",
"Ranks" => "امتيازها",
"No charts defined yet" => "هنوز هيچ نموداري تعريف نشده است",
"Chat Administration" => "مديريت گپ‌زني",
"Chat Admin" => "مديريت گپ‌زني",
"Chat Admin tpl" => "الگوي مديريت گپ‌زني",
"Create/edit channel" => "ايجاد/ويرايش كانال",
"Refresh rate" => "نرخ بازيابي(Refresh)",
"Half a second" => "نيم ثانيه",
"second" => "ثانيه",
"Chat channels" => "كانال‌هاي گپ‌زني",
"active" => "فعال",
"Admin templates" => "الگوهاي سرپرستي",
"admin content templates" => "مديريت الگوهاي محتوي",
"admin content templates template" => "مديريت الگوي 'اگوهاي محتوي'",
"Edit this template:" => "اين الگو را ويرايش كن:",
"Create new template" => "ساخت الگوي جديد",
"use in cms" => "استفاده در سامانه‌ي مديريت محتوا",
"use in wiki" => "استفاده در ويكي",
"use in newsletters" => "استفاده در خبرنامه‌ها؟",
"use in events" => "استفاده در رويدادها؟",
"use in HTML pages" => "استفاده در اين صفحات HTML",
"template" => "الگو",
"Templates" => "الگوها",
"last modif" => "تاريخ آخرين تغيير",
"sections" => "بخش‌ها",
"Admin cookies" => "مديريت كوكي‌ها(cookies)",
"admin FortuneCookie" => "مديريت كوكي بخت",
"admin FortuneCookie tpl" => "الگوي مديريت كوكي بخت",
"Create/edit cookies" => "ايجاد/تغيير كوكي",
"Cookie" => "كوكي",
"Upload Cookies from textfile" => "كوكي‌ها را از يك فايل بارگذاري كن",
"Upload from disk:" => " بارگذاري از دستگاه:",
"upload" => "بارگذاري",
"Remove all cookies" => "تمام كوكي‌ها را حذف كن",
"cookie" => "كوكي",
"admin Drawings" => "مديريت نقاشي‌ها",
"admin Drawings tpl" => "الگوي مديريت نقاشي‌ها",
"Available drawings" => "نقاشي‌هاي موجود",
"Ver" => "نسخه",
"Admin DSN" => " مديريتDSN",
"tiki-admin_dsn tpl" => "الگوي مديريت DSN تيكي",
"Create/edit dsn" => "ايجاد/ويرايش dsn",
"dsn" => "dsn",
"Admin event subscriptions" => "مديريت عضويت رويدادها",
"list events" => "فهرست رويدادها",
"admin events" => "مديريت رويدادها",
"send events" => "ارسال رويدادها",
"Event" => "رويداد",
"Add a subscription event" => "افزودن به عضويت رويدادها",
"First Name" => "نام كوچك",
"Last Name" => "نام خانوادگي",
"Company" => "سازمان",
"Add all your site users to this event (broadcast)" => "تمام كاربران پايگاه خود را به اين رويداد اضافه كنيد (خبرگزاي)",
"Add all users" => "اضافه كردن تمام كاربران",
"Subscribe group" => "گروه عضو شود",
"Group subscription also subscribes included groups" => "عضويت در گروه‌ها باعث عضويت در گروه‌هاي شامل نيز مي‌شود",
"Subscriptions" => "اعضا",
"fname" => "نام كوچك",
"lname" => "نام خانوادگي",
"company" => "شركت",
"valid" => "اعتبار",
"subscribed" => "عضو شد",
"admin events template" => "مديريت الگوي رويدادها",
"Create/edit events" => "ايجاد/ويرايش رويدادها",
"There are individual permissions set for this event" => "حقوق دسترسي فردي براي اين رويداد تنظيم شده است",
"Users can subscribe/unsubscribe to this list" => "اربران مي‌توانند عضو اين فهرست شوند و عضويت خود را لغو كنند",
"Users can subscribe any email address" => "كاربران مي‌توانند هر آدرس پست الكترونيكي را عضو كنند",
"Add unsubscribe instructions to each event" => "اطلاعات مربوط به لغو عضويت را به تمام رويدادها اضافه كن",
"Validate email addresses" => "آدرس‌هاي پست الكترونيكي را تاييد اعتبار كن",
"editions" => "نسخه‌ها",
"last sent" => "آخرين ارسال",
"Assign Permissions" => "تخصيص حقوق دسترسي به ",
"subscriptions" => "مشتركين",
"send event" => "ارسال رويداد",
"Admin external wikis" => "سرپرستي ويكي‌هاي خارجي",
"admin External Wikis" => "سرپرستي ويكي‌هاي خارجي",
"tiki admin external wikis template" => "الگوي مديريت ويكي‌هاي خارجي تيكي",
"Create/Edit External Wiki" => "ايجاد/تغيير ويكي‌هاي خارجي‌",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (از \$page براي جايگزيني نام صفحه در URL استفاده كنيد، مانند: http://www.example.com/tiki-index.php?page=\$page)",
"External Wiki" => "ويكي‌هاي خارجي",
"extwiki" => "ويكي خارجي",
"Admin Forums" => "مديريت انجمن",
"admin forums template" => "مديريت الگوي انجمن‌ها",
"Create new forum" => "ايجاد انجمن جديد",
"Edit existing forums" => "ويرايش انجمن‌هاي كنوني",
"Configure/Options" => "پيكربندي/تنظيمات",
"Edit this Forum:" => "اين انجمن را ويرايش كن:",
"Create New Forum" => "ساخت يك انجمن جديد",
"There are individual permissions set for this forum" => "حقوق دسترسي فردي براي اين انجمن تنظيم شده است",
"Show description" => "شرح را نمايش بده؟",
"Prevent flooding" => "جلوگيري از طغيان",
"Minimum time between posts" => "حداقل زمان بين الصاق‌ها",
"min" => "دقيقه",
"Topics per page" => "تعداد عنوان در هر صفحه",
"Section" => "بخش",
"Create new" => "يكي ايجاد كن",
"Moderator user" => "كاربر ناظم",
"Moderator group" => "گروه ناظم",
"Password protected" => "حفاظت شده با كلمه‌ي عبور؟",
"Topics only" => "فقط عنوان",
"All posts" => "تمام الصاق‌ها",
"Forum password" => "كلمه‌ي عبور انجمن:",
"Default ordering for topics" => "ترتيب پيش‌فرض براي موضوعات",
"Date (desc)" => "تاريخ (نزولي)",
"Score (desc)" => "امتياز (نزولي)",
"Replies (desc)" => "پاسخ‌ها (نزولي)",
"Reads (desc)" => "خوانده شدن (نزولي)",
"Title (desc)" => "عنوان (نزولي)",
"Title (asc)" => "عنوان (صعودي)",
"Default ordering for threads" => "ترتيب پيش‌‍فرض براي رگه‌ها",
"Date (asc)" => "تاريخ (نزولي)",
"Send this forums posts to this email" => "الصاق‌هاي اين انجمن را به اين پست الكترونيكي بفرست",
"Prune unreplied messages after" => "پيغام‌هاي بدون جواب بايد بعد از چند روز هرس(حذف) شوند؟",
"Prune old messages after" => "پيغام‌ها بعد از چند روز قديمي هستند و بايد هرس(حذف) شوند؟",
"Topic list configuration" => "پيكربندي فهرست عناوين",
"Replies" => "پاسخ‌ها",
"Posts can be rated" => "الصاق‌ها مي‌توانند ارزيابي شوند‌",
"Display last post titles" => "چند تعداد از آخرين الصاق‌ها نمايش داده شوند؟",
"no display" => "هيچ",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "پيغام‌هاي الصاق شده به اين انجمن را چنان به اين آدرس ارسال كن، كه پاسخ آن‌ها بتواند به‌عنوان الصاق در انجمن قرار گيرد:",
"Originating e-mail address for mails from this forum" => "پست‌هاي الكترونيكي ارسالي از اين انجمن، از طرف اين آدرس ارسال مي‌شوند:",
"Add messages from this email to the forum" => "پيغام‌هاي اين آدرس را در اين انجمن الصاق كن",
"POP3 server" => "سرور POP3",
"Use topic smileys" => "صورتك‌هاي عناوين را نمايش بده؟",
"Show topic summary" => "خلاصه‌ي عناوين را نمايش بده؟",
"User information display" => "اطلاعات كاربر را نمايش بده؟",
"avatar" => "شكلك",
"flag" => "پرچم",
"posts" => "الصاق‌ها",
"online" => "روي خط",
"Approval type" => "نوع تصويب(approval)",
"All posted" => "همه را الصاق كن (نيازي به تصويب نيست)",
"Queue anonymous posts" => "الصاق‌هاي بي‌نام را در صف قرار بده",
"Queue all posts" => "تمام الصاق‌ها را در صف قرار بده",
"No attachments" => "بدون ضميمه",
"Everybody can attach" => "همه مي‌توانند پرونده ضميمه كنند",
"Only users with attach permission" => "تنها كاربراني كه دسترسي ضميمه كردن دارند مي‌توانند ضميمه كنند",
"Moderators and admin can attach" => "مديران و ناظم‌ها نمي‌توانند ضميمه كنند",
"Store attachments in:" => "ضمايم را در اين‌جا نگهداري:",
"Database" => "بانك اطلاعاتي",
"Max attachment size (bytes)" => "بيشينه حجم ضميمه (بايت)",
"Edit Existing Forums" => "انجمن كنوني را ويرايش كن",
"topics" => "عناوين",
"coms" => "نظرات",
"age" => "سن",
"ppd" => "ppd",
"last post" => "آخرين الصاق",
"hits" => " ضربت‌ها(Hits)",
"Assign Permissions (Active)" => "تخصيص حقوق دسترسي (فعال)",
"Click here to delete this forum" => "براي حذف اين انجمن اين‌جا را كليك كنيد",
"Admin Hotwords" => "مديريت واژگان آتشين",
"admin hotwords" => "مديريت واژگان آتشين",
"admin hotwords template" => "مديريت الگوي واژگان آتشين",
"Add Hotword" => "اضافه كردن واژگان آتشين",
"Word" => "واژه",
"Add" => "اضافه كن",
"admin HTML page dynamic zones" => "مديريت قلمرو پوياي صفحات HTML",
"Admin HTML pages" => "مديريت صفحات HTML",
"Edit this page" => "اين صفحه را ويرايش كن",
"View page" => "مشاهده‌ي صفحه",
"Edit zone" => "اين قلمرو را ويرايش كن",
"Zone" => "قلمرو",
"Dynamic zones" => "قلمرو پويا",
"zone" => "قلمرو",
"content" => "محتوي",
"Mass update" => "بارگذاري كيلويي!",
"admin Html Pages" => "مديريت صفحات HTML",
"admin Html Pages template" => "مديريت الگوي صفحات HTML",
"Create new HTML page" => "يك صفحه‌ي HTML جديد ايجاد كن",
"Edit this HTML page:" => "ويرايش اين صفحه‌ي HTML:",
"Page name" => "نام صفحه",
"Dynamic" => "پويا",
"Static" => "ثابت",
"Refresh rate (if dynamic) [secs]" => "نرخ تازه كردن-Refresh- (در صورت پويا بودن) [ثانيه]",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => " از {literal}{{/literal}ed شناسه=نام} يا {literal}{{/literal}ted شناسه=نام} براي ايجاد قلمروهاي پويا استفاده كنيد",
"Edit Repository:" => "ويرايش مخرن:",
"Create New Repository" => "ساخت مخزن جديد",
"list repositories" => "فهرست مخازن",
"new repository" => "مخزن جديد",
"view repository" => "مشاهده‌ي مخزن",
"Human readable repository name" => "نام قابل خواندن مخزن",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "مسير مخزن (سامانه‌ي پرونده‌ي محلي: نسبي/مطلق ريشه‌هاي وب، از راه‌دور: بايد با 'http://' آغاز شوند)",
"File name of start page" => "نام پرونده‌ي صفحه‌ي آغازين",
"Start page" => "صفحه‌ي آغازين",
"CSS file to load when browse this repository" => "پرونده‌ي CSSاي كه بايد هنگام مرور اين مخزن بار شود",
"CSS file" => "پرونده‌ي CSS",
"Is repository visible to users" => "آيا مخزن براي كاربران عادي قابل مشاهده است؟",
"Can files from repository be cached" => "آيا پرونده‌هاي مخزن مي‌توانند cache شوند؟",
"Cacheable" => "قابل cache شدن",
"Are files from repository can be cached" => "آيا پرونده‌هاي اين مخزن قابل cache هستند؟",
"Clear all cached pages of this repository" => "تمام صفحاتي از اين مخزن كه cache شده‌اند را خالي كن",
"Clear cache" => "حافظه نهان(cache) را تخليه كن",
"Seconds count 'till cached page will be expired" => "شمارش ثانيه‌ها 'تا صفحه‌ي cache شده منقضي شود'",
"Cache expiration" => "انقضاي cache",
"Human readable text description of repository" => "متن قابل خواندن مخزن",
"Available Repositories" => "مخازن موجود",
"Start" => "شروع",
"CSS File" => "پرونده‌هاي CSS",
"Edit rules" => "ويرايش قوانين",
"Edit Rules for Repository:" => "ويرايش قوانين مخازن:",
"configure repositories" => "پيكربندي مخازن",
"configure this repository" => "پيكربيندي اين مخزن",
"view this repository" => "مشاهده‌ي اين مخزن",
"Add new rule" => "افزودن قانون جديد",
"new rule" => "قانون جديد",
"view/hide copy rules dialog" => "مشاهده/مخفي‌كردن رونوشت محاروه‌ي(dialog) كپي قوانين",
"copy rules" => "كپي قوانين",
"Source repository" => "مخزن منبع",
"Copy" => "كپي",
"According this order rules will be applied ('0' or empty = auto)" => "قوانين با توجه به اين ترتيب اعمال مي‌شوند (0 يا هيچي =خودكار)",
"Rule order" => "ترتيب قوانين",
"Text to search for" => "متن براي جستجو",
"Text to replace" => "متن براي جايگزيني",
"Replace" => "جايگزين كن",
"Is this regular expression or simple search/replacer" => "آيا اين يك مبين منظم(regular expression) است يا جستجوي/جايگزيني ساده؟",
"Regex" => "Regex",
"Is case sensitive (for simple replacer)" => "حساس به حروف؟ (براي جايگزيني ساده)",
"Case sensitive" => "حساس به حروف",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "زيرمجموعه‌اي از حروف: imsxeADSXUu، كه تعديل كننده‌ي regex است",
"Regex modifiers" => "تعديل كننده‌هاي regex",
"Human readable text description of rule" => "توضيح قابل خواندن قانون",
"Check to enable this rule" => "براي فعال كردن اين قانون اين گزينه را انتخاب كنيد",
"Enabled" => "فعال شد",
"Preview options" => "اختيارات پيش‌نمايش",
"Apply all rules or just this to generate preview" => "تمام قوانين يا فقط اين را براي توليد پيش‌نمايش اعمال كن",
"Apply all rules" => "اعمال تمام قوانين",
"View source code after rules applied" => "كداصل(sourcecode) پس از اعمال قوانين نمايش بده",
"Code preview" => "پيش‌نمايش كد",
"Generate HTML preview" => "پيش‌نمايش HTML را توليد كن",
"HTML preview" => "پيش‌نمايش HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
"Preview Results" => "پيش‌نمايش نتايج",
"Rules List" => "فهرست قوانين",
"Case" => "اگر",
"Admin layout" => "مديريت طرح‌بندي",
"layout options" => "اختيارات طرح‌بندي",
"admin featured links" => "مديريت پيوندهاي خاص",
"admin featured links template" => "الگوي مديريت پيوندهاي خاص",
"Generate positions by hits" => "موقعيت‌ها اطلاعات طريق ضربات مشخص شود",
"List of featured links" => "فهرست پيوندهاي خاص",
"url" => "آدرس اينترنتي",
"title" => "عنوان",
"position" => "موقعيت",
"Add Featured Link" => "افزودن پيوند خاص",
"Edit this Featured Link:" => "اين پيوند خاص را ويرايش كن:",
"Create new Featured Link" => "ايجاد پيوند خاص جديد",
"Position" => "موقعيت",
"disables the link" => "پيوند را غيرفعال كن",
"Link type" => "نوع پيوند",
"replace current page" => "جايگزين صفحه‌ي كنوني شود",
"framed" => "قاب‌دار",
"open new window" => "پنجره‌ي جديد باز شود",
"Mail-in accounts" => "حساب‌هاي 'كنترل با پست الكترونيكي'",
"admin Webmail" => "مديريت پست تحت وب",
"admin mailin template" => "مديريت الگوي دريافت پست الكترونيكي",
"Account" => "حساب",
"Add new Mail-in account" => "افزودن حساب جديد 'كنترل با پست الكترونيكي'",
"Edit Mail-in account" => "ويرايش حساب 'كنترل با پست الكترونيكي'",
"Account name" => "نام حساب:",
"POP server" => "سرور POP(دريافت):",
"Port" => "درگاه(port):",
"SMTP server" => "سرور SMTP(ارسال):",
"SMTP requires authentication" => "آيا سرور SMTP نياز به تصديق هويت (authentication) دارد؟",
"article-put" => "قراردادن مقاله",
"wiki-get" => "گرفتن ويكي",
"wiki-put" => "قراردادن ويكي",
"wiki-append" => "افزودن ويكي",
"Article Topic" => "عنوان مقاله",
"Article Type" => "نوع مقاله",
"Allow anonymous acces" => "دسترسي بي‌نمام مجاز است؟",
"Allow attachments" => "ضمايم مجازند؟",
"Discard to the end from" => "از اين به بعد را دور بنداز:",
"Check Mail-in accounts" => "بررسي حساب‌هاي 'كنترل با پست الكترونيكي'",
"Check automatically" => "به‌صورت خودكار بررسي كن",
"Frequency" => "تناوب",
"List menus" => "فهرست منوها",
"Edit this menu" => "اين منو را ويرايش كن",
"Edit menu options" => "ويرايش اختيارات منو",
"Show Quick Urls" => "URLهاي سريع را نمايش بده",
"Hide Quick Urls" => "URLهاي سريع را مخفي كن",
"Some useful URLs" => "چند URL سودمند",
"Permissions" => "دسترسي‌ها",
"section" => "بخش",
"sorted section" => "بخش‌هاي مرتب شده",
"option" => "اختيارات",
"separator" => "جداكننده",
"Choose" => "انتخاب كنيد",
"Home Page" => "صفحه‌ي مبدا",
"Home Blog" => "بلاگ مبدا",
"Home Image Gal" => "سرسراي تصوير مبدا",
"Home Image Gallery" => "سرسراي تصوير مبدا",
"Home File Gal" => "سرسراي پرونده‌ي مبدا",
"Home File Gallery" => "سرسراي پرونده‌ي مبدا",
"User preferences" => "تنظيمات كاربر",
"User prefs" => "تنظيمات كاربر",
"List image galleries" => "فهرست سرسراهاي تصوير",
"Upload" => "بارگذاري",
"Gallery Rankings" => "امتيازدهي‌هاي سرسراها",
"Browse a gallery" => "مرور سرسرا",
"All articles" => "تمام مقالات",
"Submit" => "ارائه",
"List Blogs" => "فهرست بلاگ‌ها",
"Create blog" => "ايجاد بلاگ‌",
"View a forum" => "مشاهده‌ي انجمن",
"View a thread" => "مشاهده‌ي رگه",
"View a FAQ" => "مشاهده‌ي FAQ",
"Take a quiz" => "برگزاري آزمون",
"Stats for a Quiz" => "آمار آزمون",
"Preview menu" => "مشاهده‌ي منو",
"Menu options" => "اختيارات منو",
"group" => "گروه",
"Admin Menus" => "مديريت منو",
"admin menu builder" => "مديريت سازنده‌ي منو",
"admin menus template" => "الگوي مديريت منوها",
"Edit this Menu:" => "اين منو را ويرايش كن:",
"Create new Menu" => "ايجاد يك منوي جديد",
"dynamic collapsed" => "جمع‌كردن پويا",
"dynamic extended" => "بست دادن پويا",
"fixed" => "ثابت شده",
"options" => "اختيارات",
"Admin Modules" => "مديريت ماژول‌ها",
"admin modules" => "مديريت ماژول‌ها",
"admin modules template" => "الگوي مديريت ماژول‌ها",
"assign module" => "تخصيص ماژول‌ها",
"left modules" => "ماژول‌هاي سمت چپ",
"right modules" => "ماژول‌هاي سمت راست",
"edit/create" => "ويرايش/ايجاد ",
"clear cache" => "پاك‌سازي حافظه نهان(cache)",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>نكته 1</b>درصورتي كه با كاربران اجازه‌ي پيكربندي ماژول‌ها را بدهيد، آن‌گاه 'ماژول‌هاي تخصيص‌داده شده' در صفحه نمايش داده نخواهد شد، مگر آن‌كه آن‌ها را در 'تيكي من -> ماژول‌ها' پيكربندي كنيد.<br />\n<b>نكته 2</b>: درصورتي كه ماژولي را به گروه خاصي اختصاص مي‌دهيد، به‌خاظر داشته باشيد كه گزينه‌ي 'نمايش همواره‌ي ماژول‌ها به تمام گروه‌ها' را در 'مديريت -> عمومي' غيرفعال كنيد.",
"User Modules" => "ماژول‌هاي كاربران",
"assign" => "اختصاص بده",
"Assign new module" => "تخصيص ماژول جديد",
"Edit this assigned module:" => "اين ماژول تخصيص داده شده را ويرايش كن:",
"Module Name" => "نام ماژول",
"left" => "راست",
"right" => "چپ",
"Order" => "ترتيب",
"Cache Time" => "زمان نگهداري در نهانگاه(Cache)",
"Rows" => "رديف",
"parameters" => "پارامترها",
"Visibility" => "قابلت روئيت",
"Displayed for the eligible users with no personal assigned modules" => "براي كاربران واجد شرايط كه هيچ ماژول اختصاصي‌اي براي آن‌ها وجود ندارد، نمايش داده شود",
"Displayed now for all eligible users even with personal assigned modules" => "براي كاربران واجد شرايط كه حتي ماژولي به آن‌ها اختصاص يافته است نيز نمايش داده شود",
"Displayed now, can't be unassigned" => "نمايش داده مي‌شود، نمي‌تواند حذف شود",
"Not displayed until a user chooses it" => "نمايش داده نمي‌شود مگر آن‌كه كاربر انتخابش كند",
"Assigned Modules" => "ماژول‌‌هاي تخصيصي داده شده",
"Left Modules" => "ماژول‌هاي سمت چپ",
"order" => "ترتيب",
"rows" => "رديف",
"groups" => "گروه‌هاي كاربري",
"Right Modules" => "ماژول‌هاي سمت راست",
"Create new user module" => "يك ماژول جديد كاربري ايجاد كن",
"Edit this user module:" => "اين ماژول كاربري را ويرايش كن:",
"Use wysiwyg editor" => "از ويراستار WYSIWYG استفاده كن",
"Use normal editor" => "از ويراستار معمولي استفاده كن",
"create/edit" => "ايجاد/حذف",
"Objects that can be included" => "اشيائي كه مي‌توانند داخل ماژول قرار بگيرند",
"Available polls" => "راي‌گيري‌هاي موجود",
"use poll" => "از اين راي‌گيري استفاده كن",
"Random image from" => "تصوير تصادفي از",
"All galleries" => "تمام سرسراها",
"use gallery" => "از اين سرسراها استفاده كن",
"Dynamic content blocks" => "بلوك محتواي پويا",
"use dynamic  content" => "از محتوي پويا استفاده كن",
"use rss module" => "از اين ماژول RSS استفاده كن",
"use menu" => "از اين فهرست استفاده كن",
"phpLayersMenus" => "فهرست‌هاي لايه‌اي PHP",
"use phplayermenu" => "از اين فهرست لايه‌اي PHP استفاده كن ",
"Banner zones" => "قلمرو درفش‌ها(Banner Zones)",
"use banner zone" => "از قلمرو درفش استفاده كن",
"Admin newsletter subscriptions" => "مديريت اشتراك خبرنامه‌ها",
"list newsletters" => "فهرست خبرنامه‌ها",
"admin newsletters" => "مديريت خبرنامه‌ها",
"send newsletters" => "ارسال خبرنامه‌ها",
"Add a subscription newsletters" => "افزودن يك اشتراك خبرنامه",
"Add email:" => "افزودن پست الكترونيكي:",
"Add user:" => "افزودن كاربر:",
"Group users" => "كاربران گروه",
"Don't send confirmation mail" => "پست الكترونيكي 'تصديق' را ارسال نكن",
"Included group, group users and emails will be refreshed at each newsletter sending" => "در هر ارسال خبرنامه، گروه‌ها، كاربران گره‌ها و پست‌هاي الكترونيكي را تازه كن",
"admin newsletters template" => "مديريت الگوي خبرنامه‌ها",
"Create/edit newsletters" => "ايجاد/تغيير خبرنامه‌ها",
"There are individual permissions set for this newsletter" => "حقوق دسترسي فردي براي اين خبرنامه تنظيم شده است",
"Add unsubscribe instructions to each newsletter" => "دستورالعمل لغو عضويت را در تمام خبرنامه‌ها قرار بده",
"send newsletter" => "خبرنامه را بفرست",
"archives" => "بايگاني‌ها",
"EMail notifications" => "آگاه‌ساز‌هاي پست الكترونيكي‌اي",
"admin Email Notifications" => "مديريت اطلاع‌رساني‌هاي پست الكترونيكي",
"admin notifications template" => "مديريت الگوي اطلاع‌رساني‌ها",
"Add notification" => "افزودن آگاه‌ساز",
"A user registers" => "ثبت‌نام يك كاربر",
"A user submits an article" => "يك كاربر، يك مقاله ارائه مي‌دهد",
"Any wiki page is changed" => "يكي از صفحات ويكي تغيير كردند",
"PHP error" => "خطاهاي PHP",
"use admin email" => "از پست الكترونيك سرپرست استفاده كن",
"object" => "شيء",
"No records found." => "هيچ ركوردي يافت نشد.",
"Admin Polls" => "مديريت راي‌گيري‌ها",
"List polls" => "فهرست راي‌گيري‌ها",
"Edit this poll" => "ويرايش اين راي‌گيري",
"Preview poll" => "پيش‌نمايش راي‌گيري",
"Edit or add poll options" => "افزودن يا ويرايش اختيارات راي‌گيري‌ها",
"Option" => "اختيار(Option)",
"Poll options" => "اختيارات راي‌گيري‌ها",
"votes" => "راي",
"admin polls" => "مديريت راي‌گيري‌ها",
"admin polls template" => "مديريت الگوي راي‌گيري‌ها",
"configure polls" => "پيكربندي راي‌گيري‌ها",
"Set last poll as current" => "آخرين راي‌گيري را راي‌گيري جاري قرار بده",
"Close all polls but last" => "بجر آخرين راي‌گيري، ما بقي را ببند",
"Activate all polls" => "تمام راي‌گيري‌ها را فعال كن",
"Create/edit Polls" => "ايجاد/ويرايش راي‌گيري",
"PublishDate" => "تاريخ انتشار",
"Admin Quicktags" => " مديريت تگ‌هاي سريع ",
"admin QuickTags" => " مديريت تگ‌هاي سريع ",
"tiki admin quicktags template" => "الگوي مديريت تگ‌هاي سريع تيكي",
"Create/Edit QuickTags" => "ايجاد/ويرايش تگ‌هاي سريع",
"label" => "برچسب",
"Insert (use 'text' for figuring the selection)" => "درج (از 'متن' براي مشخص كردن محدوده‌ انتخاب استفاده كنيد)",
"Category: wiki, tracker, etc." => "طبقه: ويكي، tracker، ساير",
"Path to the tag icon" => "مسير تمثال برچسب",
"Insert" => "درج",
"Icon" => "تمثال",
"Category" => "طبقه",
"Admin RSS modules" => "مديريت ماژول RSS",
"admin RSS modules" => "مديريت ماژول RSS",
"admin RSSmodules template" => "مديريت الگوي ماژول RSS",
"Content for the feed" => "محتواي تغذيه",
"Edit this RSS module:" => "اين ماژول RSS را ويرايش كن",
"Create new RSS module" => "يك ماژول جديد RSS ايجاد كن",
"show feed title" => "عنوان تغذيه را نمايش بده",
"show publish date" => "تاريخ انتشار را نمايش بده",
"Rss channels" => "كانال‌هاي RSS",
"Last update" => "آخرين به‌روز رساني",
"show pubdate" => "تاريخ انتشار را نمايش بده",
"Score System" => "سامانه‌ي امتيازدهي",
"security admin" => "مديريت امنيت",
"security admin tpl" => "الگوي مديريت امنيت",
"edit tpl" => "ويرايش الگو",
"PHP settings" => "تنظيمات PHP",
"PHP variable" => "متغيير PHP",
"Setting" => "تنظيمات",
"Risk Factor" => "ضريب خطر",
"Explanation" => "توضيحات",
"Tikiwiki settings" => "تنظيمات تيكي‌ويكي",
"Tiki variable" => "متغيير تيكي‌ويكي",
"Check all tiki files" => "تمام پرونده‌هاي تيكي را كنترل كن",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "دقت كنيد كه اين كار ممكن است زمان بسيار زيادي بگيرد. لذا بهتر است قبل از اجراي آن، تنظيم مربوط به max_execution_time در پرونده‌ي php.ini را كنترل كنيد.",
"File checks" => "بررسي‌هاي پرونده",
"Filename" => "نام پرونده",
"State" => "وضعيت",
"Admin Shoutbox Words" => "مديريت كلمات فريادگاه",
"admin shoutbox words" => "مديريت كلمات فريادگاه",
"admin shoutbox words template" => "الگوي مديريت كلمات فريادگاه",
"Add Banned Word" => "افزودن كلمات ممنوعه",
"Are you sure you want to delete this word?" => "آيا درمورد حذف اين كلمه مطمئن هستيد؟",
"admin structures template" => "سرپرستي الگوي ساختارها",
"Structure ID" => "شناسه‌ي ساختار",
"export pages" => "صدور صفحه",
"dump tree" => "dumpكردن درختواره",
"create webhelp" => "ساخت كمك وبي",
"view webhelp" => "مشاهده‌ي كمك وبي",
"Destroy the structure leaving the wiki pages" => "هنگام خروجي از صفحات ويكي، ساختار آن‌ها را نابود كن",
"Destroy the structure and remove the pages" => "ساختار را نابود كن و صفحات را حذف نما",
"Create new structure" => "ايجاد ساختار جديد",
"Use single spaces to indent structure levels" => "براي مشخص كردن سطوح ساختار از يك 'فاصله' استفاده كنيد",
"Alias" => "نام مستعار",
"tree" => "درختواره",
"create new structure" => "ايجاد ساختار جديد",
"Edit survey questions" => "ويرايش سئوالات نظرسنجي‌",
"survey stats" => "آمار نظرسنجي‌",
"this survey stats" => "وضعيت اين نظرسنجي‌",
"edit this survey" => "ويرايش اين نظرسنجي‌",
"admin surveys" => "مديريت نظرسنجي‌ها",
"Create/edit questions for survey" => "ساخت/ويرايش سئوال براي نظرسنجي‌",
"Question" => "سئوال",
"One choice" => "تك انتخابي",
"Multiple choices" => "چند انتخابي",
"Short text" => "متن كوتاه",
"Rate (1..5)" => "امتياز (از 1 تا 5)",
"Rate (1..10)" => "امتياز (از 1 تا 10)",
"Options (if apply)" => "اختيارات (اگر قابل استفاده باشند)",
"Questions" => "سئوالات",
"question" => "پرسش‌گر",
"administer surveys template" => "اداره كردن الگوي نظرسنجي‌ها",
"list surveys" => "فهرست نظرسنجي‌ها",
"Edit this Survey:" => "ويرايش اين نظرسنجي:‌",
"Create New Survey" => "ايجاد نظرسنجي جديد‌",
"There are individual permissions set for this survey" => "حقوق دسترسي فردي براي اين نظرسنجي تعيين شده است‌",
"status" => "آمار",
"questions" => "سئوالات",
"active perms" => "حقوق دسترسي فعال",
"system admin" => "مديريت سيستم",
"system admin tpl" => "الگوي مديريت سامانه",
"Exterminator" => "منهدم كننده",
"Empty" => "تخليه شود",
"files" => "پرونده",
"Templates compiler" => "گردآوري كننده‌ي الگوها",
"Compile" => "گردآوري كن(compile)",
"Fix UTF-8 Errors in Tables" => "رفع اشكالات UTF-8 در جداول",
"Warning: Make a backup of your Database before using this function!" => "اخطار: قبل از استفاده از اين تابع، يك نسخه‌ي پشتيبان از بانك اطلاعاتي خود تهيه كنيد!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "اخطار: اگر سعي در تبديل جداول بزرگ داشته داريد، بيشينه زمان اجرا را در پرونده‌ي php.ini خود بالا ببريد!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "اي تابع، رشته‌هاي كدشده با استاندارد ISO-8859-1 را در جداول شما به UTF-8 تبديل مي‌كند.",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "اگر شما محتوايي را با تيكي &lt; 1.8.4 تهيه كرده باشيد و charsetپيش‌فرض در apache هروي ISO-8859-1 باشد، اين كار احتمالا ضروري است.",
"UTF-8 Errors fixed" => "خطاهاي رفع شده‌ي UTF-8",
"Table" => "جدول",
"Field" => "ستون",
"Investigate" => "استفسار(Investigate)",
"Fix it" => "ترميمش كن",
"Admin Topics" => "مديريت عناوين",
"admin topics template" => "الگوي مديريت عناوين",
"Create a new topic" => "ايجاد يك عنوان جديد",
"Topic Name" => "نام عنوان",
"Upload Image" => " بارگذاري تصوير",
"List of topics" => "فهرست عناوين",
"Active?" => "فعال؟",
"Articles (subs)" => "زير مقالات",
"topic image" => "تصوير موضوع",
"Remove with articles" => "حذف با مقالات",
"Activate" => "فعال شود",
"Deactivate" => "غيرفعال شود",
"Admin tracker" => "مديريت tracker",
"Edit this tracker" => "ويرايش اين tracker",
"View this tracker items" => "نمايش اقلام اين tracker",
"Edit tracker fields" => "ويرايش ستون‌هاي tracker",
"Is column visible when listing tracker items?" => "آيا اين ستون هنگام نمايش فهرست اقلام tracker نمايش داده شود؟",
"Column links to edit/view item?" => "از طريق اين ستون بتوان فقره را ويرايش كرد؟",
"Column is searchable?" => "ستون قابل جستجو باشد؟",
"Field is public? (for use thru trackerlist plugin)" => "ستون عمومي است؟ (براي استفاده در pluginهاي trackerها)",
"Field is hidden?" => "ستون مخفي است؟",
"Field is mandatory?" => "پركردن اين ستون اجباري است؟",
"Tracker fields" => "ستون‌هاي tracker",
"Id" => "شناسه",
"isMain" => "اصلي؟",
"Tbl vis" => "قابل مشاهده؟",
"Searchable" => "قابل جستجو",
"Public" => "عمومي؟",
"Hidden" => "مخفي؟",
"Mandatory" => "اجباري؟",
"Import/export trackers fields" => "وارد/صادر كردن ستون‌هاي tracker",
"Import" => "ورود اطلاعات",
"admin Trackers tpl" => "مديريت الگوي trackerها",
"Edit fields for tracker" => "ويرايش ستون‌هاي trackerها",
"Edit tracker" => "ويرايش tracker",
"Create trackers" => "ايجاد trackerها",
"Import/export" => "واردات/صادرات",
"created" => "ايجاد شده",
"items" => "اقلام",
"active permissions" => "حقوق دسترسي فعال",
"fields" => "ستون‌ها",
"Create/edit trackers" => "ايجاد/ويرايش trackerها",
"There are individual permissions set for this tracker" => "حقوق دسترسي فردي براي اين tracker تعريف شده است",
"Show status" => "وضعيت را نمايش بده؟",
"Default status displayed in list mode" => "وضعيت پيش‌فرض براي نمايش در حالت فهرست",
"Show status to tracker admin only" => "وضعيت را تنها به سرپرست‌ها نمايش بده",
"New items are created with status" => "اقلام جديد با اين وضعيت ايجاد شوند:",
"Authoritative status for modified items" => "وضعيت‌ها مجاز براي اقلام ويرايش شده:",
"No change" => "بدون تغيير",
"Item creator can modify his items?" => "آيا ايجاد كننده‌ي يك فقره، مي‌تواند آن را تغيير دهد؟",
"The tracker needs a user field with the option 1" => "(tracker به يك رشته‌ي كاربري option برابر 1 نياز دارد)",
"Member of the default group of creator can modify items?" => "اعضاي گروه پيش‌فرض كاربران ايجاد كننده مي‌توانند اقلام را ويرايش كنند؟",
"Show creation date when listing tracker items?" => "نمايش تاريخ ايجاد در فهرست اقلام trakcerها؟",
"Show lastModif date when listing tracker items?" => "نمايش آخرين تاريخ تغيير در فهرست اقلام trakcerها؟",
"What field is used for default sort?" => "اقلام به‌صورت پيش‌فرض به كدام ترتيب باشند؟",
"What is default sort order in list?" => "ترتيب پيش‌فرض در داخل فهرست چيست؟",
"ascending" => "صعودي",
"descending" => "نزولي",
"Tracker items allow ratings?" => "امكان امتيازدهي به اقلام trackerها؟",
"with values" => "با مقادير",
"and display rating results in listing?" => "و امتيازات را در فهرست نمايش بده؟",
"Tracker items allow comments?" => "امكان نظردهي درخصوص اقلام؟",
"and display comments in listing?" => "و نظرات را در فهرست نمايش بده؟",
"Tracker items allow attachments?" => "امكان ضميمه كردن به اقلام؟",
"and display attachments in listing?" => "و نمايش ضميمه‌ها در فهرست",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "اختيارات در نمايش ضمايم (از اعداد براي ترتيب‌دهي استفاده كنيد، 0(صفر)ها نمايش داده نمي‌شوند و اعداد منفي در popupها نمايش داده مي‌شوند.",
"filename" => "نام پرونده",
"downloads" => "دريافت",
"filesize" => "حجم پرونده",
"version" => "نسخه",
"filetype" => "نوع پرونده",
"longdesc" => "توضيحات",
"Import/export trackers" => "وارد/صادر كردن trackerها",
"admin groups" => "مديريت گروه‌هاي كاربري",
"admin groups template" => "الگوي مديريت گروه‌هاي كاربري",
"Add new group" => "اضافه كردن گروه جديد",
"List" => "فهرست",
"Edit group" => "ويرايش گروه",
"Members" => "اعضا",
"Add a new group" => "افزودن يك گروه جديد",
"List of existing groups" => "فهرست گروه‌هاي موجود",
"Number of displayed rows" => "تعداد رديف‌هايي كه بايد نمايش داده شود",
"Includes" => "شامل",
"assign permissions" => "تخصيص حقوق دسترسي به ",
"Include" => "شامل",
"Group Homepage" => "صفحه‌ي مبدا گروه‌",
"Use wiki page name or full URL" => "از نام صفحات ويكي و يا URL كامل استفاده كنيد",
"Group Information Tracker" => "tracker اطلاعات گروه‌ها",
"choose a group tracker ..." => "يك tracker گروه انتخاب كنيد",
"choose a field ..." => "يك ستون انتخاب كنيد ...",
"admin" => "مديريت تقويم‌ها",
"Users Information Tracker" => "tracker اطلاعات كاربران",
"choose a users tracker ..." => "يك tracker كاربر انتخاب كنيد...",
"Group tracker item : {\$groupitemid}" => "فقره tracker فقره : {\$groupitemid}",
"Edit item" => "ويرايش فقره",
"Group tracker item not found" => "فقره tracker گروه يافت نشد",
"Create item" => "ايجاد فقره",
"Members List" => "فهرست اعضا",
"users in group" => "كاربران در گروه",
"List all members" => "فهرست تمام اعضا",
"admin users" => "مديريت كاربران",
"admin users template" => "الگوي مديريت كاربران",
"Add a new user" => "اضافه كردن يك كاربر جديد",
"Edit user" => "ويرايش كاربر",
"Change user preferences" => "تغيير تنظيمات كاربر",
"edit account settings" => "ويرايش تنظيمات حساب كاربر",
"Never" => "هيچ‌وقت!",
"Assign Group" => "قرار دادن كاربر در گروه",
"select all" => "انتخاب همه",
"Perform action with checked:" => "با انتخاب شده‌ها:",
"manage group assignments" => "عضويت گروه‌هايشان رو مديريت كن",
"set default groups" => "غضو گروه‌هاي كاربري پيش‌فرض كن",
"Assign selected to" => "انتخاب شده‌ها را منتصب كنيد به",
"Remove selected from" => "انتخاب شده‌ها را حذف كنيد از",
"the following groups:" => "گروه‌هاي ذيل:",
"Set the default group of the selected users to" => "گروه پيش‌فرض كاربران منتخب را به اين گزينه تنظيم كن",
"assign to groups" => "انتصاب به گروه‌ها",
"Pass" => "كلمه عبور",
"Again" => "تكرار كلمه‌ي عبور",
"Registration" => "ثبت‌نام",
"Batch upload (CSV file):" => " بارگذاري دسته‌اي(Batch upload)",
"Overwrite" => "روي اطلاعات قبلي بنويس",
"User tracker item : {\$usersitemid}" => "فقره tracker كاربر: {\$usersitemid}",
"Batch Upload Results" => "نتيجه‌ي بارگذاري دسته‌اي",
"Added users" => "كاربران اضافه شده",
"Rejected users" => "كاربران رد اعتبار شده",
"Reason" => "مشكل:",
"Admin Article Types" => "مديريت انواع مقالات",
"Article Types tpl" => "الگوي انواع مقالات",
"Shows up in the drop down list of article types" => "در فهرست كركره‌اي انواع مقالات نمايش داده مي‌شود.",
"Rate" => "نرخ",
"Allow ratings by the author" => "اجازه‌ي امتيازدهي به‌وسيله‌ي مولف.",
"Show before publish date" => "نمايش قبل از انتشار",
"non-admins can view before the publish date" => "كاربران عادي مي‌توانند قبل از تاريخ انتشار مشاهده كنند.",
"Show after expire date" => "نمايش بعد از انقضا",
"non-admins can view after the expire date" => "كاربران عادي مي‌توانند بعد از انقضا مشاهده كنند.",
"Heading only" => "فقط سرصفحه",
"No article body, heading only" => "بدون متن، تنها سرصفحه",
"Allow comments for this type" => "نظردهي براي اين نوع مجاز است",
"Comment Can Rate Article" => "نظرات در امتياز دخيل‌اند",
"Allow comments to include a rating value" => "نظرات در تعيين امتياز مقاله تاثير دارند.",
"Show image" => "نمايش تصوير",
"Show topic or own image" => "عنوان يا تصوير خود را نمايش بده.",
"Show avatar" => "نمايش شكلك",
"Show author's avatar" => "شكلك مؤلف را نمايش بده",
"Show author" => "نمايش مؤلف",
"Show author name" => "نام مؤلف را نمايش بده",
"Show publish date" => "تاريخ تاليف را نمايش بده",
"Show expire date" => "تاريخ انقضا را نمايش بده",
"Show reads" => "نمايش خوانده‌شدن",
"Show the number of times the article was read" => "تعداد دفعاتي كه اين مقاله خوانده شده را نمايش بده",
"Show size" => "حجم را نمايش بده",
"Show the size of the article" => "حجم مقاله را نمايش بده",
"Show topline" => "نمايش خط مقدم",
"Show a small title over the title" => "يك عنوان كوچك بالاي عنوان اصلي نمايش بده",
"Show subtitle" => "نمايش زيرنويس",
"Show the subtitle" => "،نمايش زيرنويس!",
"Show source" => "نمايش منبع",
"Show link to source after article body" => "پس از متن مقاله، پيوند به منبع را نمايش بده",
"Show Image Caption" => "عنوان تصوير را نمايش بده",
"Show a legend under the image" => "علائم و اختصارات را زير تصوير نمايش بده",
"Show Language" => "نمايش زبان",
"Show the language" => "زبان را نمايش بده",
"Creator can edit" => "امكان ويرايش خالق",
"The person who submits an article of this type can edit it" => "شخصي كه مقاله‌اي از اين دسته را ارائه كرده است، بتواند آن‌را ويرايش كند",
"Delete" => "حذف",
"Delete this type" => "حذف اين نوع",
"List of types" => "فهرست انواع",
"Show lang" => "نمايش زبان",
"Review" => "مرور",
"Classified" => "طبقه‌بندي شده",
"Create a new type" => "ساخت نوع جديد",
"Assign permissions to group" => "تخصيص حقوق دسترسي به گروه كاربري ",
"Edit Article" => "ويرايش مقاله",
"edit article tpl" => "الگوي ويرايش مقالات",
"Back to groups" => "بازگشت به گروه‌ها",
"Group Information" => "اطلاعات گروه",
"Desc" => "توضيحات",
"Create level" => "ايجاد مرلحه",
"all permissions in level" => "تام حقوق دسترسي در مرحله",
"all" => "همه موارد",
"level" => "مرحله",
"Assign user" => "تخصيص كاربر",
"to groups" => "به گروه(هاي)",
"User Information" => "اطلاعات كاربر",
"Default Group" => "گروه پيش‌فرض",
"Available groups" => "گروه‌هاي موجود",
"assign perms to this group" => "حقوق دسترسي اختصاص يافته به اين گروه",
"to" => "تا",
"save_to" => "to",
"backlinks to" => "پيوندهاي معكوس به",
"No backlinks to this page" => "هيچ پيوند معكوسي براي اين صفحه وجود ندارد",
"admin backups" => "مديريت نسخ پشتيبان",
"admin admin tpl" => "مديريت الگوي مديريت",
"List of available backups" => "فهرست نسخ پشتيبان موجود",
"Restoring a backup" => "بازيابي يك نسخه‌ي پشتيبان",
"Warning!" => "اخطار!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "بازيابي يك نسخه‌ي پشتيبان، تمام اطلاعات بانك اطلاعاتي تيكي شما را نابود خواهد كرد. تمام جداول شما با اطلاعات موجود در نسخه‌ي پشتيبان جايگزين خواهند شد",
"Click here to confirm restoring" => "براي تاييد بازيابي نسخه‌ي پشتيبان، اين‌جا را كليك كنيد",
"Create new backup" => "تهيه‌ي يك نسخه‌ي پشتيبان جديد",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "تهيه‌ي نسخ پشتيبان ممكن است مدت زمان زيادي به طول انجامد. اگر فرايند تكميل نشود، شما يك صفحه‌ي خالي مشاهده خالي كرد. بهتر از حداكثر زمان اجراي دستخط(script)ها را در پرونده‌ي php.ini خود بالا ببريد.",
"Your image gallery storage is set to \"{\$gal_use_dir}\", you will need to backup this using FTP or SCP." => "منبع ذخيره‌ي سراسري تصاوير شما بر روي  \"{\$gal_use_dir}\", تنظيم شده است. بايد از ظريق FTP يا SCP از آن پشتيبان تهيه كنيد",
"Your file gallery storage is set to \"{\$fgal_use_dir}\", you will need to backup this using FTP or SCP." => "منبع ذخيره‌ي سراسري پرونده‌ي شما بر روي  \"{\$fgal_use_dir}\", تنظيم شده است. بايد از ظريق FTP يا SCP از آن پشتيبان تهيه كنيد",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "درصورتي كه انجمن‌هاي شما پرونده‌هايي خارج از بانك اطلاعاتي دارند، بايد از آن‌ها به كمك FTP با SCP به‌صورت جداگانه پشتيبان تهيه كنيد.",
"Upload a backup" => "بارگذاري يك نسخه‌ي پشتيبان",
"Upload backup" => "بارگذاري نسخ پشتيبان",
"Edit Post" => "ويرايش الصاق",
"view blog" => "مشاهده‌ي بلاگ",
"list blogs" => "فهرست بلاگ‌ها",
"Note: if you want to use images please save the post first and you\nwill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\nor use the image URL to include images using the WYSIWYG editor. " => "نكته: براي استفاده از تصاوير، لطفا متن خود را الصاق كنيد تا قادر به ايجاد/ويرايش تصاوير شويد. از &lt;img&gt براي قرار دادن تصوير در متن نوشته شده‌ي خود و يا از URL تصوير براي افزودن تصاوير در ` WYSIWYG استفاده كنيد.",
"Use ...page... to separate pages in a multi-page post" => "براي جدا كردن صفحات در يك الصاق چندصفحه‌اي، از ...page... استفاده كنيد",
"Upload image for this post" => "بارگذاري تصوير براي اين الصاق",
"Trash" => "خاكروبه",
"Mark entry as private:" => "اين الصاق، خصوصي است",
"Send trackback pings to:" => "pingهاي trackback را به اين URIها بفرست:",
"(comma separated list of URIs)" => "URIها را با كاما(؛)از هم جدا كنيد",
"save and exit" => "ذخيره كن و خارج شو",
"Made with" => "ساخته شده با",
"powered by" => "فراهم شده به‌وسيله‌ي",
"Wiki RSS" => "RSS ويكي",
"Blogs RSS" => "RSS بلاگ‌ها",
"Articles RSS" => "RSS مقالات ",
"Image Galleries RSS" => "RSS سرسراهاي تصاوير",
"File Galleries RSS" => "RSS سرسراهاي پرونده",
"Forums RSS" => "RSS انجمن‌ها",
"Maps RSS" => "RSS نقشه‌ها",
"admin category" => "مديريت طبقه",
"Browse in" => "مرور در",
"Wiki pages" => "صفحات ويكي",
"Sheets" => "ورق‌ها",
"search category" => "طبقه را بگرد",
"deep" => "عميق",
"Hide subcategories objects" => "اشياء زيرطبقات را مخفي كن",
"Show subcategories objects" => "اشياء زيرطبقات را هم نشان بده",
"Objects" => "شيء",
"Browsing Gallery" => "مرور سرسرا",
"edit gallery" => "ويرايش سرسرا",
"rebuild thumbnails" => "تصويرك‌ها را مجددا بساز",
"upload image" => "بارگذاري تصوير",
"list gallery" => "نمايش اقلام",
"Sort Images by" => "تصاوير مرتب بر اساس",
"Subgallery" => "زير سرسرا",
"hit" => "ضربه(hit)",
"original size" => "اندازه‌ي سازمان",
"rotate right" => "چرخش به راست",
"rotate" => "چرخش",
"popup" => "popup",
"Browsing Image" => "مرور تصوير",
"return to gallery" => "بازگشت به سرسرا",
"edit image" => "ويرايش تصوير",
"first image" => "اولين تصوير",
"smaller" => "كوچكتر",
"bigger" => "بزرگتر",
"prev image" => "تصوير قبلي",
"next image" => "تصوير بعدي",
"last image" => "آخرين تصاوير",
"Click to zoom" => "براي بزرگنمايي اين‌جا را كليك كنيد",
"Popup window" => "پنجره‌ي Popup",
"popup window" => "پنجره‌ي popup",
"Image Name" => "نام تصوير",
"Latitude (WGS84/decimal degrees)" => "عرض جغرافيايي (درجه‌ي دهدهي بر اساس WGS84)",
"Longitude (WGS84/decimal degrees)" => "طول جغرافيايي (درجه‌ي دهدهي بر اساس WGS84‌)",
"Move image" => "انتقال تصوير",
"You can view this image in your browser using" => "به اين طريق مي‌توانيد تصوير را در مرورگر خود ببينيد",
"You can include the image in an HTML page using one of these lines" => "به كمك يكي از اين خطوط مي‌توانيد تصوير دلخواه خود را در يك صفحه‌ي HTML بگنجانيد",
"You can include the image in a tiki page using one of these lines" => "به كمك يكي از اين خطوط مي‌توانيد تصوير دلخواه خود را در يك صفحه‌ي تيكي بگنجانيد",
"add item" => "افزودن فقره",
"Edit/Create" => "ويرايش/ساخت",
"Date Selector" => "انتخاب‌گر تاريخ",
"click to navigate" => "براي هدايت اين‌جا را كليك كنيد",
"Focus:" => "تمركز:",
"month" => "ماه",
"change focus" => "تغيير تمركز",
"quater" => "يك چهارم",
"quarter" => "چهارم",
"semester" => "نيم‌سال",
"year" => "سال",
"End" => "پايان",
"details" => "جزئيات",
"Hours" => "ساعت",
"h" => "ساعت",
"+" => "+",
"Group Calendars" => "تقويم‌هاي گروهي",
"check / uncheck all" => "انتخاب همه/هيچكدام",
"Tools Calendars" => "تقويم‌ها ابزارها",
"Edit Calendar Item" => "ويرايش فقره جديد در تقويم",
"New Calendar Item" => "ايجاد فقره‌ي جديد در تقويم",
"or create a new category" => "يا يك طبقه‌ي جديد ايجاد كنيد",
"Location" => "محل",
"or create a new location" => "يا يك محل جديد ايجاد كنيد",
"Organized by" => "سازماندهي شده به‌وسيله‌ي",
"comma separated usernames" => "نام‌هاي كاربر(جداشده به‌وسيله‌ي كاما)",
"Participants" => "شركت‌كنندگان",
"comma separated username:role" => "نام‌هاي كاربر(جداشده به‌وسيله‌ي كاما): قانون",
"with roles" => "؛با قوانين",
"Chair" => "مقر",
"Optional" => "اختياري",
"Syntax error" => "خطا در نحو",
"Format: mm/dd/yyyy hh:mm<br />...See strtotime php function" => "شكل: mm/dd/yyyy hh:mm<br />...تابع strtotime php را ببينيد",
"Format: mm/dd/yyy hh:mm" => "شكل: mm/dd/yyy hh:mm",
"Event ID" => "شناسه‌ي رويداد",
"Tentative" => "آزمايشي",
"Confirmed" => "تاييد شد",
"Cancelled" => "لغو شد",
"duplicate" => "تكراري است",
"Add Calendar Item" => "افزوردن فقره در تقويم",
"Calendrier" => "تقويم‌وار!",
"Assign permissions to category" => "تخصيص حقوق دسترسي به طبقه ",
"Current permissions for this category" => "دسترسي‌هاي جاري براي اين طبقه",
"permission" => "حقوق دسترسي",
"remove from this category &amp; all its children" => "از اين طبقه و طبقات فرزندش حذف كن",
"remove from this category only" => "تنها از اين طبقه حذفش كن",
"No individual permissions global permissions apply" => "بدون حقوق دسترسي فردي. حقوق دسترسي عمومي اعمال مي‌شوند.",
"Assign permissions" => "تخصيص حقوق دسترسي به ",
"to group" => "را به گروه",
"this category &amp; all its children" => "اين طبقه و تمام طبقات فرزندانش",
"this category only" => "تنها اين طبقه",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "تخصيص حقوق دسترسي براي  <b>تمام فرزندان</b> براي رسيدن به بهترين عملكرد پيشنهاد مي‌شود",
"Change password enforced" => "تغيير كلمه‌ي عبور اجباري است",
"Old password" => "كلمه‌ي عبور قبلي",
"Again please" => "دوباره لطفا",
"Welcome to the Tiki Chat Rooms" => "به اتاق‌هاي گفتگوي تيكي خوش‌آمديد‌",
"Please select a chat channel" => "لطفا يك كانال گپ‌زني انتخاب كنيد",
"Nickname" => "نام مستعار",
"enter chat room" => "وارد اتاق گپ‌زني شو",
"There are no channels setup, please contact a site admin" => "هيج كانالي آماده نيست، لطفا با مدير پايگاه تماس بگيريد",
"Chatroom" => "اتاق گپ‌زني",
"Active Channels" => "كانال‌هاي فعال",
"Users in this channel" => "كاربران اين كانال",
"Browser not supported" => "مرورگر وب شما پشتيباني نمي‌شود(نمي‌توانيد با اين مرورگر از گپ‌زني‌ها استفاده كنيد)",
"Channel Information" => "اطلاعات كانال",
"Channel" => "كانال",
"Ratio" => "نرخ",
"Use :nickname:message for private messages" => "براي پيغام‌هاي شخصي، از تركيب :نام متسعار:پيغام استفاده كنيد.",
"Use [URL|description] or [URL] for links" => "براي پيوندها از [URL|description] يا [URL] استفاده كنيد.",
"Use (:smileyname:) for smileys" => "براي صورتك‌ها از (:نام صورتك:) استفاده كنيد:",
"Create PDF" => "ساخت PDF",
"PDF Settings" => "تنظيمات PDF",
"Font" => "قلم",
"Textheight" => "ارتفاع متن",
"Height of top Heading" => "ارتفاع سرصفحه‌ي بالايي",
"Height of mid Heading" => "ارتفاع سرصفحه‌ي وسطي",
"Height of inner Heading" => "ارتفاع سرصفحه‌ي مياني",
"tbheight" => "ارتفاع جدول",
"imagescale" => "مقياس تصوير",
"Automatic Page Breaks" => "جدا كردن خودكار صفحات",
"Select Wiki Pages" => "انتخاب صفحات ويكي",
"add page" => "صفحه را اضافه كن",
"remove page" => "صفحه را حذف كن",
"reset" => "بازنشاني",
"Send a message to us" => "يك پيغام براي ما بفرستيد",
"Contact us by email" => "تماس با ما از طريق پست الكترونيكي",
"click here to send us an email" => "براي ارسال يك پست الكترونيكي به ما، اين‌جا را كليك كنيد",
"Create WebHelp" => "ساخت كمك تحت وب",
"You can browse the generated WebHelp here" => "شما مي‌توانيد 'كمك تحت‌وب' توليد شده را اينجا مرور كنيد",
"Structure" => "ساختار",
"Top page" => "صفحه‌ي بالا",
"Tiki Debugger Console" => "ميز رفع اشكال تيكي",
"Close" => "ببند",
"Current URL" => "URL كنوني",
"Command" => "دستور",
"exec" => "اجرا",
"Type <code>help</code> to get list of available commands" => "براي دريافت فهرستي از دستورات موجود، را وارد كنيد<code>help</code>",
"Add a new site" => "افزودن يك پايگاه جديد",
"You cannot add sites until Directory Categories are setup." => "قبل از تنظيم طبقات پوشه‌ها، نمي‌توانيد پايگاهي اضافه كنيد.",
"Please contact the Site Administrator" => "لظفا با سرپرست پايگاه تماس بگيريد.",
"Site added" => "پايگاه اضافه شد",
"The following site was added and validation by admin may be needed before appearing on the lists" => "اين پايگاه اضافه شده است و تاييد اعتبار به‌وسيله‌ي سرپرست قبل از نمايش در فهرست لازم است",
"Add or edit a site" => "افزودن يا ويرايش يك پايگاه وب",
"Name:" => "نام:",
"URL:" => "آدرس اينترنتي(URL):",
"Categories:" => "طبقات:",
"Is valid" => "آيا معتبر است؟",
"Directory Administration" => "مديريت پوشه‌ها",
"admin directory tpl" => "الگوي مديريت پوشه",
"Statistics" => "آمار",
"There are" => "تعداد",
"invalid sites" => "پايگاه بي‌اعتبار",
"valid sites" => "پايگاه معتبر",
"Users have visited" => "كاربران ديده‌اند:",
"sites from the directory" => "عدد از اين پوشه.",
"Users have searched" => "كاربران جستجو كرده‌اند:",
"times from the directory" => "بار از اين پوشه.",
"Admin sites" => "مديريت پايگاه‌ها",
"Admin category relationships" => "مديريت ارتباط طبقات",
"Validate links" => "تاييد اعتبار پيوندها",
"Settings" => "تنظيمات",
"browse" => "مرور",
"related" => "مرتبط",
"sites" => "پايگاه‌ها",
"validate" => "تاييد",
"Admin directory categories" => "مديريت طبقات پوشه‌ها",
"admin directory categories tpl" => "الگوي مديريت طبقات پوشه",
"Parent category" => "طبقه‌ي مادر",
"Add a directory category" => "افزودن يك طبقه‌ي پوشه‌اي",
"Edit this directory category" => "اين پوشه‌ي طبقات را ويرايش كن",
"Children type" => "انواع فرزند",
"Most visited sub-categories" => "پر بيننده‌ترين زيرطبقات",
"Category description" => "شرح طبقه",
"Random sub-categories" => "زيرطبقات تصادفي",
"Maximum number of children to show" => "بيشينه تعداد فرزنداني كه نمايش داده مي‌شود",
"Allow sites in this category" => "پايگاه‌ها در اين طبقه مجازند",
"Show number of sites in this category" => "تعداد پايگاه‌ها در اين طبقه را نمايش بده",
"Editor group" => "گروه ويراستار",
"Subcategories" => "زيرطبقات",
"cType" => "نوع طبقه",
"allow" => "مجاز",
"count" => "تعداد",
"editor" => "ويراستار",
"relate" => "ارتباط",
"Admin related categories" => "مديريت طبقات مرتبط",
"Admin Directory Related " => "مديريت پوشه‌هاي مرتبط",
"directory admin related tpl" => "الگوي مديريت پوشه‌ي مرتبط",
"Add a related category" => "افزودن يك طبقه‌ي مرتبط",
"Mutual" => "دوجانبه",
"Related categories" => "طبقات مرتبط",
"Admin Directory Sites" => "مديريت پايگاه‌هاي پوشه",
"Admin Directory Sites tpl" => "مديريت الگوي پايگاه‌هاي پوشه",
"country" => "كشور",
"new sites" => "پايگاه‌هاي جديد",
"cool sites" => "پايگاه‌هاي بامزه(cool)",
"add a site" => "اضافه كردن يك پاگاه",
"any" => "هركدام از",
"in entire directory" => "در بين تمام پوشه‌ها‌",
"in current category" => "در بين طبقه‌ي جاري",
"search" => "جستجو",
"Sort by" => "مرتب بر اساس",
"name (desc)" => "نام (نزولي)",
"name (asc)" => "نام (صعودي)",
"hits (desc)" => "ضربت-hit- (نزولي)",
"hits (asc)" => "ضربت-hit- (صعودي)",
"creation date (desc)" => "تاريخ ايجاد (نزولي)",
"creation date (asc)" => "تاريخ ايجاد (صعودي)",
"last updated (desc)" => "آخرين تغيير (نزولي)",
"last updated (asc)" => "آخرين تغيير (صعودي)",
"sort" => "مرتب كن",
"Added" => "اضافه شد",
"Last updated" => "تاريخ آخرين تغيير",
"Total categories" => "مجموع طبقهها",
"Total links" => "مجموع پيوندها",
"Links to validate" => "پيوندهايي كه بايد بررسي شوند",
"Searches performed" => "جستجو انجام شده",
"Total links visited" => "مجموعه صفحاتي كه ديده شده",
"Directory ranking" => "امتيازدهي به پوشه‌ها",
"Search results" => "نتيجه‌ي جستجو",
"Validate sites" => "پايگاه را تاييد اعتبار كنيد",
"Validate Sites" => "پايگاه را تاييد اعتبار كنيد",
"directory validate sites tpl" => "الگوي پايگاه تاييد اعتبار پوشه",
"list articles" => "فهرست مقالات",
"view articles" => "مشاهده‌ي مقالات",
"Topline" => "خط بالايي",
"Subtitle" => "زيرنويس",
"Source" => "منبع",
"Author Name" => "نام مولف",
"Own Image" => "تصوير مخصوص",
"Use own image" => "از تصوير مخصوص استفاده كن؟",
"Float text around image" => "متن را حول تصوير شناور كن",
"Own image size x" => "طول تصوير اختصاصي",
"pixels" => "نقطه(پيكسل)",
"Own image size y" => "عرض تصوير اختصاصي",
"Image caption" => "عنوان تصوير",
"Heading" => "سرنامه(عنوان)",
"Body" => "مات",
"Use ...page... to separate pages in a multi-page article" => "از ...page... براي جداكردن صفحات در يك مقاله‌ي چندصفحه‌اي استفاده كنيد",
"Expiration Date" => "تاريخ انقضا",
"Edit or create banners" => "ويرايش يا ساخت درفش‌ها",
"List banners" => "فهرست درفش‌ها",
"URL to link the banner" => "URL براي پيوند درفش",
"Client" => "نرم‌افزار بخش كاربر",
"Max impressions" => "بيشينه تعداد نمايش",
"create zone" => "ايجاد قلمرو",
"Show the banner only between these dates" => "درفش را تنها در اين بازه‌ي تاريخي نمايش بده",
"From date" => "از تاريخ",
"To date" => "تا تاريخ",
"Use dates" => "هر هيچ حالت بعد از تاريخ فعال نباشد",
"Show the banner only in this hours" => "درفش را تنها در اين ساعات نمايش بده",
"Show the banner only on" => "درفش را تنها در اين روزها نمايش بده",
"Mon" => "دوشنبه",
"Tue" => "سه‌شنبه",
"Wed" => "چهارشنبه",
"Thu" => "پنج‌شنبه",
"Fri" => "جمعه",
"Sat" => "شنبه",
"Sun" => "يك شنبه",
"Select ONE method for the banner" => "تك شيوه براي درفش انتخاب كنيد",
"Use HTML" => "از HTML استفاده كن",
"HTML code" => "كد HTML",
"Use image" => "از تصوير استفاده كن:",
"Image:" => "تصوير:",
"Current Image" => "تصوير كنوني",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "از تصوير توليد شده توسط URL استفاده كن.(تصوير براي هر مشاهده به‌وسيله‌ي URL درخواست خواهد شد)",
"Use text" => "از متن استفاده كن",
"Text" => "متن",
"save the banner" => "درفش را ذخيره كن",
"Remove Zones (you lose entered info for the banner)" => "قلمروها را حذف كن(اطلاعات مربوط به درفش‌ها را از دست خواهيد داد)",
"Edit Blog" => "ويرايش بلاگ",
"Create Blog" => "ايجاد بلاگ",
"edit blog tpl" => "ويرايش الگوي بلاگ",
"Current heading" => "سرصفحه‌ي كنوني",
"There are individual permissions set for this blog" => "حقوق دسترسي فردي براي اين بلاگ تنظيم شده است",
"Number of posts to show" => "تعداد الصاق‌هايي كه بايد نشان داده شود",
"Allow other user to post in this blog" => "به ديگر كاربران اجازه‌ي الصاق در اين بلاگ را بده",
"Use titles in blog posts" => "از عنوان در الصاق‌هاي بلاگ استفاده كن",
"Allow search" => "اجازه‌ي جستجو را بده",
"Allow comments" => "اجازه‌ي نظردادن(commenting) را بده",
"Show user avatar" => "شكلك كاربر را نمايش بده",
"Blog heading" => "سرصفحه‌ي بلاگ",
"Edit Style Sheet" => "ويرايش سبك نگارش",
"Style Sheet" => "سبك نگارش",
"Cancel" => "لغو",
"choose a stylesheet" => "يك سبك نگارش انتخاب كنيد",
"try" => "تلاش",
"display" => "نمايش",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "پرونده‌هايي كه با -{\$user} آغاز مي‌شوند، قابل تغيير هستند، باقي تنها قابل كپي‌كردن و استفاده به عنوان مدل هستند.",
"wiki help" => "كمك از ويكي",
"Show Plugins Help" => "نمايش كمك در مورد Pluginها",
"For more information, please see <a href=\"{\$helpurl}WikiSyntax\">WikiSyntax</a>" => "براي اطلاعات بيشتر، لطفا نگاهي به <a href=\"{\$helpurl}WikiSyntax\">نحو ويكي</a> بياندازيد",
"Emphasis" => "تاكيد",
"italics" => "مورب",
"bold" => "پررنگ",
"both" => "هردو",
"Lists" => "فهرست‌ها",
"for bullet lists" => "براي فهرست گلوله‌اي",
"for numbered lists" => "براي فهرست شماره‌اي",
"for definiton lists" => "براي فهرست معنا",
"Wiki References" => "مرجع‌هاي ويكي",
"JoinCapitalizedWords or use" => "كلمات با حروف بزرگ را ادغام كن و يا از اين استفاده كن",
"page|desc" => "صفحه|توضحيات",
"for wiki references" => "براي مراجع ويكي",
"SomeName" => "نامي",
"prevents referencing" => "ممانعت از ارجاع‌دهي",
"External links" => "پيوندهاي خارجي",
"use square brackets for an external link: [URL] or [URL|link_description] or [URL|description|nocache]  (that last form prevents the local Wiki from caching the page; please use that form for large pages!)." => "از كروشه براي ويكي‌هاي خارجي استفاده كن: [URL] يا [URL|توضيح پيوند] يا [URL|توضيح|nocache] (كه مورد آخر از cache كردن صفحه توسط ويكي محلي جلوگيري مي‌كند؛ لطفا براي صفحات بزرگ از اين گزينه استفاده كنيد!).",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "براي يك ويكي خارجي، از 'نام ويكي خارجي': نام صفحه يا ((نام ويكي خارجي': نام صفحه)) استفاده كنيد",
"Multi-page pages" => "صفحات چندصفحه‌اي",
"use ...page... to separate pages" => "از ...page... براي جاسازس صفحات استفاده كن",
"Misc" => "متنوع",
"make_headings" => "ساخت سرصفحه‌ها",
"makes a horizontal rule" => "يك قانون افقي ايجاد كن",
"underlines text" => "متن را زيرخط دار كن",
"make a line break" => "يك خط افقي بكش",
"Title bar" => "ميله‌ي عنوان",
"creates a title bar" => "يك ميله‌ي عنوان مي‌سازد",
"displays an image" => "يك تصوير نمايش مي‌دهد",
"height width desc link and align are optional" => "پيوند توضيحات ارتفاع و عرض صف كردن‌ها اختياري‌اند",
"Non cacheable images" => "تصاوير غيرقابل Cache شدن",
"creates an editable drawing named foo" => "يك نقاشي قابل ويرايش با نام foo بساز",
"Tables" => "جداول",
"creates a table" => "يك جدول مي‌سازد",
"displays rss feed with id=n maximum=m items" => "تغذيه‌هاي RSS اي كه شناسه‌اش برابر n و حداكثر m فقره است را نمايش مي‍دهد",
"Simple box" => "جعبه‌ي ساده",
"Box content" => "محتواي جعبه",
"Creates a box with the data" => "يك جعبه با داده بساز",
"Will be replaced by the actual value of the dynamic content block with id=n" => "به‌وسيله‌ي بلاك محتواي پويا با شناسه‌ي برابر n جايگزين خواهد شد",
"Colored text" => "متن رنگي",
"some text" => "برخي متون",
"Will display using the indicated HTML color" => "با كمك رنگ مشخص شده‌ي HTML نمايش داده مي‌شود",
"Center" => "مركز",
"Will display the text centered" => "متن را در مركز نمايش خواهد داد",
"Non parsed sections" => "بخش تجزيه نشده",
"Prevents wiki parsing of the enclosed data." => "از تجزيه‌ي داده‌ي پيوست توسط ويكي ممانعت مي‌كند.",
"Preformated sections" => "شكل‌دهي اوليه‌ي بخش‌ها",
"Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done)." => "كد/متن‌هاي از پيش شكل گرفته را نمايش بده. هيچ پردازشي توسط ويكي داخل اين بخش انجام نخواهد شد.",
"Square Brackets" => "كروشه‌هاي مربع",
"Use [[foo] to show [foo]." => "از [[foo] براي نمايش[foo] استفاده كنيد.",
"Block Preformatting" => "شكل‌دهي اوليه را مسدود كن",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "متن پيش‌تاخته را با هر تعداد فاصله‌ي خالي را يك بلوك تك فاصله‌اي تبديل كن كه هنوز ساير دستورالعمل‌هاي شكل‌بندي ويكي را رعايت مي‌كند. از همان تعداد فاصله كه شما وارد كرده‌اي استفاده خواهد شد. توجه كنيد كه اين حالت از تك فاصله‌ها و خط شكن‌ها جلوگيري نمي‌كند؛ براي اين‌كار از ~pp~...~/pp~ استفاده كنيد.",
"Dynamic variables" => "متغييرهاي پويا",
"Inserts an editable variable" => "يك متغيير قابل ويرايش درج مي‌كند",
"Insert Module Output" => "درج خروجي ماژول",
"{literal}{MODULE(module=>some_module)}text{MODULE}{/literal}  can be used to insert the output of module \"some_module\" into your Wiki page. See <a href=\"{\$helpurl}PluginModule\">PluginModule</a> for more information. " => "{literal}{MODULE(module=>يك ماژول)}متن{MODULE}{/literal} مي‌تواند براي درج خروجي ماژول \"يك ماژول\" در صفحه‌ي ويكي شما استفاده شود. براي اطلاعات بيشتر، <a href=\"{\$helpurl}PluginModule\">PluginModule</a> را ببينيد.",
"Rendering Program Code" => "ترجمه‌ي كد برنامه",
"{literal}{CODE()}some code{CODE} {/literal} will render \"some code\" as program code. This plugin has other options; see <a href=\"{\$helpurl}PluginCode\">PluginCode</a>." => "{literal}{CODE()}يك‌سري كد{CODE} {/literal}، \"يك‌سري كد\" را به عنوان برنامه ترجمه خواهند كرد. اين Plugin  اختيارات ديگري نيز دارد؛ <a href=\"{\$helpurl}PluginCode\">كد Plugin</a> را ببينيد.",
"Direction" => "جهت",
"Table of contents" => "فهرست",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" فهرست محتويات صفحه‌ي جاري را مبني بر ساختار ()toc يا سرصفحه‌ي (maketoc) چاپ خواهد كرد.",
"Show Text Formatting Rules" => "قوانين شكل‌دهي متون را نمايش بده",
"No description available" => "توضيحي موجود نيست",
"Quicktags" => "تگ‌هاي سريع",
"italic" => "مورب",
"underline" => "زيرخط دار",
"table" => "جدول",
"table new" => "جدول جديد",
"external link" => "پيوند خارجي",
"wiki link'" => "پيوند ويكي'",
"heading1" => "سرصفحه‌ي 1",
"title bar" => "نوار عنوان",
"box" => "جعبه",
"rss feed" => "تعذيه‌ي RSS",
"dynamic content" => "محتواي پويا",
"tagline" => "خط برچسب(tagline)",
"hr" => "hr",
"center text" => "متن در وسط",
"colored text" => "متن رنگي",
"dynamic variable" => "متغيير پويا",
"New wms Metadata" => "فراداده‌ي WMS جديد",
"New Class" => "كلاس جديد",
"New Projection" => "افكنش جديد",
"New Query" => "درخواست جديد",
"New Scalebar" => "نوار مقياس جديد",
"New Layer" => "لايه‌ي جديد",
"New Label" => "برچسب جديد",
"New Reference" => "مرجع جديد",
"New Legend" => "فهرست علائم جديد",
"New Web" => "وب جديد",
"New Outputformat" => "شكل خروجي جديد",
"New Mapfile" => "پرونده‌ي نقشه‌ي جديد",
"special chars" => "حروف خاص",
"special characters" => "حروف خاص",
"admin quicktags" => "مديريت تگ‌هاي سريع",
"Edit Image" => "ويرايش تصوير",
"browse image" => "مرور تصوير",
"Edit successful!" => "ويرايش موفقيت‌آميز بود!",
"The following image was successfully edited" => "تصوير مقابل با موفقيت ويرايش شد",
"Image Description" => "شرح تصوير",
"Edit or ex/import Languages" => "ويرايش يا وارد/صادر كردن زبان",
"Edit and create Languages" => "ويرايش و ايجاد زبان‌ها",
"Im- Export Languages" => "واردات، صادرات زبان‌ها",
"Edit and create languages" => "ويرايش و ايجاد زبان‌ها",
"Create Language" => "ساخت زبان",
"Shortname" => "نام كوتاه",
"like" => "مانند",
"Longname" => "نام بلند",
"Select the language to edit" => "زبان را براي ويرايش انتخاب كنيد",
"Add a translation" => "يك ترجمه اضافه كن",
"Edit translations" => "ويرايش ترجمه",
"Translate recorded" => "ترجمه ظبط شد",
"Original" => "بكر",
"Translation" => "ترجمه",
"translate" => "ترجمه كن",
"reset table" => "جدول را بازبنشان",
"Program dynamic content for block" => "محتواي پوياي برنامه براي بلوك",
"create new block" => "يك بلوك جديد ايجاد كن",
"Return to block listing" => "به فهرست بلوك‌ها بازگرد",
"Block description: " => "توضيحات بلوك: ",
"Create or edit content" => "ساخت يا ايجاد محتوي",
"You are editing block:" => "شما در حال ويرايش اين بلاك هستيد:",
"Publishing date" => "تاريخ انتشار",
"Publishing Date" => "تاريخ انتشار",
"Project Object Created Successfully" => "شيء پروژه با موفقيت ساخته شد",
"Project Name:" => "نام پروژه:",
"Project Description:" => "توضيحات پروژه",
"Project Active" => "پروژه فعال است",
"Current Objects:" => "اشياء جاري:",
"Add a File Gallery" => "افزودن يك سرسراي پرونده",
"Listing configuration" => "پيكربندي فهرست‌سازي",
"icon" => "تمثال",
"id" => "شناسه",
"Name-filename" => "نام-نام پرونده",
"Filename only" => "تنها نام پرونده",
"Permission" => "حقوق دسترسي",
"Project Admin" => "مدير پروژه",
"Project Members" => "اعضاي پروژه",
"Registered" => "اعضا",
"Not Set" => "تنظيم نشده است",
"Edit question options" => "ويرايش اختيارات سئوالات",
"list quizzes" => "فهرست آزمون‌ها",
"quiz stats" => "وضعيت آزمون",
"this quiz stats" => "آمار اين آزمون",
"edit this quiz" => "اين آزمون را ويرايش كن",
"admin quizzes" => "مديريت آزمون‌ها",
"Create/edit options for question" => "ايجاد/ويرايش اختيارات براي سئوال‌ها",
"points" => "امتياز",
"Admin quizzes" => "مديريت آزمون‌ها",
"admin quizzes tpl" => "الگوي مديريت آزمون‌ها",
"Create/edit quizzes" => "ايجاد/تغيير آزمون‌ها ",
"There are individual permissions set for this quiz" => "براي اين آزمون، حقوق دسترسي فردي تنظيم شده است.",
"Quiz can be repeated" => "امكان شركت مجدد در آزمون وجود دارد",
"Store quiz results" => "نتايج آزمون‌ها را نگهداري كن",
"Immediate feedback" => "نتيجه را بلافاصله به كاربر اعلام كن",
"Show correct answers" => "جواب‌هاي صحيح را نمايش بده",
"Shuffle questions" => "سئوالات را درهم‌ريخته انتخاب كن",
"Shuffle answers" => "جواب‌ها را درهم ريخته نشان بده",
"Questions per page" => "تعداد سئوالات در هر صفحه",
"Quiz is time limited" => "زمان آزمون محدود است",
"Maximum time" => "بيشينه زمان",
"Passing Percentage" => "نمره‌ي قبولي",
"%" => "%",
"canRepeat" => "قابل تكرار",
"timeLimit" => "زمان آزمون",
"results" => "نتايج",
"Edit quiz questions" => "ويرايش سئوالات آزمون",
"edit quiz questions" => "سئوالات آزمون را ويرايش كن",
"edit quiz questions tpl" => "الگوي ويرايش سئوالات آزمون",
"Create/edit questions for quiz" => "ايجاد/ويرايش سئوال‌ها براي آزمون",
"Question Type" => "نوع سئوال",
"Import questions from text" => "سئوالات را از متن دريافت كن",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "دستورالعمل: سئوالات چندگزينه‌اي خود را در زير تايپ كنيد. در خط اول سئوال و در خطوط بعدي در هر خط پاسخ‌ها را وارد كنيد. سئوال‌هاي بعدي را با يك خط خالي از هم جدا كنيد. پاسخ‌هاي صحيح را با \"*\" مشخص كنيد (ستاره‌ي خالي، بدون گيومه).",
"Input" => "ورودي",
"maxScore" => "امتياز بيشينه",
"From Points" => "از امتياز",
"To Points" => "تا امتياز",
"Answer" => "پاسخ",
"Results" => "نتايج",
"answer" => "پاسخ",
"Modify Structure" => "اصلاح ساختار",
"You will remove" => "شما حذف خواهيد كرد:",
"and its subpages from the structure, now you have two options:" => "و زيرصفحات آن را از ساختار، حالا شما تو انتخاب داريد:",
"Remove only from structure" => "تنها از ساختار حذفش كن",
"Remove from structure and remove page too" => "از ساختار حذفش كن و خود صفحه را نيز حذف كن",
"Current Node" => "گره‌ي كنوني",
"Page alias" => "نام مستعار صفحه",
"Move" => "تغيير مكان",
"Promote" => "ارتقا",
"Previous" => "قبلي",
"Demote" => "تنزل",
"Add pages to current node" => "افزودن صفحه به گره‌ي كنوني",
"After page" => "پس از صفحه",
"create page" => "ساخت صفحه",
"Use pre-existing page" => "از صفحات موجود استفاده كن",
"Structure Layout" => "طرح‌بندي ساختار",
"Edit Submissions" => "ويرايش ارائه‌ها",
"edit submissions tpl" => "الگوي ويرايش ارائه‌ها",
"list submissions" => "فهرست ارائه‌ها",
"<b>*</b>=optional" => "<b>*</b>=اختياري",
"<b>Topline</b>=small line above Title" => "<b>خط اوليه</b>=خط كوچك بالاي تيتر",
"<b>زيرنويس</b>=small line below Title" => "<b>Subtitle</b>=خط كوچك بايين تيتر",
"<b>Source</b>=URL to article source" => "<b>منبع</b>=URLاي به منبع مقاله",
"EditTemplates" => "ويرايش الگوها",
"EditTemplates tpl" => "الگوي ويرايش الگوها",
"Template" => "الگو",
"Available templates" => "الگوهاي موجود",
"Template listing" => "فهرست الگوها",
"Edit a topic" => "ويرايش يك موضوع",
"Edit Translation:" => "ويررايش ترجمه:",
"edit translations" => "ويرايش ترجمه‌ها",
"edit translations template" => "الگوي ويرايش ترجمه‌ها",
"You must specify the object language" => "بايد زبان شيء را مشخص كنيد",
"The object doesn't exist" => "شيء وجود ندارد",
"The object doesn't have a language" => "شيء زباني ندارد",
"The object has already a translation for this language" => "اين شيء قبلا براي اين زبان ترجمه شده است",
"The object is already in the set of translations" => "اين شيء از قبل در مجموعه‌ي ترجمه‌ها وجود داشته است",
"Use this section to set the language of the version you are currently working on." => "از اين بخش براي تنظيم نسخه‌ي از زبان كه برروي آن كار مي‌كنيد استفاده كنيد",
"Set of Translations" => "مجموعه‌ي ترجمه‌ها",
"detach" => "جداسازي",
"add to the set" => "افزودن به مجموعه",
"Mods Install/uninstall" => "حذف/نصب حالات",
"Select the article for which the current article is the translation." => "مقاله‌اي كه اين مقاله ترجمه‌ي آن است را انتخاب كنيد",
"Translation of:" => "ترجمه‌ي",
"Enter the name of the page for which the current page is the translation." => "نام صفحه‌اي كه اين صفحه ترجمه‌ي آن است را وارد كنيد",
"Use rating" => "از امتيازدهي استفاده كن",
"disable" => "غيرفعال شده‌است",
"There is no available poll template." => "هيچ الگوي راي‌گيري‌اي وجود ندارد.",
"You should ask an admin to create them." => "براي ايجاد آن‌ها بايد از مديريت درخواست كنيد.",
"an existing poll" => "يك راي‌گيري موجود",
"Import HTML" => "واردات HTML",
"Try to convert HTML to wiki" => "Try to convert HTML to wiki",
"Admin ephemerides" => "مديريت سالنامه‌ها",
"admin Ephemerides tpl" => "مديريت الگوي سالنامه‌ها",
"All ephemerides" => "تمام سالنامه‌ها",
"Browse" => "مرور",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No events will be sent to you until the subscription is confirmed." => "از عضويت شما متشكريم. به‌زودي براي تاييد عضويت خود يك پيام دريافت خواهيد كرد. تا زماني كه عضوت را تاييد نكرده‌اي، هيچ رويدادي براي شما ارسال نخواهد شد.",
"Your email address was removed from the list of subscriptors." => "آدرس پست الكترونيكي شما از فهرست اعضا حذف شد",
"Subscription confirmed!" => "عضصويت تاييد شد",
"Subscribe to event" => "عضويت در رويداد",
"First Name:" => "نام:",
"Last Name:" => "نام خانوادگي:",
"Company:" => "سازمان:",
"Email:" => "پست الكترونيكي:",
"Subscribe" => "عضويت",
"Admin FAQ" => "مديريت FAQ",
"View FAQ" => "مشاهده‌ي FAQ",
"Edit this FAQ" => "ويرايش اين FAQ",
"new question" => "سئوال جديد",
"Edit FAQ questions" => "ويرايش سئوالات اين FAQ",
"Use a question from another FAQ" => "استفاده از يك سئوال در FAQ ديگر",
"FAQ questions" => "سئوالات FAQ",
"Suggested questions" => "سئوالات پيشنهاد شده",
"approve" => "تاييد",
"No suggested questions" => "بدون سئوال پيشنهادي",
"File Galleries tpl" => "الگوي سرسراهاي پرونده",
"configure listing" => "پيكربندي فهرست‌ها",
"Create a file gallery" => "ايجاد يك سرسراي پرونده",
"Edit this file gallery:" => "ويرايش اين سرسراي پرونده:",
"create new gallery" => "ايجاد سرسراي جديد",
"There are individual permissions set for this file gallery" => "حقوق دسترسي فردي براي اين سرسراي پرونده تنظيم شده است",
"Gallery is visible to non-admin users?" => "سرسرا براي كاربران عادي(غير سرپرست) نيز قابل ديدن است؟",
"Max description display size" => "بيشينه اندازه‌ي نمايش شرح",
"Max Rows per page" => "بيشينه سطرها در هر صفحه",
"Other users can upload files to this gallery" => "ساير كاربران مي‌توانند به اين سرسرا پرونده اضافه كنند",
"You can access the file gallery using the following URL" => "شما مي‌توانيد به كمك اين آدرس به سرسراهاي پرونده‌ها دسترسي پيدا كنيد",
"Available File Galleries" => "سرسراهاي پرونده‌ي موجود",
"Message queue for" => "صف پيغام براي",
"back to forum" => "بازگشت به انجمن",
"Edit queued message" => "ويرايش پيغام‌هاي در صف",
"topic" => "موضوع",
"make this a thread of" => "اين را به يك گره تبديل كن از",
"None, this is a thread message" => "هيچ‌كدام، اين يك پيغام رگه‌اي است",
"summary" => "خلاصه",
"normal" => "معمولي",
"announce" => "اعلام",
"hot" => "برانگيخته",
"sticky" => "چسب‌‌ناك",
"no feeling" => "بدون احساس",
"frown" => "اخمو",
"exclaim" => "متعجب",
"idea" => "متفكر",
"mad" => "قاطي",
"neutral" => "معمولي",
"sad" => "غمگين",
"happy" => "شاد",
"wink" => "چشمك",
"save and approve" => "ذخيره و تاييد",
"convert to topic" => "تبديل به عنوان",
"List of messages" => "فهرست پيغام‌ها",
"new topic" => "عنوان جديد",
"no summary" => "بدون خلاصه",
"No messages queued yet" => "هنوز هيچ پيغامي در صف قرار نگرفته است",
"reject" => "مردود",
"visits" => "بازديدها",
"configure forum" => "پيكربندي انجمن‌ها",
"Reported messages for" => "پيغام‌هاي گزارش شده براي",
"Reported by" => "گزارش شده به‌وسيله‌ي",
"friends tpl" => "الگوي رفقا",
"create new user" => "ايجاد كاربر جديد",
"Pending requests" => "درخواست‌هاي رفاقت معلق",
"Request Time" => "زمان درخواست",
"accept" => "قبول مي‌كنم",
"refuse" => "رد مي‌كنم",
"Waiting requests" => "درخواست‌هاي در انتظار",
"Your friends" => "دوستان شما",
"Real Name" => "نام واقعي",
"break friendship" => "قطع ارتباط(رفاقت)",
"Activity completed" => "فعاليت به اتمام رسيد",
"Process" => "فرايند",
"Admin process activities" => "مديريت فعاليت‌هاي فرايند",
"Add or edit an activity" => "افزودن يا ويرايش يك فعاليت",
"start" => "آغاز",
"end" => "پايان",
"activity" => "فعاليت",
"switch" => "گزينه",
"split" => "انشعاب",
"join" => "اتصال",
"standalone" => "خودمختار",
"interactive" => "تعاملي",
"auto routed" => "خودمسيرياب است",
"Expiration Time" => "تاريخ انقضا",
"Years" => "سال",
"Months" => "ماه",
"Days" => "روز",
"Minutes" => "دقيقه",
"Add transitions" => "افزودن تراكنش",
"Add transition from:" => "تراكنش ها را از اين‌جا اضافه كن:",
"Add transition to:" => "تراكنش‌ها را به اين‌جا اضافه كن:",
"roles" => "قوانين",
"No roles associated to this activity" => "هيچ قانوني به اين فعاليت تخصيص نگرفته است",
"Add role" => "افزودن قانون",
"add new" => "جديد",
"add role" => "قانون را اضافه كن",
"Process activities" => "فعاليت‌هاي فرايند",
"Int" => "تعامل",
"Routing" => "مسيريابي",
"Interactive" => "تعاملي",
"Automatic" => "خودكار",
"Auto routed" => "خودكار",
"Manual" => "دستي",
"#" => "رديف",
"inter" => "تعامل",
"route" => "مسيريابي",
"(no roles)" => "(بدون قانون)",
"No activities defined yet" => "هنوز هيچ فعاليت تعريف نشده است.",
"Process Transitions" => "تراكنش‌هاي فعاليت",
"List of transitions" => "فهرست تراكنش‌ها",
"From:" => "از:",
"Origin" => "سرچشمه",
"No transitions defined yet" => "هنوز هيچ تراكنشي تعريف نشده است.",
"Add a transition" => "افزودن يك تراكنش",
"Process Graph" => "نودار فرايند",
"Galaxia Admin Graph" => "نگار مديريت گالكسي",
"Galaxia Admin Graph tpl" => "الگوي نگار مديريت گالكسي",
"This process is invalid" => "اين فرايند نامعتبر است",
"Process Graph for" => "نگار براي فرايند",
"No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed." => "هيچ نموداري موجود نيست. يا فرايند شامل خطا است و يا نموداري هنوز توليد نشده است و يا <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> به درستي نصب نگرديده است.",
"List of processes" => "فهرست فرايندها",
"Inactive" => "غيرفعال",
"act" => "گونه",
"val" => "معتبر؟",
"active process" => "فرايندهاي فعال",
"invalid" => "نامعتبر",
"invalid process" => "فرايند نامعتبر",
"valid process" => "فرايند معتبر",
"new minor" => "كهاد جديد",
"new major" => "مهاد جديد",
"activities" => "فعاليت‌ها",
"No processes defined yet" => "هنوز هيچ فرايندي تعريف نشده است.",
"Admin instance" => "مديريت نمونه‌ها",
"Process:" => "فرايند",
"Instance" => "نمونه",
"Workitems" => "اقلام كاري",
"exception" => "استثنا",
"completed" => "تكميل شده",
"aborted" => "منقطع شده",
"Owner" => "مالك",
"Send all to" => "ارسال به همه",
"Don't move" => "حركت نكن",
"Activities" => "فعاليت‌ها",
"Started" => "تاريخ برپايي",
"Act status" => "وضعيت كنش",
"Ended" => "پايان يافته",
"Not Defined" => "تعريف نشده",
"Not Interactive" => "غيرتعاملي",
"Not Ended" => "پايان نپذيرفته",
"Properties" => "خصوصيات",
"Property" => "خاصيت",
"Value" => "مقدار",
"Add property" => "افزودن خصوصيت",
"value" => "مقدار",
"run instance" => "اجراي نمونه",
"Executed" => "اجرا",
"Pop-up" => "Pop-up",
"erase" => "پاكش كن",
"Galaxia Admin Processes" => "فرايندهاي مديريت گالكسي",
"Galaxia Admin Processes tpl" => "الگوي فرايندهاي مديريت گالكسي",
"Add or edit a process" => "افزودن يا ويرايش كردن يك فرايند",
"Process Name" => "نام فرايند",
"ver:" => "نگارش:",
"is active?" => "آيا فعال است؟",
"Or upload a process using this form" => "يا به كمك اين ورقه يك فرايند بارگذاري كنيد",
"Admin process roles" => "مديريت قوانين فرايند",
"Add or edit a role" => "ايجاد يا ويرايش يك قانون",
"Process roles" => "قوانين فرايند",
"No roles defined yet" => "هنوز هيچ قانوني تعريف نشده است.",
"Map users to roles" => "نگاشتن كاربران به قوانين",
"Map" => "نگاشت",
"Roles" => "قوانين",
"map" => "بنگار",
"Map groups to roles" => "نگاشت گروه‌هاي كاربري به قوانين",
"Operation" => "عمل",
"Warning" => "اخطار",
"No roles are defined yet so no roles can be mapped" => "هنوز هيچ قانوني تعريف نشده است، لذا هيچ قانوني قابل نگاشت نيست.",
"List of mappings" => "فهرست نگاشت‌ها",
"No mappings defined yet" => "هنوز هيچ نگاشتي تعريف نشده است.",
"Admin process sources" => "مديريت منابع فرايندها",
"select source" => "انتخاب منبع",
"Shared code" => "دستورالعمل(كد)هاي به اشتراك گذاشته شده",
"Set next user" => "تنظيم كاربر بعدي(Set next user)",
"Get property" => "دريافت خصوصيت(Get property)",
"Set property" => "تنظيم خصوصيت(Set property)",
"Complete" => "كامل",
"Process form" => "فرم فرايند",
"Set Next act" => "تنظيم عمل بعدي",
"If:SetNextact" => "اگر:تنظيم‌فعالت‌بعدي",
"Switch construct" => "تعويض ساختار",
"Map process roles" => "نگاشت قوانين فرايند",
"admin processes" => "مديريت فرايندها",
"admin activities" => "مديريت فعاليت‌ها",
"admin roles" => "مديريت قوانين",
"edit this process" => "اين فرايند را ويرايش كن",
"Galaxia Monitor Activities" => "ديده‌باني فعاليت‌هاي گالكسي",
"Galaxia Monitor Activities tpl" => "الگوي ديده‌باني فعاليت‌هاي گالكسي",
"List of activities" => "فهرست فعاليت‌ها",
"proc" => "فرايند",
"auto" => "مسيريابي",
"int" => "تعاملي",
"routing" => "خودمسيرياب",
"Instances" => "نمونه‌ها",
"run" => "اجرا",
"run activity" => "اجراي فعاليت",
"Enter the name of this instance" => "نام اين نمونه را وارد كنيد",
"The name is not valid. Please, enter the name again" => "نام معتبر نبود، لطفا مجددا سعي كنيد",
"monitor" => "ديده‌باني",
"monitor processes" => "ديده‌باني فرايندها",
"monitor activities" => "ديده‌باني فعاليت‌ها",
"monitor instances" => "ديده‌باني نمونه‌ها",
"monitor workitems" => "ديده‌باني اقلام كاري",
"Galaxia Monitor Instances" => "ديده‌باني نمونه‌هاي گالگسي",
"Galaxia Monitor Instances tpl" => "ديده‌باني نمونه‌هاي گالگسي",
"List of instances" => "فهرست نمونه‌ها",
"Not ended" => "تمام نشده",
"No instances created yet" => "هيچ نمونه‌اي هنوز ايجاد نشده است.",
"Galaxia Monitor Processes" => "ديده‌باني فرايندهاي گالكسي",
"Galaxia Monitor Processes tpl" => "الگوي ديده‌باني فرايندهاي گالكسي",
"Valid" => "معتبر",
"Invalid" => "نامعتبر",
"Activs" => "فعال",
"processes" => "فرايند",
"being run" => "آغاز شده",
"exceptions" => "استثنا",
"Monitor workitems" => "ديده‌باني اقلام كاري",
"List of workitems" => "فهرست اقلام كاري",
"instance" => "نمونه",
"Ins" => "درج",
"time" => "زمان",
"My activities" => "فعاليت‌هاي من",
"Current Activity" => "فعاليت‌هاي جاري",
"Assigned To" => "منصوب به",
"exception instance" => "نمونه‌ي استثنا",
"exceptions instance" => "نمونه‌هاي استثنا",
"send instance" => "نمونه را ارسال كن",
"abort instance" => "نمونه را متوقف كن",
"grab instance" => "نمونه را بگير",
"release instance" => "نمونه را رها كن",
"No activities found" => "هيچ فعاليتي يافت نشد.",
"My instances" => "نمونه‌هاي من",
"No instances found" => "هيچ نمونه‌اي يافت نشد.",
"stop" => "توقف",
"activate" => "فعال‌سازي",
"graph" => "نگار(نمودار)",
"User Activities" => "فعاليت‌هاي كاربر",
"Galaxia User Activities" => "فعاليت‌هاي كاربر گالكسي",
"Galaxia User Activities tpl" => "الگوي فعاليت‌هاي كاربر گالكسي",
"process" => "فرايند",
"user processes" => "فرايندهاي كاربر",
"user activities" => "فعاليت‌هاي كاربر",
"user instances" => "نمونه‌هاي كاربر",
"Galaxia User Instances" => "نمونه‌ي كاربر Galaxia",
"Galaxia User Instances tpl" => "الگوي نمونه‌هاي كاربر گالكسي",
"Inst Status" => "وضعيت نمونه",
"Not defined" => "تعريف نشده",
"No instances defined yet" => "هنوز هيچ نمونه‌اي تعريف نشده است.",
"Galaxia User Processes" => "فرايندهاي كاربر گالكسي",
"Galaxia User Processes tpl" => "الگوي فرايندهاي كاربر گالكسي",
"Browsing Workitem" => "مرور اقلام كاري",
"Workitem information" => "اطلاعات اقلام كاري",
"galleries tpl" => "الگوي سرسراها",
"Create a gallery" => "ايجاد يك سرسراي جديد",
"Edit this gallery:" => "اين سرسرا را ويرايش كن",
"There are individual permissions set for this gallery" => "براي اين سرسرا، حقوق دسترسي فردي تعريف شده است",
"Geographic" => "جغرافيايي",
"Images per row" => "تصاوير در هر سطر",
"Thumbnails size X" => "اندازه‌ي عرض تصويرك(thumbnail)",
"Thumbnails size Y" => "اندازه‌ي عرض تصويرك(thumbnail)",
"Default sort order" => "مرتب‌سازي پيش‌فرض",
"Fields to show during browsing the gallery" => "هنگام مرور سرسرا، اين موارد را نشان بده",
"Image ID" => "شناسه‌ي تصوير",
"Creation Date" => "تاريخ ايجاد",
"XY-Size" => "اندازه‌ي طول و عرض(XY) ",
"Filesize" => "حجم پرونده",
"Gallery Image" => "تصوير سرسرا",
"Parent gallery" => "سرسراي مادر",
"Available scales" => "مقياس‌هاي موجود",
"Bounding box" => "جعبه‌ي كران‌گزاري",
"default scale" => "ابعاد پيش‌فرض",
"No scales available" => "هيچ مقياسي موجود نيست",
"Original image is default scale" => "تصوير اصلي، مقياس پيش‌فرض است",
"Add scaled images with bounding box of square size" => "تصاوير مدرج را با كادري مربع به اين اندازه اضافه كن",
"Other users can upload images to this gallery" => "ساير كاربران مي‌توانند به اين سرسرا تصوير اضافه كنند",
"You can access the gallery using the following URL" => "شما مي‌توانيد با استفاده از اين URL به اين سرسرا دسترسي پيدا كنيد",
"Available Galleries" => "سرسراهاي(Galleries) موجود",
"Imgs" => "تصاوير",
"Make Map" => "ساخت نقشه",
"Wiki quick help" => "كمك سريع ويكي",
"Quicklinks" => "پيوندهاي سريع",
"Last Edit:" => "آخرين ويرايش",
"Grade Paper" => "كاغذ درجه‌بندي",
"Due Date:" => "تاريخ انجام",
"Comparing versions" => "مقايسه‌ي نسخ",
"Actual_version" => "نسخه‌ي واقعي",
"Diff to version" => "متفاوت از نسخه‌ي",
"rollback" => "عقب‌گرد",
"source" => "منبع",
"Rollback page" => "صفحه را به حالت قبل برگردان",
"to_version" => "به نسخه‌ي",
"Assignments List" => "فهرست منصوبات",
"My Work" => "كارهاي من",
"Details" => "جزئيات",
"Last Modified" => "آخرين تغيير",
"Assignment" => "منصوبات",
"Due Date" => "تاريخ انجام",
"Grading Queue " => "صف درجه‌بندي ",
"empty" => "تخليه شود",
"paper" => "كاغذ",
"papers" => "كاغذ",
"Edit Assignment" => "ويرايش منصوبات",
"list assignments" => "فهرست منصوبات",
"Summary" => "خلاصه",
"Due" => "مقرر",
"create assignment" => "ايجاد منصوبات",
"Im- Export languages" => "وارد/صادر كردن زبان‌ها",
"Select the language to Import" => "زبان را براي وارد كردن انتخاب كنيد",
"import" => "وارد كن",
"Select the language to Export" => "زبان را براي صادر كردن انتخاب كنيد",
"Import A PHPBB Dump" => "يك PHPBB Dump وارد كن",
"ImportingPagesPhpWikiPageAdmin" => "صفحه‌ي مديريت واردات صفحه‌ي ويكي PHP",
"tiki-import_phpbb tpl" => "الگوي واردات PHP تيكي",
"Name of the SQL dump file (relative to\ntiki basedir, e.g. dump/phpbb_db_backup.sql )" => "نام پرونده‌ي SQL Dump (نسبت به پوشه‌ي منبع تيكي، مثلا: dump/phpbb_db_backup.sql)",
"Overwrite existing threads if the name is\nthe same" => "درصورتي كه رگه‌اي با همين نام وجود دارد، روي آن بنويس",
"Excerpt" => "گلچين كردن",
"Result" => "نتيجه",
"Import pages from a Structured Text Dump" => "صفحات را از يك متن Dumpشده‌ي ساختار يافته وارد كن",
"tiki-import_phpwiki tpl" => "الگوي واردات PHP ويكي",
"Name of the dump file (it has to be in dump/)" => "نام پرونده‌ي dump (بايد به اين شكل باشد: dump/)",
"Overwrite existing pages if the name is the same" => "در صورتي كه صفحه‌اي با اين نام وجود دارد، روي آن بنويس",
"Previously remove existing page versions" => "نسخ قبلي اين صفحه",
"excerpt" => "گلچين كردن",
"result" => "نتيجه",
"body" => "بدنه",
"Clear cached version and refresh cache" => "نسخه‌ي Cacheشده را خالي كن و Cache را تازه كن ",
"configure rules" => "پيكربندي قوانين",
"edit repository" => "مخزن را ويرايش كن",
"Weeks" => "هفته",
"Search by Date" => "جستجو بر اساس تاريخ",
"Found" => "پيدا شد",
"LastChanges" => "آخرين تغييرات",
"hist" => "تاريخچه",
"v" => "نما",
"Pages like" => "صفحات مشابه",
"No pages found" => "صفحه‌اي پيدا نشد.",
"List Articles" => "فهرست مقالات",
"list articles tpl" => "الگوي فهرست مقالات",
"edit new article" => "ويرايش مقاله‌ي جديد",
"ExpireDate" => "تاريخ انقضا",
"AuthorName" => "نام مولف",
"admin Banners" => "مديريت درفش‌ها",
"admin Banners tpl" => "الگوي مديريت درفش‌ها",
"Create banner" => "ساخت درفش",
"Method" => "اسلوب",
"Use Dates?" => "از تاريخ استفاده شود؟",
"Max Impressions" => "بيشينه تعداد نمايش",
"Impressions" => "تعداد نمايش",
"Clicks" => "كليك",
"create new blog" => "يك بلاگ جديد ايجاد كن",
"admin cache" => "مديريت Cache",
"admin cache tpl" => "الگوي مديريت Cashe",
"Dynamic content system" => "سامانه‌ي محتوي پويا",
"admin DynamicContent" => "مديريت محتوي پويا",
"admin DynamicContent tpl" => "الگوي مديريت محتوي پويا",
"Create or edit content block" => "ايجاد يا ويرايش بلاك محتوي",
"Available content blocks" => "بلوك‌هاي محتوي موجود",
"Current ver" => "نسخه‌ي جاري",
"Next ver" => "نسخه‌ي بعدي",
"Future vers" => "نسخ آينده",
"Old vers" => "نسخ قديمي",
"Program" => "برنامه",
"list faqs tpl" => "الگوي فهرست سئوالات متداول",
"Edit this FAQ:" => "ويرايش اين FAQ",
"Create new FAQ" => "ساخت FAQ جديد",
"Create New FAQ:" => "ساخت FAQ جديد:",
"Users can suggest questions" => "كاربران مي‌توانند سئوال پيشنهاد دهند؟",
"Available FAQs" => "FAQهاي موجود",
"Listing Gallery" => "فهرست كردن سرسراها",
"upload file" => "بارگذاري پرونده",
"Edit a file using this form" => "با استفاده از اين فرم، يك پرونده را ويرايش كن",
"Gallery Files" => "پروده‌هاي سرسرا",
"move selected files" => "پرونده‌هاي انتخاب شده را منتقل كن",
"delete selected files" => "پرونده‌هاي انتخاب شده را حذف كن",
"Move to" => "انتقال به",
"Dls" => "دريافت‌ها",
"browse gallery" => "مرور سرسرا",
"Gallery Images" => "تصاوير سرسرا",
"games tpl" => "الگوي بازي‌ها",
"/" => "/",
"All games are from" => "تمام بازي‌ها از اين پايگاه هستند:",
"visit the site for more games and fun" => "براي ساير بازي‌ها و سرگرمي‌ها، نگاهي به اون پايگاه بندازيد.",
"Upload a game" => "يك بازي بارگذاري كنيد",
"Upload a new game" => "بارگذاري يك بازي جديد",
"Flash binary (.sqf or .dcr)" => "فلاش‌هاي دودويي (.sqf or .dcr)",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "تصويرك (اگر بازي foo.swf باشد، نام تصويرك بايد foo.swf.gif يا foo.swf.png يا foo.swf.jpg شود)",
"Edit game" => "ويرايش بازي",
"Played" => "بازي شده",
"times" => "بار",
"If you can't see the game then you need a flash plugin for your browser" => "اگر نمي‌توانيد بازي را ببينيد، به plugin مربوط به flash براي مرورگر خود نياز داريد",
"list posts tpl" => "الگوي فهرست الصاق‌ها",
"edit blog" => "ويرايش بلاگ",
"Blog Title" => "عنوان بلاگ",
"Number Members" => "تعداد اعضا",
"Number Admins" => "تعداد مديران",
"No projects found" => "پروژه‌اي پيدا نشد.",
"list quizzes tpl" => "الگوي فهرست آزمون‌ها",
"edit new submission" => "ويرايش ارائه‌ي جديد",
"Approve" => "تصويب",
"edit quiz stats tpl" => "ويرايش الگوي آمار آزمون",
"Survey stats" => "آمار نظرسنجي‌ها",
"actions" => "اعمال",
"take survey" => "به اجرا گذاشتن",
"adm" => "مديريت",
"list trackers tpl" => "الگوي فهرست trackerها",
"Gender" => "جنس",
"Distance (km)" => "فاصله (به كيلومتر)",
"List Movies" => "فهرست فيلم‌ها",
"Choose a movie" => "يك فيلم انتخاب كن",
"Display" => "نمايش",
"Last mod" => "آخرين تغيير",
"Last author" => "آخرين مؤلف",
"Last ver" => "آخرين نسخه",
"Com" => "نوع",
"Vers" => "نسخ",
"with checked" => "تيك خورده‌ها را...",
"admin live support tpl" => "الگوي مديريت پشتيباني زنده",
"Open client window" => "پنجره‌ي كاربر را بازكن",
"Generate HTML" => "HTML توليد كن",
"Transcripts" => "رونوشت‌ها",
"Support tickets" => "بليط‌هاي پشتيباني",
"Online operators" => "پشتيبانان روي خط",
"Operator" => "پشتيبان",
"Accepted requests" => "درخواست‌هاي پذيرفته شده",
"transcripts" => "روشت‌ها",
"Offline operators" => "پشتيبانان خارج از خط",
"Add an operator to the system" => "افزودن يك پشتيبان به سامانه",
"Operators must be tiki users" => "پشتيبان بايد كاربر تيكي باشد.",
"set as operator" => "به عنوان پشتيبان قرارش بده",
"Chat started" => "گفتگو آغاز شد",
"User:" => "نام كاربري:",
"Operator:" => "پشتيبان",
"Live support:User window" => "پشتيباني زنده: پنجره‌ي كاربر",
"Request live support" => "درخواست پشتيباني زنده",
"Request support" => "درخواست پشتيباني",
"Open a support ticket instead" => "به‌جاي اين يك بليط پشتيباني بازكن",
"Your request is being processed" => "درخواست شما درحال جريان است",
"cancel request and exit" => "درخواست را لغو كن و خارج شو",
"cancel request and leave a message" => "درخواست را لغو كن و يك پيغام بگذار",
"Live support:Console" => "پشتيباني زنده: ميزكار",
"be online" => "وارد مدار شو",
"be offline" => "از مدار خارج شو",
"Support requests" => "درخواست پشتيباني",
"Requested" => "درخواست شده",
"Accept" => "قبول شده",
"Join" => "بپيوند",
"Support chat transcripts" => "رونوشت گفتگوي پشتيباني",
"back to admin" => "بازگشت به مديريت",
"operator" => "پشتيبان",
"started" => "تاريخ شروع",
"reason" => "دليل",
"msgs" => "پيغام‌ها",
"Transcript" => "رونوشت",
"Mail-in feature" => "خصيصه‌ي 'كنترل با پست الكترونيكي'",
"User Calendar" => "تقويم كاربر",
"User Calendar Doc tpl" => "الگوي مستندات تقويم جيبي",
"Upcoming events" => "رويدادهاي قريب‌الوقوع",
"Remove old events" => "رويدادهاي قديمي را حذف كن",
"duration" => "مدت زمان",
"Add or edit event" => "افزودن يا ويرايش رويداد",
"Duration" => "مدت زمان",
"Mini Calendar: Preferences" => "تقويم جيبي: تنظيمات",
"User Calendar Doc" => "مستندات تقويم جيبي",
"User Calendar Preferences Doc tpl" => "از الگوي مستندات تنظيمات تقويم جيبي استفاده كن",
"Calendar Interval in daily view" => "بازه تقويم در نماي روزانه",
"Start hour for days" => "ساعت شروع براي روزها",
"End hour for days" => "ساعت پايان براي روزها",
"Reminders" => "يادآورها",
"no reminders" => "بدون يادآوري",
"Import CSV file" => "وارد كردن پرونده‌ي CSV",
"Or enter path or URL" => "يا مسير يا URL را وارد كنيد",
"add topic" => "افزودن موضوع",
"Tikiwiki Mods" => "حالات تيكي‌ويكي",
"Update remote index" => "به‌روز رساني راهنماي از راه دور(remote index)",
"Rebuild local list" => "ساخت مجدد فهرست محلي(local)",
"Republish all" => "همه را مجددا منتشر كن",
"Publish all" => "همه را منتشر كن",
"Unpublish all" => "پس‌گرفتن تمام انتشارها",
"Attention" => "توجه",
"Apache has the right to write in your file tree, which enables the installation, removal or \nupgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \n\"./fixperms.sh fix\" for example)." => "آپاچي(Apache) اجازه‌ي نوشتن در پرونده‌هاي شما را دارد، كه اين امر نصب، حذف و به‌روز رساني بسته‌ها را ممكن مي‌سازد. هنگامي كه كار شما با اين اعمال به پايان رسيد، به‌خاطر داشته باشيد كه حقوق دسترسي مربوط را به حالت امن برگردانيد(مثلا با استفاده از \n\"./fixperms.sh fix\")",
"To install, remove or upgrade packages you need to give the apache user the right\nto write files in your web tree (you can use \"./fixperms.sh open\" to set it up). After installation you need to remove that\npermission (using \"./fixperms.sh fix\")." => "به منظور نصب، حذف و به‌روز رساني بسته‌ها بايد به آپاچي(Apache) اجازه‌ي نوشتن در پرونده‌هاي خود را بدهيد.(مي‌توانيد از \"./fixperms.sh open\" بهره بگيريد). پس از نصب، بايد اين دسترسي را از اين كاربر صلب كنيد.(مثلا با استفاده از \"./fixperms.sh fix\)",
"all types" => "تمام موارد",
"Display only this type" => "فقط اين نوع را نمايش بده",
"Unpublish" => "پس گرفتن انتشار",
"Republish" => "انتشار مجدد",
"install" => "نصب",
"Install" => "نصب",
"Tikiwiki Mods Configuration" => "پيكربندي حالات تيكي‌ويكي",
"Enable Mods providing" => "فراهم كردن حالات، فعال باشد",
"Mods local directory" => "پوشه‌ي محلي حالات",
"Mods remote server" => "سرور راه‌دور حالات",
"Package Config" => "پيكربندي بسته‌بندي",
"my tiki tpl" => "الگوي تيكي من",
"subscribe" => "عضويت",
"Sent edition" => "ويرايشات ارسال شده",
"The newsletter was sent to {\$edition.users} email addresses" => "خبرنامه به اين آدرس‌هاي الكترونيكي ارسال شد: {\$edition.users}",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "از عضويت شما متشكريم. به‌زودي يك پيغام الكترونيكي دريافت خواهيد كرد تا از طريق آن عضويت خود را تاييد كنيد. قبل از تاييد هيچ خبرنامه‌اي براي شما ارسال نخواهد شد.",
"Subscribe to newsletter" => "عضويت در خبرنامه",
"Select news group" => "انتخاب گروه خبري",
"Back to servers" => "بازگشت به سرورها",
"Msgs" => "پيغام‌ها",
"News from" => "اخبار از",
"Save position" => "موقعيت را ذخيره كن",
"Reading article from" => "خوانده مقاله از",
"Back to list of articles" => "بازگشت به فهرست مقالات",
"First" => "اولين",
"Newsgroup" => "خبرنامه",
"Configure news servers" => "پيكربندي سرورهاي اخبار",
"Configure Newsreader" => "پيكربندي اخبارگو",
"configure newsreader server tpl" => "الگوي پيكربندي سرور اخبارگو",
"Select a news server to browse" => "يك سرور اخبار گو براي مرور انتخاب كنيد",
"server" => "سرور",
"Read the news" => "مشاهده‌ي اخبار",
"Add or edit a news server" => "افزودن يا ويرايش يك سرور اخبار",
"News server" => "سرور اخبار",
"port" => "درگاه",
"Notes" => "يادداشت‌ها",
"quota" => "سهميه",
"Write a note" => "يك يادداشت بنويس",
"No notes yet" => "هنوز هيچ پيغامي وجود ندارد.",
"merge selected notes into" => "يادداشت‌هاي انتخابي را ادغام كن و بريز داخل",
"Reading note:" => "خواندن يادداشت:",
"List notes" => "آخرين يادداشت‌ها",
"Write note" => "نوشتن يادداشت",
"wiki create" => "ساخت ويكي",
"wiki overwrite" => "نوشتن ويكي(جايگزيني روي قبلي‌ها)",
"Assign permissions to " => "تخصيص حقوق دسترسي به ",
"back" => "بازگشت",
"Current permissions for this object" => "حقوق دسترسي كنوني براي اين شيئ",
"Assign permissions to this object" => " تخصيص حقوق دسترسي به اين شيئ",
"Published" => "تاريخ انتشار",
"Votes" => "تعداد راي‌ها",
"Orphan Pages" => "صفحات يتيم",
"s=source" => "s=منبع",
"b=rollback" => "b=برگشت تغييرات",
"Assign permissions to page" => " تخصيص حقوق دسترسي به صفحه‌ي",
"Current permissions for this page" => "حقوق دسترسي كنوني براي اين صفحه",
"remove from this page" => "از اين صفحه حذفش كن",
"remove from this structure" => "از اين ساختار حذف كن",
"No individual permissions; category or global permissions apply" => "حقوق دسترسي فردي تنظيم نشده است، دسترسي‌هاي طبقه يا دسترسي‌هاي عمومي اعمال خواهند شد.",
"this page" => "اين صفحه",
"this structure" => "اين ساختار",
"Current permissions for categories that this page belongs to" => "دسترسي‌هاي جاري براي طبقه‌هايي كه اين صفحه به آن‌ها تعلق دارد",
"No category permissions; global permissions apply" => "بدون حقوق دسترسي طبقه‌اي، حقوق دسترسي عمومي اعمال خواهد شد",
"Send email notifications when this page changes to" => "هنگامي كه اين صفحه تغيير مي‌كند، به اين آدرس‌ها پست الكترونيكي بفرست",
"add email" => "آدرس پست الكترونيكي",
"Notifications" => "آگاه‌سازي‌ها",
"Pick your avatar" => "شكلك خود را انتخاب كنيد",
"Your current avatar" => "شكلك كنوني شما",
"Pick avatar from the library" => "شكلك خود را از بين كتابخانه انتخاب كنيد",
"Hide all" => "همه را پنهان كن",
"icons" => "تمثال‌ها",
"Show all" => "نمايش همه",
"Avatar Image" => "تصوير شكلك",
"random" => "تصادفي",
"no avatar" => "بدون شكلك",
"Upload your own avatar" => "شكلك خود را بارگذاري كنيد",
"lastModif" => "آخرين تغييرات",
"atts" => "خصوصيات",
"List Attachments" => "آخرين ضمايم",
"View Results" => "مشاهده‌ي نتايج",
"Vote poll" => "راي دادن",
"Other Polls" => "ساير راي‌گيري‌ها",
"Note: Remember that this is only a preview, and has not yet been saved!" => "نكته: به‌خاطر داشته‌باشيد كه اين تنها يك پيش‌نمايش است و وظيفه دخيره نشده است",
"posted by" => "الصاق شده توسط",
"Viewing blog post" => "مشاهده‌ي الصاقات بلاگ",
"Return to blog" => "بازگشت به بلاگ",
"Permalink" => "دنباله‌ي ثابت",
"referenced by" => "مرجوع شده از",
"references" => "ارجاعات",
"view comments" => "مشاهده‌ي نظرها",
"email this post" => "اين الصاق را با پست الكترونيكي بفرست",
"Print multiple pages" => "چاپ چندين صفحه",
"Print Wiki Pages" => "چاپ صفحات ويكي",
"clear" => "پاك كن",
"Project Created:" => "پروژه ساخته شده:",
"Project Info" => "اطلاعات پروژه",
"Project Admins:" => "مديريت پروژه:",
"Project Members:" => "اعضاي پروژه:",
"View Details" => "مشاهده‌ي جرئيات",
"Edit Project" => "ويرايش پروژه",
"Add Blog" => "افزودن بلاگ",
"Add Articles" => "افزودن مقاله",
"Add Calendar" => "افزودن تقويم",
"Add FAQ" => "افزودن FAQ",
"Add File Gallery" => "افزودن سرسراي پرونده",
"Add Forum" => "افزودن انجمن",
"Add Image Gallery" => "افزودن سرسراي تصوير",
"Add Newsletter" => "افزودن خبرنامه",
"Add URL" => "افزودن URL",
"Project Registration" => "ثبت‌نام",
"Your project was successfully submitted.  It may be subject\nto approval. Once available, you can create/link your project objects\nto your project page." => "پروژه‌ي شما با موفقيت ارائه شد. بايد در معرض تصويب قرار بگيرد. هنگامي كه تاييد شد مي‌توانيد در صفحه‌ي پروژه‌ي خود اشياء پروژه را بسازيد و براي آن‌ها پيوند ايجاد كنيد",
"List all projects" => "فهرست تمام پروژه‌ها",
"Take care when you register your project, the project name\ncannot be changed afterwards. Please also provide an accurate \nproject description. If you havent worked out these details please\ndo so before your register the project." => "هنگامي كه پروژه‌ي خود را ثبت مي‌كنيد، مراقب باشيد، نام پروژه پس از ثبت نمي‌تواند تغيير كند. اگر هنوز در خصوص آن تصميم نگرفته‌ايد، قبل از ثبت پروژه ترتيب آن را بدهيد.",
"Please choose your project categories carefully. You can\nhowever change this later on your project admin panel." => "لطفا طبقات پروژه‌ي خود را با دقت انتخاب كنيد. هرچند مي‌توانيد در بخش مديريت پروژه آن‌ها را تغيير دهيد.",
"All project names are converted to lowercase." => "نام تمام پروژه‌ها به حروف كوچك تبديل خواهد شد.",
"Edit quiz" => "ويرايش آزمون",
"show" => "نمايش بده",
"hide" => "مخفي كن",
"Current Version" => "نسنه‌ي جاري",
"General Options" => "اختيارات عمومي",
"Publication Date" => "تاريخ انتشار",
"at " => "در ",
"Use " => "بهره‌گيري ",
"randomly selected questions." => "سئوالات انتخاب شده به‌صورت تصادفي",
"Test-time Options" => "اختيارات زماني",
"Limit questions displayed per page to " => "سئوالاتي كه در هر صفحه نمايش داده مي‌شوند را محدود كن به",
"&nbsp question(s)." => "سئوال(هاي) &nbsp",
"Impose a time limit of " => "تحميل محدوديت زماني  ",
"Allow students to store partial results and return to quiz." => "به دانش‌آموزيين اجازه بده نتايج را نيمه‌كاره نگه‌داريند و با آزمون برگردند.",
"Allow students to retake this quiz " => "به دانش‌آموزيين اجازه‌ي شركت مجدد در اين آزمون را بده ",
"Grading and Feedback" => "درجه‌بندي و بازخورد",
"Grading method " => "اسلوب درجه‌بندي ",
"Show students their score " => "به دانش‌آموزيين امتيازاتشان را نشان بده ",
"Show students the correct answers " => "به دانش‌آموزيين پاسخ‌هاي صحيح را نشان بده ",
"Publish statistics " => "انتشار آمار ",
"Extra Options" => "اختيارات اضافي ",
"Solicit additional questions from students" => "درخواست سئوالات اضافي از طرف دانش‌آموزيين",
"Link quiz to forum named: " => "آزمون را به اين انجمن پيوند بده: ",
"Prologue:" => "افتتاحيه",
"Epilogue:" => "اختتاميه:",
"Quiz result stats" => "آمار نتايج آزمون",
"Quiz" => "آزمون",
"Time" => "زمان",
"User answers" => "پاسخ‌هاي كاربران",
"Stats for quizzes" => "وضعيت آزمون‌ها",
"taken" => "گرفته شده؟",
"Av score" => "متوسط امتياز",
"Av time" => "زمان متوسط",
"Stats for quiz" => "آمار آزمون",
"clear stats" => "آمار را پاك كن",
"time taken" => "زمان گرفته شده",
"P" => "قبول",
"F" => "رد",
"Stats for this quiz Questions " => "آمار براي اين سئوالات آزمون ",
"Average" => "معدل",
"Top 10" => "10 تاي برتر",
"Top 20" => "20 تاي برتر ",
"Top 50" => "50 تاي برتر ",
"Top 100" => "100 تاي برتر ",
"Received Articles" => "مقالات دريافت شده",
"received articles tpl" => "الگوي مقالات دريافت شده",
"Edit received article" => "ويرايش مقالات دريافت شده",
"Use Image" => "از تصوير استفاده كن",
"Image x size" => "اندازه‌ي طول تصوير",
"Image y size" => "اندازه‌ي عرض تصوير",
"Image name" => "نام تصوير",
"Image size" => "اندازه‌ي تصوير",
"Accept Article" => "تاييد مقاله",
"Site" => "پايگاه",
"Communcation Center" => "مركز ارتباطات",
"received pages tpl" => "الگوي صفحات دريافت شده",
"Edit received page" => "ويرايش صفحات دريافت شده",
"admin Referer stats" => "آمار مراجعات به سرپرست",
"admin Referer stats tpl" => "الگوي آمار مراجعات به سرپرست",
"last" => "آخرين بار",
"A valid email is mandatory to register" => "براي ثبت‌نام، يك پست الكترونيكي معتبر ضروري است",
"Tiki site registered" => "پايگاه تيكي ثبت شد",
"You don't have permission to use this feature." => "متاسفانه شما حقوق دسترسي كافي براي استفاده از اين خصيصه را نداريد",
"Please register." => "لطفا ثبت‌نام كنيد.",
"Read this first!" => "ابتدا اين را بخوانيد!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "در اين صفحه مي‌توانيد پايگاه خود را به tikiwiki.org بشناسانيد. پايگاه شما در فهرست پايگاه‌هاي شناخته شده‌ي تيكي در tikiwiki.org ثبت خواهد شد.",
"Registering is voluntary." => "ثبت‌نام اختياري است",
"Registering does not give you any benefits except one more link to your site." => "ثبت‌نام سود خاصي عايد شما نمي‌كند، جز اين‌كه يك پيود اضافه به پايگاه شما ايجاد مي‌شود.",
"You don't get any emails, we don't sell the data about your site." => "شما هيچ پست الكترونيكي دريافت نخواهيد كرد، ما اطلاعات پايگاه شما را نخواهيم فروخت!",
"Registering is just for us to get an overview of Tiki's usage." => "ثبت‌نام فقط براي ماست، براي اين‌كه يك چشم‌اندازي از استفاده‌هاي تيكي داشته باشيم",
"If your site is private or inside your intranet, you should not register!" => "اگز پايگاه شما خصوصي است، يا داخل اينترانت قرار گرفته است، نبايد ثبتش كنيد!",
"tikiwiki.org" => "tikiwiki.org",
"Information about your site" => " اطلاعاتي درخصوص پايگاه شما",
"I forgot my password" => "من كلمه‌ي عبورم را فراموش كرده‌ام",
"send me my password" => "براي من كلمه‌ي عبورم را ارسال كن",
"Return to HomePage" => "بازگشت به صفحه‌ي مبدا",
"Remove page" => "صفحه را حذف كن",
"last version" => "آخرين نسخه",
"You are about to remove the page" => "شما درحال حذف صفحه هستيد",
"permanently" => "كاملا",
"Remove all versions of this page" => "تمام نسخ اين صفحه را حذف كن",
"Rename page" => "تغيير نام",
"New name" => "نام جديد",
"Replicate" => "تكرار",
"Slave" => "برده",
"Master" => "ارباب",
"Change" => "تعيير بده",
"Operations" => "اعمال",
"Operations Log" => "وقايع ثبت‌شده‌ي اعمال",
"Search Stats" => "آمار جستجو",
"search stats tpl" => "الگوي آمار جستجو",
"searched" => "جستجو شد",
"Search in" => "جستجو در",
"galleries" => "سرسراها",
"images" => "تصاوير",
"blog posts" => "الصاق‌هاي بلاگ",
"articles" => "مقالات",
"Simple search" => "جستجوي ساده",
"No pages matched the search criteria" => "هيچ صفحه‌اي كه شرايط جستجو را داشته باشد، يافت نشد",
"Send blog post" => "الصاق بلاگ را بفرست",
"A link to this post was sent to the following addresses:" => "يك پيوند به اين الصاق براي آدرس‌هاي ذيل ارسال شد:",
"Send post to this addresses" => "الصاق را به اين آدرس‌ها بفرست",
"List of email addresses separated by commas" => "فهرست آدرس‌هاي پست الكترونيكي، تفكيك شده با ويرگول",
"The event was sent to {\$sent} email addresses" => "اين رويداد براي آدرس‌هاي پست الكترونيكي {\$sent} ارسال شد",
"This event will be sent to {\$subscribers} email addresses." => "اين رويداد براي آدرس‌هاي پست الكترونيكي {\$subscribers} ارسال خواهد شد",
"Prepare a event to be sent" => "آماده‌سازي يك رويداد براي ارسال",
"Send Events" => "رويداد را بفرست",
"Send objects" => "ارسال اشياء",
"admin send objects tpl" => "الگوي مديريت ارسال اشياء",
"Transmission results" => "نتايج مخابره‌ها",
"Send objects to this site" => "اشياء را به اين پايگاه بفرست",
"site" => "نام پايگاه",
"path" => "مسير",
"password" => "كلمه‌ي عبور‌",
"Send Wiki Pages" => "صفحات ويكي را بفرست",
"Send Articles" => "مقالات را بفرست",
"add article" => "مقاله را اضافه كن",
"sheets tpl" => "الگوي اوراق",
"Create a sheet" => "ساخت يك ورق",
"Edit this sheet:" => "ويرايش اين ورق:",
"create new sheet" => "ساخت ورق جديد",
"There are individual permissions set for this sheet" => "براي اين ورق حقوق دسترسي فردي تعريف شده است",
"Class Name" => "نام كلاس",
"Header Rows" => "ستون‌هاي سرصفحه",
"Footer Rows" => "ستون‌هاي پاصفحه",
"Create new Sheet" => "ساخت ورق جديد",
"You can access the sheet using the following URL" => "با استفاده از YRL روبرو مي‌توانيد به اين ورق دسترسي پيدا كنيد",
"Available Sheets" => "اوراق موجود",
"Tiki Shoutbox" => "فريادگاه تيكي",
"admin Tiki Shoutbox" => "مديريت فريادگاه تيكي",
"admin Tiki Shoutbox tpl" => "الگوي مديريت فريادگاه تيكي",
"Change shoutbox general settings" => "تغيير تنظيمات عمومي فريادگاه",
"auto-link urls" => "URLهاي پيوند خودكار(Autolink)",
"Post or edit a message" => "الصاق يا ويرايش پيغام",
"Location : " => "محل:",
"Search : " => "جستجو:",
"first" => "اولين",
"big grin" => "شاد",
"confused" => "گيج",
"cool" => "آرام",
"cry" => "گريه",
"eek" => "زكي",
"evil" => "شيطون",
"lol" => "قهقهه",
"mr green" => "آقاي سبز",
"razz" => "شوخ",
"redface" => "صورت صورتي",
"rolleyes" => "با چشماي چرخون",
"smile" => "لبخند",
"surprised" => "متعجب",
"twisted" => "پيچونده شده",
"arrow" => "فلش",
"santa" => "سانتا",
"CMS" => "سامانه‌ي مديريت محتوي",
"Site Stats" => "آمار پايگاه",
"Days online" => "برپا (روز)",
"Total pageviews" => "تعداد كل بازديدها",
"Average pageviews per day" => "متوسط بازديد در روز",
"Best day" => "بهترين روز",
"pvs" => "قبلي",
"Worst day" => "بدترين روز",
"Wiki Stats" => "آمار ويكي",
"Size of Wiki Pages" => "حجم صفحات ويكي",
"Mb" => "مگابايت",
"Average page length" => "متوسط طول صفحه",
"bytes" => "بايت",
"Average versions per page" => "متوسط نسخه در هر صفحه",
"Visits to wiki pages" => "بازديد از صفحات ويكي",
"Average links per page" => "متوسط پيوندها در هر صفحه",
"Image galleries Stats" => "آمار سرسراهاي تصاوير",
"Average images per gallery" => "متوسط تعداد تصوير در هر سرسرا",
"Total size of images" => "مجموع حجم تصاوير",
"Average image size" => "متوسط حجم تصاوير",
"Visits to image galleries" => "بازديد از سرسراهاي تصاوير",
"File galleries Stats" => "آمار سرسراهاي پرونده‌ها",
"Average files per gallery" => "متوسط تعداد پرونده در هر سرسرا",
"Total size of files" => "مجموع حجم پرونده‌ها",
"Average file size" => "متوسط حجم پرونده‌ها",
"Visits to file galleries" => "بازديد از سرسراهاي پرونده‌ها",
"CMS Stats" => "آمار سامانه‌ي مديريت محتوي",
"Total reads" => "مجموع قرائت‌ها",
"Average reads per article" => "متوسط قرائت هر مقاله",
"Total articles size" => "مجموع حجم مقالات",
"Average article size" => "متوسط حجم مقالات",
"Forum Stats" => "آمار انجمن‌ها",
"Total topics" => "مجموع موضوعات",
"Average topics per forums" => "متوسط تعداد موضوع در هر انجمن",
"Total threads" => "مجموع رگه‌ها",
"Average threads per topic" => "متوسط رگه‌ها در هر موضوع",
"Visits to forums" => "تعداد بازديد ار انجمن‌ها",
"Blog Stats" => "آمار بلاگ‌ها",
"Weblogs" => "وبلاگ‌ها‌",
"Total posts" => "مجموع الصاق‌ها",
"Average posts per weblog" => "متوسط الصاق در هر بلاگ‌",
"Total size of blog posts" => "حجم مجموع الصاق‌هاي بلاگ",
"Average posts size" => "متوسط حجم الصاق‌ها‌",
"Visits to weblogs" => "بازديد از وبلاگ‌ها",
"Poll Stats" => "آمار راي گيري‌ها",
"Total votes" => "مجموع راي‌ها",
"Average votes per poll" => "متوسط تعداد راي در هر راي‌گيري",
"Faq Stats" => "آمار سئوالات متداول",
"Total questions" => "مجموع سئوالات",
"Average questions per FAQ" => "متوسط تعداد سئوال در هر بخش",
"User Stats" => "آمار كاربران",
"User bookmarks" => "صفحه‌ياب(bookmark)هاي كاربران",
"Average bookmarks per user" => "متوسط تعداد صفحه‌ياب براي هر كاربر",
"Quiz Stats" => "آمار آزمون‌ها",
"Average questions per quiz" => "متوسط تعداد سئوال در هر آزمون",
"Quizzes taken" => "مجموع آزمون‌ها",
"Average quiz score" => "متوسط امتياز آزمون‌ها",
"Average time per quiz" => "متوسط زمان هر آزمون",
"Stats for surveys" => "آمار نظرسنجي‌ها",
"Survey" => "نظرسنجي",
"Last taken" => "آخرين اجرا",
"Stats for survey" => "آمار نظرسنجي",
"Stats for this survey Questions " => "آمار اين نظرسنجي",
"SysLog" => "ثبت وقايع",
"system logs" => "ثبت‌وقايع سامانه",
"system logs tpl" => "الگوي ثبت‌وقايع سامانه",
"IP" => " آدرس اينترنتي(IP)",
"Time Left" => "زمان باقي مانده",
"send answers" => "پاسخ‌ها را ارسال كن",
"Thank you for your submission" => "از ارائه‌ي شما متشكريم",
"Theme Control Center: categories" => "مركز كنترل قيافه‌ها: طبقات",
"ThemeControl" => "كنترل قيافه",
"ThemeControl tpl" => "الگوي كنترل قيافه",
"Theme is selected as follows" => "قيافه‌ها بدين ترتيب انتخاب مي‌شوند",
"If a theme is assigned to the individual object that theme is used." => "اگر قيافه‌اي به يك شيء منفرد تخصيص داده شده باشد، آن قيفه انتخاب مي‌شود.",
"If not then if a theme is assigned to the object's category that theme is used" => "وگرنه درصورتي كه يك قيافه به طبقه‌اي از اشياء تخصيص داده شده باشد، آن قيفه انتخاب مي‌شود.",
"If not then a theme for the section is used" => "وگرنه، درصورتي كه قيافه‌اي به يك بخش تخصيص داده شده باشد، آن قيفه انتخاب مي‌شود. ",
"If none of the above was selected the user theme is used" => "درصورتي كه هيچ‌كدام از موارد فوق نباشد، قيافه‌ي منتخب كاربر انتخاب مي‌شود.",
"Finally if the user didn't select a theme the default theme is used" => "و در پايان، اگر كاربر نيز قيافه‌اي انتخاب نكرده باشد، قيافه‌ي پيش‌فرض انتخاب مي‌شود.",
"Control by Objects" => "كنترل با اشياء",
"Control by Sections" => "كنترل با بخش‌ها",
"Assign themes to categories" => "تخصيص قيافه به طبقات",
"Assigned categories" => "طبقات تحصيص‌يافته",
"theme" => "قيافه",
"Theme Control Center: Objects" => "مركز كنترل قيافه‌ها: اشياء",
"ThemeControl Objects" => "اشياء كنترل قيافه",
"theme control objects tpl" => "الگوي اشياء كنترل قيافه‌ها",
"Control by Categories" => "كنترل با طبقات",
"Assign themes to objects" => "تخصيص قيافه به اشياءظ",
"Object" => "شئي",
"Assigned objects" => "اشياء تخصيص يافته",
"Theme Control Center: sections" => "مركز كنترل قيافه: بخش‌ها",
"theme control sections tpl" => "الگوي مركز قيافه‌ي بخش‌ها",
"Assign themes to sections" => "تخصيص قيافه‌ها به بخش‌ها",
"Assigned sections" => "بخش‌هاي تحصيص داده شده",
"Tiki community" => "اجتماع تيكي",
"{if \$editFileId}Edit File: {\$fileInfo.filename}{else}Upload File{/if}" => "{if \$editFileId}ويرايش پرونده‌ي: {\$fileInfo.filename}{else}بارگذاري پرونده{/if}",
"Browse gallery" => "مرور سرسرا",
"File Title" => "عنوان پرونده",
"File Description" => "شرح پرونده",
"Now enter the file URL" => "هم اكنون URL پرونده را وارد كنيد",
" or upload a local file from your disk" => " يا يك پرونده از دستگاه خود بارگذاري كنيد",
"Batch upload" => " بارگذاري دسته‌اي(Batch upload)",
"Errors detected" => "خطايي بوجود آمد",
"The following file was successfully uploaded" => "پرونده‌ي مذكور با موفقيت بارگذاري شد",
"You can download this file using" => "بدين‌وسيله مي‌توانيد اين پرونده را بارگذاري كنيد",
"You can include the file in an HTML/Tiki page using" => "بدين‌وسيله مي‌توانيد پرونده‌اي را در يك صفحه‌ي HTML يا تيكي بگنجانيد",
"You have to create a gallery first!" => "شما بايد ابتدا يك سرسرا ايجاد كنيد",
"Image Gallery tpl" => "الگوي سرسراي تصوير",
"or use filename" => "يا از نام اصلي پرونده استفاده كن",
"Now enter the image URL" => "يك URL تصوير وارد كنيد",
" or upload a local image from your disk" => " يا از دستگاه خود يك تصوير بارگذاري كنيد",
"Upload from disk" => " بارگذاري از دستگاه",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "تصويرك (اختياري، جايگزين ساخت خودكار تصويرك مي‌شود)",
"Upload successful!" => "بارگذاري موفقيت آميز بود!",
"The following image was successfully uploaded" => "تصوير مذكر با موفقيت بارگذاري شد",
"Thumbnail" => "تصويرك",
"Image ID thumb" => "تصويرك شناسه‌ي تصوير",
"You can include the image in an Wiki page using" => "بدين وسيله مي‌توانيد تصويري را دريك صفحه‌ي ويكي بگنجانيد",
"User assigned modules" => "ماژول‌هاي تخصيص يافته‌ي كاربر",
"User Assigned Modules" => "ماژول‌هاي تخصيص يافته‌ي كاربر",
"User Assigned Modules tpl" => "الگوي ماژول‌هاي تخصيص يافته‌ي كاربر",
"Restore defaults" => "برگرداندن پيش‌فرض‌ها",
"move to right column" => "انتقال به ستون چپ",
"unassign" => "حذف",
"move to left column" => "انتقال به ستون راست",
"Assign module" => "تخصيص ماژول",
"Module" => "ماژول",
"Column" => "ستنون",
"User Bookmarks tpl" => "الگوي صفحه‌ياب‌هاي كاربر",
"top" => "گره بالايي",
"Current folder" => "پوشه‌ي جاري",
"Folders" => "پوشه‌ها",
"Folder in" => "پوشه در",
"remove folder" => "پوشه را حذف كنت",
"refresh cache" => "بازيابي cache",
"Admin folders and bookmarks" => "مديريت پوشه‌ها و صفحه‌ياب‌ها",
"Add or edit folder" => "افزودن يا ويرايش پوشه",
"Add or edit a URL" => "افزودن يا ويرايش يك URL",
"Avatar" => "شكلك",
"Homepage" => "صفحه‌ي مبدا",
"Users HomePage" => "صفحه‌ي مبدا كاربران",
"Personal Wiki Page" => "صفحه‌ي شخصي ويكي‌",
"Create page" => "صفحه‌ي را بساز",
"Displayed time zone" => "نمايش زمان",
"This user is your friend" => "اين كاربر رفيق شماست",
"Request friendship from this user" => "درخواست رفاقت با اين كاربر",
"Send me a message" => "يك پيغام براي من بفرست",
"User Preferences" => "تنظيمات كاربر",
"UserPreferences tpl" => "الگوي تنظيمات كاربر",
"Personal Information" => "اطلاعات شخصي",
"General preferences" => "تنظيمات عمومي",
"Other preferences" => "ساير تنظيمات",
"Pick user Avatar" => "انتخاب شكلك كاربر",
"HomePage" => "صفحه‌ي مبدا",
"Your personal Wiki Page" => "صفحه‌ي شخصي ويكي شما",
"Your personal tracker information" => "اطلاعات tracker شخصي شما",
"Edit information" => "ويرايش اطلاعات",
"View extra information" => "مشاهده‌ي اطلاعات اضافي",
"Change information" => "تغيير اطلاعات",
"Is email public? (uses scrambling to prevent spam)" => "آيا پست الكترونيكي عمومي است؟(باعث دريافت Spam مي‌شود‌",
"Unavailable - please set your e-mail below" => "در دسترس نيست – لطفا آدرس پست الكترونيك خود را در زير ثبت كنيد",
"Does your mail reader need a special charset" => "آيا نرم‌افزار دريافت كننده‌ي پست‌هاي الكترونيكي شما به كاراكتر خاصي نيازمند است؟",
"Number of visited pages to remember" => "تعداد صفحات ديده شده‌اي كه  بايد در ياد بماند",
"UTC" => "ساعت هماهنگ فراگير(UTC)",
"Local" => "محلي(Local)",
"User information" => "اطلاعات كاربر",
"private" => "شخصي",
"public" => "عمومي",
"Use double-click to edit pages" => "از double-click براي ويرايش صفحات استفاده كن",
"Account Information" => "اطلاعات حساب",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "'كلمه‌ي عبور' و 'تاييد كلمه‌ي عبور' را خالي بگذاريد تا كلمه‌ي عبور كنوني باقي بماند",
"Email address" => "آدرس پست الكترونيكي",
"Confirm new password" => "كلمه‌ي عبور جديد رو تاييد كنيد",
"Current password (required)" => "كلمه‌ي عبور كنوني(ضروري)",
"Change administrative info" => "تغيير اطلاعات سرپرستي",
"Messages per page" => "پيغام در هر صفحه",
"Allow messages from other users" => "دريافت پيغام از ساير كاربران مجاز است",
"Send me an email for messages with priority equal or greater than" => "هنگامي كه پيامي با درجه‌ي اولويت برابر يا بزرگتر از اين دريافت مي‌كنم، آن را با يك پست الكترونيكي برايم بفرست",
"Tasks per page" => "وظيفه در هرصفحه",
"My pages" => "صفحات من",
"My messages" => "پيغام‌هاي من‌",
"My tasks" => "وظايف من",
"My items" => "اقلام من",
"My workflow" => "جريان كاري من",
"User Tasks tpl" => "الگوي وظايف كاربر",
"New task" => "وظيفه‌ي جديد",
"Task list" => "فهرست وظايف",
"Admin mode off" => "حالت عادي",
"Admin mode on" => "حالت سرپرستي",
"Task help" => "كمك در وظايف",
"Received task" => "وظايف دريافت شده",
"You received this task, please read and execute it" => "شما اين وظيفه را دريافت كرده‌ايد، لطفا آن را مطالعه كرده و اجرا فرماييد",
"Send task" => "ارسال وظيفه",
"You send this task to a other user" => "شما اين وظيفه را به يك كاربر ديگر ارسال مي‌كند",
"Shared task" => "وظايف مشترك",
"This task is public to a special group" => "اين وظيفه براي يك گروه خاص عمومي است",
"accepted by task user and creator" => "پذيرفته شده از طرف كاربر وظيفه و ايجاد كننده",
"Task is accepted by user and creator" => "اين وظيفه از طرف كاربر موظف و ايجاد كننده پذيرفته شده است",
"not accepted by one user" => "از طرف يك كاربر پذيرفته شده است",
"Task is rejected by one user" => "وظيفه از طرف يك كاربر رد شده است",
"waiting for me" => "منتظر من هستند",
"Task is not accepted by you, read the task and accept or reject it" => "اين وظيفه از طرف شما پذيرفته نشده است، لطفا آن را مطالعه كرده، سپس رد يا قبولش كنيد",
"waiting for other user" => "منتظر ساير كاربران",
"Task is not accepted/rejected by other user" => "وظيفه از طرف كاربر قبول يا رد نشده است",
"empty trash" => "تخليه‌ي خاكرويه",
"Edit task" => "ويرايش وظيفه",
"NOT accept" => "قبول نشد",
"remove from trash" => "از خاكروبه هم حذفش كن",
"move into trash" => "انتقال به خاكروبه",
"Task saved" => "وظيفه ذخيره شد",
"Edit Task" => "ويرايش وظيفه",
"View Task" => "مشاهده‌ي وظيفه",
"Open a new task" => "گشايش يك وظيفه‌ي جديد",
"Task user" => "كاربر موظف",
"Only the creator can delete this task" => "تنها ايجاد كننده مي‌تواند اين وظيفه را حذف كند",
"open / in process" => "بازكردن / در فرايند",
"waiting / not started" => "درحال انتظار/هنوز آغاز نشده است",
"Percentage completed" => "درصد پيشرفت",
"waiting" => "انتظار",
"shared for group" => "مشترك براي گروه",
"accepted by user" => "پذيرفته شده از طرف كاربر",
"no / rejected" => "خير / رد شده",
"accepted by creator" => "پذيرفته شده از طرف ايجاد كننده",
"Info" => "اطلاعات",
"This message will be send to users if you are makeing changes of assigned tasks" => "درصورتي كه تغييراتي در وظايف اختصاص داده‌شده دهيد، اين پيغام براي كاربران ارسال خواهد شده",
"Send message with changes" => "پيغام را با تغييرات ارسال كن",
"Modified by" => "تغيير كرده به‌وسيله‌ي",
"Maked as deleted" => "با عنوان حذف شده علامت بخورند",
"Inform task user by email" => "كاربر موظف را با پست الكترونيكي آگاه كن",
"reload" => "باركردن مجدد",
"You can only view this task" => "شما تنها اين وظيفه را مي‌توانيد ببينيد",
"priority" => "اولويت",
"%m/%d/%Y [%H:%M]" => "%m/%d/%Y [%H:%M]",
"No tasks entered" => "هيچ وظيفه‌اي وارد نشده است.",
"select one" => "يكي را انتخاب كنيد",
"trash" => "خاكروبه",
"undo trash" => "بازگشت از خاكروبه",
"show:" => "نمايش بده:",
"received" => "دريافت شده‌ها",
"submitted" => "ارائه شده",
"shared" => "مشترك",
"all shared tasks" => "تمام وظايف مشترك",
"completed (100%)" => "تماما (100%) تكميل شد",
"Public for group" => "Public for group",
"User Watches tpl" => "الگوي ديده‌بان‌هاي كاربر",
"Add Watch" => "افزودن ديده‌بان",
"edit user files" => "ويرايش پرونده‌هاي كاربر",
"May need to refresh twice to see changes" => "ممكن است براي ديدن تغييرات، احتياج به دو بار بازيابي باشد",
"Add top level bookmarks to menu" => "صفحه‌ياب‌هاي برتر را به منو اضافه كن",
"Pos" => "رديف",
"Mode" => "حالت",
"replace window" => "جايگزيني پنجره",
"User_versions_for" => "نسخ كاربر براي",
"Insert Row" => "درج سطر",
"Insert Column" => "درج ستون",
"Remove Row" => "حذف سطر",
"Remove Column" => "حذف ستون",
"Merge Cells" => "ادغام ستون",
"Restore Cells" => "بازيابي سلول‌ها",
"Copy Calculation" => "محاسبات را كپي كن",
"Format Cell" => "شكل‌دهي سلول",
"Before" => "قبل از",
"After" => "بعداز",
"expires:" => "منقضي در:",
"no comments" => "بدون شرح",
"Banner stats" => "آمار درفش‌ها",
"Create new banner" => "ساخت درفش جديد",
"Banner Information" => "اطلاعات درفش",
"Click ratio" => "نرخ كليك كردن",
"Weekdays" => "روزهاي هفته",
"mon" => "دو شنبه",
"tue" => "سه شنبه",
"wed" => "چهار شنبه",
"thu" => "پنج شنبه",
"fri" => "جمعه",
"sat" => "شنبه",
"sun" => "يك شنبه",
"Banner raw data" => "داده‌ي خام درفش",
" on " => " در ",
"RSS feed" => "تغذيه‌ي RSS",
"Edit blog" => "ويرايش بلاگ",
"monitor this blog" => "اين بلاگ را ديده‌باني كن",
"stop monitoring this blog" => "ديده‌باني اين بلاگ را متوقف كن",
"Activity=" => "فعاليت=",
"Find:" => "جستجو:",
"Sort posts by:" => "الصاق‌ها را براين اساس مرتب كن:",
"read more" => "اطلاعات بيشتر",
"pages" => "صفحه",
"Trackback pings" => "pingهاي trackback",
"URI" => "آدرس URI",
"Blog name" => "نام بلاگ",
"Cached" => "cachشده",
"This is a cached version of the page." => "اين يك نسخه‌ي cache شده از اين صفحه است.",
"Click here to view the Google cache of the page instead." => "اين‌جا را كليك كنيد تا cach گوگل را با جاي آن ببينيد.",
"viewed" => "مشاهده شده",
"edit items" => "ويرايش اقلام",
"list charts" => "فهرست نمودارها",
"last chart" => "آخرين نمودار",
"previous chart" => "نمودار قبلي",
"Chart created" => "نموادار ايجاد شد",
"next chart" => "نمودار بعدي",
"pos" => "رديف",
"pre" => "قبلي",
"perm" => "قطعيت",
"item" => "قلم",
"chg" => "تغييرات",
"avg" => "معدل",
"info/vote" => "مشاهده‌ي اطلاعات/دادن راي",
"Next chart will be generated on" => "نمودار بعدي در اين تاريخ توليد خواهد شد",
"View or vote items not listed in the chart" => "مشاهده يا انتخاب اقلامي كه در اين نمودار نيامده‌اند",
"Select something to vote on" => "موردي را براي راي دادن انتخاب كنيد",
"Item information" => "اطلاعات فقره",
"Chart" => "نام نمودار",
"Permanency" => "قطعيت",
"Dif" => "تعريف",
"Best Position" => "بهترين موقعيت",
"Vote this item" => "ارزش اين فقره",
"Highest" => "بيشترين ارزش",
"view faq" => "مشاهده‌ي FAQ",
"view faq tpl" => "الگوي مشاهده‌ي FAQ",
"admin menus tpl" => "الگوي مديريت منوها",
"Answers" => "پاسخ‌ها",
"Q" => "س",
"A" => "ج",
"add suggestion" => "افزودن پيشنهاد",
"1 suggestion" => "1 پيشنهاد",
"suggestions" => "پيشنهاد",
"Forum List" => "فهرست انجمن",
"Edit Forum" => "ويرايش انجمن",
"monitor this forum" => "اين انجمن را ديده‌باني كن",
"stop monitoring this forum" => "ديده‌باني اين انجمن را متوقف كن",
"You have {\$unread} unread private messages" => "شما {\$unread} عدد پيغام نخوانده‌ي شخصي داريد",
"Your message has been queued for approval, the message will be posted after\na moderator approves it." => "پيغام شما براي تاييد در صف قرار گرفته است و پس از تاييد ناظم الصاق خواهد شد.",
"You have to enter a title and text" => "شما بايد يك متن و عنوان وارد كنيد",
"post new comment" => "الصاق نظريه جديد",
"HTML tags are not allowed inside comments" => "تگ‌هاي HTML درون نظرات مجاز نيستند",
"moderator actions" => "اعمال ناظم",
"move selected topics" => "عناوين منتخب را انتقال بده",
"unlock selected topics" => "قفل عنواين منتخب را باز كن",
"lock selected topics" => "عناوين منتخب را قفل كن",
"delete selected topics" => "عناوين منتخب را حذف كن",
"merge" => "ادغام",
"merge selected topics" => "عناوين منتخب را اذغام كن",
"reported messages:" => "پيغام‌هاي گزارش شده:",
"queued messages:" => "پيغام‌هاي در صف",
"Merge into topic" => "ادغام در عنوان",
"emot" => "احساسات",
"pts" => "امتياز",
"No topics yet" => "هنوز هيچ عنواني وجود ندارد.",
"topics in this forum" => "عناوين اين انجمن",
"Show posts" => "الصاق‌ها را نمايش بده",
"Last hour" => "ساعت گذشته",
"Last 24 hours" => "24 ساعت گذشته",
"Last 48 hours" => "48 ساعت گذشته",
"Jump to forum" => "به اين انجمن بپر",
" unread private messages" => " پيغام شخصي خوانده نشده",
"prev topic" => "عنوان قبلي",
"next topic" => "عنوان بعدي",
"monitor this topic" => "اين عنوان را ديده‌باني كن",
"stop monitoring this topic" => "ديده‌باني اين عنوان با متوقف كن",
"Comments below your current threshold" => "نظرات پايين‌تر از حد آستانه‌ي شما",
"IRC log" => "ثبت وقايع IRC",
"Select" => "انتخاب",
"Show All" => "نمايش همه",
"Edit fields" => "ويرايش ستون‌ها",
"Insert new item" => "درج فقره‌ي جديد",
"Choose a filter" => "يك فيلتر انتخاب كنيد",
"list attachments" => "فهرست ضمايم",
"View inserted item" => "مشاهده‌ي اقلام درج شده",
"Editing tracker item" => "ويرايش فقره tracker",
"View" => "مشاهده",
"View item" => "مشاهده‌ي فقره",
"Filter Tracker Items" => "اقلام tracker را فيلتر كن",
"Not rated yet" => "هنوز رتبه‌بندي نشده است.",
"Add a comment" => "ايراد نظر",
"Attach a file to this item" => "يك پرونده به اين فقره ضميمه كن",
"more info" => "اطلاعات بيشتر",
"download" => "دريافت",
"No attachments for this item" => "اين فقره هيچ ضميمه‌اي ندارد",
"Special Operations" => "اعمال خاص",
"close" => "ببند",
"Webmail Doc" => "مستندات پست تحت وب",
"Webmail Doc template" => "الگوي مستندات پست تحت وب",
"settings" => "تنظيمات",
"mailbox" => "صندوق پستي",
"compose" => "تهيه‌ي نامه",
"contacts" => "تماس‌ها",
"Contacts" => "تماس‌ها",
"Add new mail account" => "اضافه كردن يك حساب پست الكترونيكي",
"User accounts" => "حساب‌هاي كاربران",
"pop" => "درگاه pop",
"View All" => "مشاهده‌ي همه",
"Msg" => "پيغام",
"sender" => "فرستنده",
"flagged" => "علامت‌دار",
"replied" => "پاسخ داده‌شده",
"clip" => "كليپ",
"back to mailbox" => "بازگشت به صندوق پستي",
"full headers" => "سرصفحه‌هاي كامل",
"normal headers" => "سرصفحه‌هاي معمولي",
"reply all" => "پايه به همه",
"forward" => "ارجاع",
"Create/edit contacts" => "ايجاد/ويرايش تماس",
"select from address book" => "از كتابچه‌ي آدرس انتخاب كن",
"cc" => "رونوشت",
"bcc" => "رونوشت مخفي",
"Use HTML mail" => "از پست الكترونيكي HTML استفاده كن",
"The following addresses are not in your address book" => "اين آدرس‌ها در كتابچه‌ي آدرس نيستند",
"add contacts" => "افزودن گيرنده",
"Attachment 1" => "ضميمه‌ي 1",
"Attachment 2" => "ضميمه‌ي 2",
"Attachment 3" => "ضميمه‌ي 3",
"Address book" => "كتابچه‌ي آدرس",
"%s enabled" => "%s فعال شد",
"%s disabled" => "%s غيرفعال شد",
"Click here to delete this category" => "براي حذف اين طبقه، اين‌جا را كليك كنيد",
"No chart indicated" => "هيچ نموداري مشخص نشده است.",
"Upload failed" => "بارگذاري شكست خورد",
"Feature disabled" => "خصيصه غيرفعال شد",
"No event indicated" => "هيچ رويداد مشخص نشده است.",
"You have to provide a hotword and a URL" => "شما بايد يك URL و يك واژه‌ي آتشين فراهم كنيد",
"No page indicated" => "هيچ صفحه‌اي انتخاب نشده است.",
"Detected, Version:" => "يافت شد، نسخه:",
"Not detected." => "كشف نشد",
"The passwords don't match" => "كلمه‌ي عبور همخواني ندارد",
"Password should be at least" => "كلمهِ‌ي عبور بايد حداقل",
"characters long" => "حرف داشته باشد",
"Your admin password has been changed" => "كلمه‌ي عبور سرپرست تغيير كرد",
"All Fields except gdaltindex must be filled" => "تمام ستون‌ها مگر gdaltindex بايد پر شوند",
"No valid gdaltindex executable" => "gdaltindex نامعتبر و غيرقابل اجرا",
"Altering database table failed" => "دگرگون‌سازي(Altering) جدول بانك اطلاعاتي ناموفق بود",
"Tag already exists" => "برچسب قبلا ايجاد شده است",
"Tag not found" => "برچسب پيدا نشد",
"Repository name can't be an empty" => "نام مخرن نمي‌تواند خالي باشد",
"Requested action is not supported on repository" => "عمل درخواستي قابل انجام بر روي مخزن نيست",
"No repository" => "هيچ مخزني نيست",
"Search is mandatory field" => "جستجوي يك ستون اجباري است",
"File not found " => "پرونده پيدا نشد ",
"Requested action in not supported on repository" => "عمل درخواستي روي مخزن پشتيباني نمي‌شود",
"Non-existent link" => "پيوند وجود ندارد",
"Mail-in account %s incorrect" => "حساب 'كنترل با پست الكترونيكي' %s ناصحيح است",
"Mail-in account %s saved" => "حساب 'كنترل با پست الكترونيكي' %s ذخيره شد",
"Frequency should be a positive integer!" => "تناوب بايد يك عدد مثبت باشد!",
"Mail-in accounts set to be checked every %s minutes" => "حساب 'كنترل با پست الكترونيكي' براي بررسي در هر %s دقيقه تنظيم شد",
"Automatic Mail-in accounts checking disabled" => "بررسي خودكار حساب 'كنترل با پست الكترونيكي' غيرفعال شد",
"No menu indicated" => "هيچ منواي مشخص نشده است",
"No newsletter indicated" => "هيچ خبرنمامه‌اي مشخص نشده است",
"No poll indicated" => "هيچ راي‌گيري‌اي مشخص نشده است",
"unsafe" => "ناامن",
"register_globals should be off by default. See the php manual for details." => "register_globals بايد  به‌صورت پيش‌فرض خاموش باشد. براي اطلاعات بيشتر سند راهنماي PHP را مطالعه كنيد",
"safe" => "امن",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid بايد به‌صورت پيش‌فرض خاموش باشد. براي اطلاعات بيشتر سند راهنماي PHP را مطالعه كنيد",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir احتمالا در پوشه‌ي تيكي‌ويكي شماست. اين خطر وجود دارد كه فردي پرونده‌اي را در اين پوشه بارگذاري كرده و از طريق وي به آن دسترسي پيدا كند",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "نمي‌توانم بررسي كنم كه آيا upload_tmp_dir از طريق وب قابل دسترس است يا خير. براي اطمينان بايد تنظيمات سرور وب خود را بررسي كنيد.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "تنظيم xbithack امن نيست! بسته به نحوه‌ي اداره كردن وب‌سرور شما و تنظيمات تيكي، ممكن است مهاجمين بتوانند پرونده‌اي به سرسراي پرونده‌ها بارگزاري كرده و آن را اجرا كنند",
"The Path to store files in the filegallery should be outside the tiki root directory" => "آدرس ذخيره‌ي پرونده‌ها در سرسراي پرونده بايد خارج از پوشه‌ي مادر تيكي باشد",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "آدرس ذخيره‌ي پرونده‌ها در سرسراي تصوير بايد خارج از پوشه‌ي مادر تيكي باشد",
"This is not a Tikiwiki File. Check if this file was uploaded and if it is dangerous." => "اين يك پرونده‌ي تيك ويكي نيست. بررسي كنيد كه آيا پرونده بارگزاي شده است يا خير و اين‌كه خطرناك نباشد.",
"File is not readable. Unable to check." => "پرونده قابل خواندن نيست. نمي‌توانم بررسي كنيم.",
"This file is modified." => "اين پرونده تغيير كرده است.",
"You have to provide a word" => "شما بايد كلمه‌اي وارد كنيد",
"You must specify a page name, it will be created if it doesn't exist." => "بايد نام صفحه را وارد كنيد، اگر وجود نداشته باشد، ساخته خواهد شد",
"page not added (Exists)" => "صفحه اضافه نشد(وجود داشت)",
"No survey indicated" => "هيچ نظرسنجي‌اي مشخص نشده است",
"You don't have permission to use this feature" => "متاسفانه شما حقوق دسترسي كافي براي استفاده از اين خصيه را نداريد",
"No Errors detected" => "هيچ خطايي يافت نشد",
"No tracker indicated" => "هيچ trackerاي مشخص نشده است",
"Group already exists" => "اين گروه قبلا ايجاد شده است.",
"The file is not a CSV file or has not a correct syntax" => "اين پرونده، يك پرونده‌ي CSV نيست يا اشكالي در نحو آن وجود دارد",
"No records were found. Check the file please!" => "هيچ ركوردي يافت نشد. لطفا پرونده را كنترل كنيد!",
"User login is required" => "احتياج به نام ورود براي كاربر است",
"Password is required" => "احتياج به كلمه‌ي عبور است",
"Email is required" => "اجتياج به پست الكترونيكي است",
"User is duplicated" => "كاربر تكراري است",
"Created account %s <%s>" => "حساب %s <%s> ايجاد شد",
"Assigned %s in group %s" => "%s به گروه %s منتصب شد",
"User %s already exists" => "كابر %s از قبل وجود داشت",
"New %s created with %s %s." => "%s جديد با %s %s ايجاد شد",
"Impossible to create new %s with %s %s." => "ساخت %s جديد با %s %s غير ممكن است.",
"%s %s successfully deleted." => "%s %s يا موفقيت ايجاد شد",
"%s %s removed from %s %s." => "%s %s با موفقيت از %s %s حذف شد",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> با موفقيت حذف شد.",
"%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> به  %s <b>%s</b> اختصاص يافت",
"%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> از %s <b>%s</b> حذف شد.",
"group <b>%s</b> set as the default group of user <b>%s</b>." => "گروه <b>%s</b> با موفقيت به عنوان گروه پيش‌فرض كاربر <b>%s</b> قرار گرفت.",
"User already exists" => "اين كاربر قبلا ايجاد شده بود",
"The passwords dont match" => "كلمه‌ي عبور با تكرارش همخواني ندارد",
"Password must contain both letters and numbers" => "كلمه‌ي عبور بايد هم شامل حروف و و هم عدد باشد.",
"%s modified successfully." => "%s با موفقيت تغيير يافت.",
"%s modification failed." => "تغيير %s موفقيت‌آميز نبود",
"%s changed from %s to %s" => "%s از %s به %s تغيير يافت",
"Impossible to change %s from %s to %s" => "تغيير %s از %s به %s غيرممكن است",
"rss feed disabled" => "تغذيه‌ي RSS غيرفعال شد",
"Permission denied you cannot view this section" => "متاسفانه شما حقوق دسترسي لازم براي مشاهده‌ي اين بخش را نداريد",
"Tiki RSS feed for articles" => "تغذيه‌ي RSSهاي تيكي براي مقالات",
"Last articles." => "آخرين مقالات",
"Unknown group" => "گروه نامشخص",
"Group doesnt exist" => "گروه وجود ندارد",
"Unknown user" => "كاربر نامشخص",
"User doesnt exist" => "كاربر وجود ندارد",
"You have to indicate a group" => "بايد يك گروه مشخص كنيد",
"This group is invalid" => "اين گروه معتبر نيست",
"Removed %s from group %s" => "%s از %s حذف شد",
"Permission denied you cannot view backlinks for this page" => "متاسفانه شما حقوق دسترسي كافي براي مشاهده‌ي backlinkهاي اين صفحه را نداريد",
"The page cannot be found" => "صفحه يافت نشد",
"Permission denied you cannot post" => "متاسفانه شما حقوق دسترسي لازم براي الصاق را نداريد",
"Permission denied you cannot edit this post" => "متاسفانه شما حقوق دسترسي لازم براي تغيير اين الصاق را نداريد.",
"You can't post in any blog maybe you have to create a blog first" => "شما به هيچ بلاگي نمي‌توانيد الصاق كنيد، شايد ابتدا بايستي بلاگ‌اي ايجاد نماييد.",
"Top visited blogs" => "پربيننده‌ترين بلاگ‌ها",
"Last posts" => "آخرين الصاق‌ها",
"Top active blogs" => "فعال‌ترين بلاگ‌ها",
"No blogId specified" => "هيچ بلاگي مشخص نشده است.",
"Tiki RSS feed for blog: " => "تغذيه‌ي RSS تيكي براي بلاگ: ",
"Tiki RSS feed for weblogs" => "تغذيه‌ي RSS تيكي براي وبلاگ‌ها",
"Last posts to weblogs." => "آخرين الصاق‌ها به وبلاگ‌ها",
"TOP" => "فوقاني",
"Permission denied you cannot access this gallery" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد به اين سرسرا دسترسي داشته باشيد.",
"No gallery indicated" => "هيچ سرسرايي مشخص نشده است.",
"Please login" => "لطفا وارد شويد",
"Permission denied you cannot view this page" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد اين صفحه را ببينيد.",
"Permission denied you can not view this section" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد اين بخش را ببينيد.",
"Permission denied you cannot remove images from this gallery" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد تصاوير را از اين سرسرا حذف كنيد.",
"Permission denied you cannot rebuild thumbnails in this gallery" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد تصويرك‌هاي اين سرسرا را از نو بسازيد.",
"Permission denied you cannot rotate images in this gallery" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد تصاوير اين سرسرا را بچرخانيد.",
"No image indicated" => "هيچ تصويري مشخص نشده است.",
"Permission denied you cannot move images from this gallery" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد تصاوير اين سرسرا را منتقل كنيد.",
"Permission denied you cannot view the calendar" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد اين تقويم را مشاهده كنيد.",
"event without name" => "رويداد بدون نام",
"%m/%d" => "%m/%d",
"No category indicated" => "هيچ طبقه‌اي مشخص نشده است.",
"Permission denied; you cannot assign permissions for this category" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد براي اين طبقه حقوق دسترسي تعريف كنيد",
"The passwords didn't match" => "كلمه‌ي عبور هم‌خواني ندارد",
"You can not use the same password again" => "نمي‌توانيد از همان كلمه‌ي عبور مجددا استفاده كنيد",
"Invalid old password" => "كلمه‌ي عبور قبلي اشتباه است",
"Permission denied to use this feature" => " دسترسي ممنوع است:متاسفانه شما نمي‌توانيد از اين خصيصه استفاده كنيد",
"No channel indicated" => "هيچ كانالي مشخص نشده است.",
"No nickname indicated" => "هيچ نام مستعاري مشخص نشده است.",
"Top authors" => "برترين مؤلفين",
"ERROR: you must include a subject or a message at least" => "خطا: بايد حداقل يك موضوع يا متن وارد كنيد",
"Message sent to" => "پيغام ارسال شد به",
"You need to change chmod 'whelp' manually to 777" => "بابد دسترسي 'whelp' را به‌صورت دستب به 777 تغيير دهيد.",
"This feature has been disabled" => "اين خصيصه غيرفعال شده است",
"Tiki RSS feed for directory sites" => "تغذيه‌ي RSS براي پايگاه‌هاي پوشه",
"Last sites." => "آخرين پايگاه‌ها",
"Must enter a name to add a site. " => "براي افزودن پايگاه بايد يك نام وارد كنيد. ",
"Must enter a url to add a site. " => "براي وارد كردن يك پايگاه بايد يك URL وارد كنيد. ",
"URL already added to the directory. Duplicate site? " => "URL قبلا به پوشه اصافه شده بود، تكراري اضافه كنم؟",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL قابل دسترس نسيت. URL اشتباه است يا پايگاه روي‌خط نيست و نمي‌تواند به پوشه اصافه شود. ",
"Must select a category. " => "بايد يك طبقه انتخاب كنيد. ",
"Must enter a name to add a site" => "براي افزودن يك پايگاه بايد يك نام وارد كنيد",
"Must enter a url to add a site" => "براي افزودن يك پايگاه بايد يك URL وارد كنيد",
"URL already added to the directory. Duplicate site?" => "URL قبلا به پوشه اصافه شده بود، تكراري اضافه كنم؟",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL قابل دسترس نسيت. URL اشتباه است يا پايگاه روي‌خط نيست و نمي‌تواند به پوشه اصافه شود. ",
"Must select a category" => "بايد يك طبقه انتخاب كنيد. ",
"No site indicated" => "هيچ پايگاهي مشخص نشده است.",
"No parent specified" => "هيچ والدي مشخص نشده است.",
"Last sites of directory \".\$rc[\"name\"].\" ." => "آخرين پايگاه‌هاي پوشه‌ي \".\$rc[\"name\"].\" .",
"You can not download files" => "شما نمي‌توانيد پرونده دريافت كنيد",
"Permission denied you cannot edit this article" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين مقاله را ويرايش كنيد",
"The language can't be changed as its set of translations has already this language" => "زبان نمي‌تواند تغيير كند، چراكه مجموعه‌ي ترجمه‌ها اين زبان را دارد",
"You do not have permissions to edit banners" => "شما حق دسترسي براي ويرايش درفش‌ها(banners) را نداريد",
"Banner not found" => "درفش(banner) پيدا نشد",
"You do not have permission to edit this banner" => "شما حق دسترسي براي ويرايش اين درفش(banner) را نداريد",
"Permission denied you cannot create or edit blogs" => "دسترسي غير ممكن است، شما نمي‌توانيد بلاگ بسازيد يا تغيير دهيد",
"Permission denied you cannot edit this blog" => "دسترسي غيرممكن است، شما نمي‌توانيد اين بلاگ را تغيير دهيد",
"You do not have permission to write the style sheet" => "متاسفانه شما حقوق دسترسي كافي براي نوشتن سبك نگارش(Style sheet) نداريد",
"Invalid request to edit an image" => "درخواست نامعتبر براي ويرايش يك تصوير",
"Permission denied you cannot edit images" => "دسترسي غيرممكن است، شما نمي‌توانيد تصاوير را تغيير دهيد",
"Permission denied you can edit images but not in this gallery" => "دسترسي ممنوع است: شما مي‌توانيد تصاوير را ويرايش كنيد، اما نه در اين سرسرا",
"Failed to edit the image" => "ويرايش تصوير ناموفق بود",
"Shortname must be 2 Characters" => "نام اختصار بايد 2 حرف باشد",
"You must provide a longname" => "بايد نام مشروح را وارد كنيد",
"Language created" => "زبان ايجاد شد",
"No content id indicated" => "هيچ شناسه‌ي محتوايي مشخص نشده است.",
"No project reference assigned" => "هيچ ارجاع پروژه‌اي منصوب نشده است",
"File Gallery successfully added to the project." => "سرسراي پرونده با موفقيت به پروژه اضافه شد.",
"No question indicated" => "هيچ سئوالي مشخص نشده است.",
"No quiz indicated" => "هيچ آزموني مشخص نشده است.",
"No structure indicated" => "هيچ ساختاري مشخص نشده است.",
"Invalid structure_id or page_ref_id" => "شناسه‌ي ساختار يا شناسه‌ي ارجاع به صفحه معتبر نيست",
"Permission denied you cannot send submissions" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد ارائه كنيد",
"Permission denied you cannot edit submissions" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد ارائه‌ها را ويرايش كنيد",
"You have to create a topic first" => "بايد ابتدا يك موضوع ايجاد كنيد",
"You do not have permission to do that" => "متاسفانه براي اين‌كار حقوق دسترسي كافي نداريد",
"You do not have permission to write the template" => "متاسفانه شما حقوق دسترسي كافي براي نوشتن الگو نداريد",
"You do not have permission to read the template" => "متاسفانه شما حقوق دسترسي كافي براي خواندن الگو نداريد",
"No topic id specified" => "هيچ شناسه‌ي موضوعي مشخص نشده است.",
"Invalid topic id specified" => "شناسه‌ي موضوع مشخص شده معتبر نيست",
"No object indicated" => "هيچ شيئي مشخص نشده است.",
"No type indicated" => "هيچ نوعي مشخص نشده است.",
"Article not found" => "مقاله پيدا نشد.",
"Permission denied you cannot edit this page" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين صفحه را ويرايش كنيد",
"page imported" => "صفحه وارد شد",
"created from import" => "ساخته شده از طريق واردات",
"Can't import remote HTML page" => "نمي‌توانم صفحه‌ي راه‌دور HTML را وارد كنم",
"Can't parse remote HTML page" => "نمي‌توانم صفحه‌ي راه‌دور HTML را تجزيه كنم",
"You cannot edit this page because it is a user personal page" => "از آن‌جايي كه اين صفحه، يك صفحه‌ي شخصي كاربر است، شما نمي‌توانيد اين صفحه را ويرايش كنيد",
"The SandBox is disabled" => "دست‌گرمي غيرفعال است",
"Cannot edit page because it is locked" => "نمي‌توان اين صفحه را ويرايش كرد. صفحه قفل است",
"unknown error" => "خطاي نامشخص",
"cannot be found" => "پيدا نشد",
"You must be logged in to subscribe to events" => "براي عضويت در رويدادها بايد ابتدا وارد سامانه شويد.",
"No permission to view the page" => "حقوق دسترسي‌اي براي ديدن اين صفحه وجود ندارد",
"Access Denied" => "دسترسي ممنوع است",
"No questions group indicated" => "هيج گروه سئوالي مشخص نشده است.",
"Permission denied you cannot create galleries and so you cant edit them" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد سرسرا ايجاد كنيد، درنتيجه نمي‌توانيد آن‌ها را ويرايش كنيد",
"Permission denied you cannot edit this gallery" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين سرسرا را ويرايش كنيد",
"Permission denied you cannot remove this gallery" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين سرسرا را حذف كنيد",
"Top visited file galleries" => "پربيننده‌ترين سرسراهاي پرونده",
"Most downloaded files" => "پرونده‌هايي كه از همه بيشتري دريافت شده‌اند",
"Last files" => "آخرين پرونده‌ها",
"Tiki RSS feed for file galleries" => "تغذيه‌ي RSS تيكي براي سرسراهاي پرونده",
"Last files uploaded to the file galleries." => "آخرين پرونده‌هاي بارگذاري شده در سرسراهاي پرونده",
"No galleryId specified" => "هيچ شناسه‌ي سرسرايي مشخص نشده است.",
"Tiki RSS feed for the file gallery: " => "تغذيه‌ي RSS تيكي براي سرسراي پرونده‌ي: ",
"No forum indicated" => "هيچ انجمني مشخص نشده است.",
"Forum posts" => "الصاق‌هاي انجمن",
"No forumId specified" => "هيچ شناسه‌ي انجمني مشخص نشده است",
"Tiki RSS feed for forum: " => "تغذيه‌ي RSS براي انجمن: ",
"Tiki RSS feed for forums" => "تغذيه‌ي RSS براي انجمن‌ها",
"Last topics in forums." => "آخرين موضوعات در انجمن‌ها",
"Go to your <a href=\"tiki-friends.php\">friendship network</a> to accept or refuse this request" => "براي پذيرش يا رد كردن اين درخواست به <a href=\"tiki-friends.php\">شبكه‌ي رفاقت خود</a> برويد.",
"Accepted friendship request from %s" => "درخواست رفاقت از طرف %s مورد قبول واقع شد",
"Refused friendship request from %s" => "درخواست رفاقت %s رد شد!",
"Broke friendship with %s" => "رابطه(رفاقت) را %s قطع شد",
"I have broken our friendship!" => "من رابطه‌مان(رابطه‌ي رفاقت) را قطع كردم!",
"You must be logged in to use this feature" => "براي استفاده از اين خصيصه بايد وارد سامانه شويد",
"Frienship request sent to %s" => "درخواست رفاقت براي %s ارسال شد",
"You're invited to join my network of friends!" => "شما براي پيوستن به شبكه‌ي رفقاي من دعوت شده‌ايد!",
"You're already friend of %s" => "شما هم‌اينك هم رفيق %s هستيد",
"Invalid username" => "نام كاربري معتبر نيست",
"I have accepted your friendship request!" => "من درخواست رفاقت شما را پذيرفته‌ام!",
"I have refused your friendship request!" => "من درخواست رفاقت شما را رد كرده‌ام!",
"No process indicated" => "هيچ فرايندي مشخص نشده است.",
"Activity name already exists" => "فعاليتي با اين نام قبلا ايجاد شده است",
"indicates if the process is active. Invalid processes cant be active" => "مشخص مي‌كند كه آيا فرايند فعال است يا خير. فرايندهاي نامعتبر نمي‌توانند فعال شوند",
"No instance indicated" => "هيچ نمونه‌اي مشخص نشده است.",
"No activity indicated" => "هشچ فعاليتي مشخص نشده است.",
"The process name already exists" => "فعاليتي با اين نام قبلا ايجاد شده است",
"Process already exists" => "اين فرايند هم‌اينك وجود دارد",
"You cant execute this activity" => "شما نمي‌توانيد اين فعاليت را اجرا كنيد",
"You couldn't abort a instance" => "شما نمي‌توانيد يك نمونه را متوقف كنيد",
"You couldn't exception a instance" => "نمي‌توانيد يك نمونه را مستثنا كنيد",
"No user indicated" => "هيچ كاربري مشخص نشده است.",
"No title indicated" => "هيچ عنواني مشخص نشده است.",
"No comment indicated" => "هيچ نظري مشخص نشده است.",
"No date indicated" => "هيچ تاريخي مشخص نشده است.",
"No item indicated" => ".هيچ موردي انتخاب نشده است",
"Individual Order" => "ترتيب فردي",
"first uploaded image" => "اولين تصوير بارگذاري شده",
"last uploaded image" => "آخرين تصوير بارگذاري شده",
"random image" => "يك تصوير تصادفي",
"Permission denied you cannot make the map of this gallery" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد نقشه‌ي اين سرسرا را تهيه كنيد",
"Top images" => "تصاوير برتر",
"Last images" => "آخرين تصاوير",
"You must be a student to edit homework pages." => "براي ويرايش صفحات مشق شب، شما بايد دانش‌آموز باشيد",
"No assignment indicated" => "هيچ انتصابي مشخصي نشده است.",
"Error: Invalid id for hw_pages table." => "خطا: شناسه‌ي نامعتبر براي جدول hw_pages.",
"Error: This page is being edited by another user." => "خطا: كاربر ديگري در حال ويرياش اين صفحه است",
"Permission denied: Students may only view or edit their own work." => "دسترسي ممنوع است: دانش‌آموزان تنها مي‌توانند تكاليف خود را مشاهده يا ويرايش كنند",
"Error: Assignment not found." => "خطا: انتصاب يافت نشد.",
"Permission denied: Students may NOT edit their work after the due date." => "دسترسي ممنوع است: دانش‌آموزان نمي‌توانند تكاليف خود را پس از تاريخ انجام تغيير دهند",
"Permission denied: The teacher must wait until the due date to edit students' work." => "دسترسي ممنوع است: معلم بايد تا پايان زمان انجام تكليف صبر كند تا بتواند كار دانش‌آموزان را ويرايش كنيد",
"No entries available yet!" => "هنوز هيچ فقره‌اي ثبت نشده است!",
"Permission denied: you must be a teacher to access this page." => "دسترسي ممنوع است: براي دسترسي به اين صفحه بايد معلم باشيد",
"Error: No assignment indicated." => "خطا: هيچ انتصابي يافت نشد",
"Error: assignment not found." => "خطا: انتصاب يافت نشد",
"You must be a student to view this page." => "براي مشاهده‌ي اين صفحه، شما بايد يك دانش‌آموز باشيد",
"Error: " => "خطا: ",
" is not a student." => " يك دانش‌آموزي نيست",
"specified." => "مشخص شده است.",
"Assignment not found" => "انتصاب پيدا نشد",
"Anonymous Grader" => "مصحح بي‌نام",
"Anonymous Peer Reviewer" => "مروركننده‌ي همتاي بي‌نام",
"No homework page indicated!" => "هيچ صفحه‌ي مشق شبي مشخص نشده است!",
"Error: Could not fetch page" => "خطا: نمي‌توانيم صفحه را واكشسي كنم",
"You must be a student to view this page!" => "براي ديدن اين صفحه بايد يك دانش‌آموزي باشيد!",
"Students may only view their own work!" => "دانش‌آموزيين تنها مي‌توانند كار خود را ببينند!",
"This function is deprecated in favor of the improved quizzes outside of the Homework feature." => "اين تابع باتوجه به آزمون‌هاي بهبوديافته‌ي خارج از خصيصه‌ي مشق شب، منسوخ شده است",
"Permission denied: You cannot rollback this page." => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين صفحه را به حالت قبل برگردانيد.",
"No hw page indicated" => "هيچ صفحه‌ي مشق شبي مشخص نشده است.",
"Error: nonexistant version specified." => "خطا: نسخه‌ي مشخص شده وجود ندارد.",
"Error: Could not fetch assignment " => "خطا: نمي‌توانم انتصاب را واكشي كنم ",
"You must be a student to view homework assignments." => "براي مشاهده‌ي انتصابات مشق شب بايد يك دانش‌آموز باشيد.",
"Permission denied you must be a student to view assignments." => "دسترسي ممنوع است: شما بايد يك دانش‌آموزي باشيد تا بتوانيد انتصاب‌ها را مشاهده كنيد",
"You must be a teacher or grader to access this page." => "براي دسترسي به اين صفحه، شما بايد يك معلم يا مصحح باشيد",
"Permission denied: You must be a teacher to edit assignments." => "دسترسي ممنوع است: براي ويرايش انتصابات شما بايد يك معلم باشيد.",
" error: Can not find assignment " => " خطا: نتوانستم پيدا كنم: ",
"Tiki RSS feed for image galleries" => "تغذيه‌ي RSS تيكي براي سرسراهاي تصاوير",
"Last images uploaded to the image galleries." => "آخرين تصاوير بارگذاري شده به سرسراهاي تصاوير",
"Tiki RSS feed for the image gallery: " => "تغذيه‌ي RSS تيكي براي سرسراي تصوير: ",
"overwriting old page" => "صفحات قديمي را بازنويسي كن",
"updated by the phpbb import process" => "به‌روز رساني شده توسط فرايند واردات phpbb",
"page created" => "صفحه ساخته شد",
"created from phpbb import" => "ساخت شده از واردات phpbb",
"You dont have permission to use this feature" => "متاسفانه شما حقوق دسترسي كافي براي استفاده از اين خصيصه را نداريد",
"updated from structured text import" => "به‌روز رساني شده توسط واردات متن ساختار يافته",
"created from structured text import" => "به‌روز رساني شده توسط واردات ساختار يافته",
"Sorry, \"\$page\" has not been created." => "متاسفم، صفحه‌ي  \"\$page\" ايجاد نشد هاست",
"No repository given" => "هيچ مخزني داده نشده است.",
"Permission denied you cannot view pages like this page" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد صفحاتي مانند اين صفحه را مشاهده كنيد",
"Permission denied you cannot remove articles" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد مقالات را حذف كنيد",
"Permission denied you cannot remove banners" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد درفش‌ها را حذف كنيد",
"Permission denied you cannot remove this blog" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين بلاگ را حذف كنيد",
"Non-existent gallery" => "چنين سرسرايي وجود ندارد",
"Permission denied you cannot remove files from this gallery" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد پرونده‌اي از اين سرسرا حذف كنيد",
"Permission denied you can't upload files so you can't edit them" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد پرونده‌اي بارگذاري كنيد، لذا نمي‌تواندي پرونده‌ها را ويرايش كنيد",
"Permission denied you cannot edit this file" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين پرونده را ويرايش كنيد",
"The game file must have .swf or .dcr extension" => "نام پرونده‌ي بازي بايد پسودي معادل .swf يا .dcr داشته باشد",
"The thumbnail name must be" => "نام تصويرك بايد ",
"Please supply both files" => "لطفا هردو پرونده را فراهم كنيد",
"You cannot admin blogs" => "شما نمي‌توانيم بلاگ‌ها را مديريت كنيد",
"Permission denied you cannot remove submissions" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد ارائه‌ها را حذف كنيد",
"Permission denied you cannot approve submissions" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد ارائه‌ها را تاييد كنيد",
"Permission denied you cannot view pages" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد صفحات را ببينيد",
"Permission denied you cannot remove pages" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد صفحات را حذف كنيد",
"You have to enable cookies to be able to login to this site" => "براي ورود به اين پايگاه، بايد كوكي‌ها را در مرورگر خود براي اين پايگاه فعال كنيد",
"Invalid username or password" => "نام كاربري يا كلمه‌ي عبور معتبر نيست",
"Tiki mail-in auto-reply" => "پاسخ خودكار 'كنترل با پست الكترونيكي'",
"Sorry, you can't use this feature." => "متاسفم، شما نمي‌توانيد از اين خصيصه استفاده كنيد",
"changed" => "تغيير كرد",
"You do not have permissions to view the maps" => "متاسفانه شما حقوق دسترسي كافي براي مشاهده‌ي نقشه‌ها را نداريد",
"Maps feature is not correctly setup : Maps path is missing." => "خصيصه‌ي نقشه به درستي برپا نشده است: مسير نقشه‌ها مفقود است.",
"Please create a directory named \$map_path to hold your map files." => "لطفا يك پوشه با عنوان \$map_path براي نگه‌داري پرونده‌هاي نقشه‌ها بسازيد.",
"mapfile name incorrect" => "نام پرونده‌ي نقشه ناصحيح است.",
"This mapfile already exists" => "پرونده‌ي نقشه قبل تكراري است.",
"You do not have permission to write to the mapfile" => "متاسفانه شما حقوق دسترسي كافي براي نوشتن در اين پرونده‌ي نقشه را ندارد",
"You do not have permission to delete the mapfile" => "متاسفانه شما حقوق دسترسي لازم براي حذف اين پرونده‌ي نقشه را نداريد",
"I could not make a copy" => "نمي‌توانم يك رونوشت(كپي) تهيه كنم",
"You do not have permission to read the mapfile" => "متاسفانه شما حقوق دسترسي كافي براي خواندن اين پرونده‌ي نقشه را نداريد",
"You dont have permission to do that" => "متاسفانه شما حقوق دسترسي كافي بري انجام اين كار را نداريد",
"Tiki RSS feed for maps" => "تغذيه‌ي RSSهاي تيكي براي نقشه‌ها",
"List of maps available." => "فهرست نقشه‌هاي موجود.",
"You do not have permissions to view the layers" => "متاسفانه شما حقوق دسترسي كافي براي مشاهده‌ي لايه‌ها را نداريد",
"Could not upload the file" => "نمي‌توانم پرونده را بارگذاري كنم",
"You do not have permissions to delete a file" => "متاسفانه شما حقوق دسترسي كافي براي حذف يك پرونده را نداريد",
"File not found" => "پرونده پيدا نشد",
"You do not have permissions to create a directory" => "متاسفانه شما حقوق دسترسي كافي براي ساخت يك پوشه را نداريد",
"The Directory is not empty" => "پوشه خالي نيست",
"Invalid directory name" => "نام پوشه معتبر نيست",
"You do not have permissions to delete a directory" => "متاسفانه شما حقوق دسترسي كافي براي حذف يك پوشه را نداريد",
"You do not have permissions to create an index file" => "متاسفانه شما حقوق دسترسي كافي براي ساخت يك پرونده‌ي Index را نداريد",
"Invalid file name" => "نام پرونده معتبر نيست",
"Invalid files to index" => "پرونده‌ي غيرمعتبر براي ايندكس‌گذاري",
"I do not know where is gdaltindex. Set correctly the Map feature" => "من نمي‌دانم gdaltindex كجاست. لطفا خصيصه‌ي نقشه را صحيح تنظيم كنيد",
"I could not create the index file" => "نمي‌توانم پرونده‌ي Index را ايجاد كنم",
"Must be logged to use this feature" => "براي استفاده از اين خصيصه، بايد وارد سامانه شويد",
"Welcome at Hawiki" => "به 'هاويكي' خوش‌آمديد",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "استفاده از اين پايگاه تيكي‌ويكي براي دسترسي از طريق بسياري از ابزارهاي سيار مانند تلفن‌هاي WAP، PDAها، ابزارهاي i-mode و غيره آماده شده است.",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "شما مي‌توانيد با هدايت مرورگر ابزار خود به آدرس مقابل، اين پايگاه را در ابزار سيار خود مرور كنيد:",
"tiki-mobile.php" => "tiki-mobile.php",
"About" => "درباره",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "شما نياز به اجراي setup.sh :<br /> داريد.  كاربران متعارف apache عبارتند از: www-data, apache يا nobody",
"Your PHP installation does not have zlib enabled." => "نصب PHP شما، zlibاش فعال نيست.",
"You must log in to use this feature" => "براي استفاده از اين خصيصيه شما بايد وارد سامانه شويد",
"You do not have permission to view other users data" => "متاسفانه شما حقوق دسترسي كافي براي مشاهده‌ي اطلاعات ساير كاربران را نداريد",
"You must be logged in to subscribe to newsletters" => "براي عضويت در خبرنامه‌ها بايد وارد سامانه شويد",
"No server indicated" => "هيچ سروري مشخص نشده است",
"Cannot connect to" => "عدم توانايي در برقراري ارتباط با",
"Missing information to read news (server,port,username,password,group) required" => "اطلاعات لازم براي خواند اخبار مفقود شده است. (سرور، درگاه، نام كاربري، كلمه‌ي عبور و گروه مورد نيازاند)",
"Cannot get messages" => "نمي‌توانم پيغام‌ها را بگيرم",
"No note indicated" => "هيچ يادداشتي مشخص نشده است",
"merged note:" => "ادغام يادداشت: ",
"File is too big" => "پرونده خيلي بزرگ است",
"created from notepad" => "ايجاد شده از notepad",
"No name indicated for wiki page" => "هيچ نامي براي صفحه‌ي ويكي مشخص نشده است.",
"Page already exists" => "صفحه قبلا ايجاد شده بود",
"Permission denied you cannot assign permissions for this page" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد براي اين صفحه تخصيص حقوق دسترسي كنيد",
"Not enough information to display this page" => "اطلاعات كافي براي نمايش در اين صفحه وجود ندارد",
"Permission denied you cannot browse this page history" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد تاريخچه‌ي اين صفحه را مرور كنيد",
"No article indicated" => "هيچ مقاله‌اي مشخص نشده است",
"Article is not published yet" => "مقاله هنوز منتشر نشده است",
"No post indicated" => "هيچ الصاقي مشخص نشده است",
"Blog not found" => "بلاگ يافت نشد",
"No pages indicated" => "هيچ صفحه‌اي مشخص نشده است.",
"You must provide a project name" => "بايد يك نام براي پروژه فراهم كنيد",
"You must provide a project description" => "بايد يك توضيح براي پروژه فراهم كنيد",
"A project with that name already exists" => "پروژه‌اي با اين نام قبلا ايجاد شده بود",
"Pageviews" => "مشاهدات صفحه",
"Day" => "روز",
"You don't have permission to edit quizzes." => "متاسفانه شما حقوق دسترسي كافي براي ويرايش اين آزمون را نداريد.",
"No result indicated" => "هيچ نتيجه‌اي مشخص نشده است.",
"Permision denied" => "دسترسي ممنوع",
"Wrong registration code" => "كد ثبت‌نام اشتباه است",
"Username is too long" => "نام كاربري پيش از حد بلند است",
"Username cannot contain whitespace" => "نام كاربر نمي‌تواند جاي خالي داشته باشد",
"Wrong passcode you need to know the passcode to register in this site" => "كدعبور اشتباه است. براي ثبت‌نام در اين پايگاه، بايد كدعبور را بدانيد",
"Invalid email address. You must enter a valid email address" => "آدرسي پست الكترونيكي معتبر نيست. بايد يك آدرس معتبر وارد كنيد",
"The registration mail can't be sent. Contact the administrator" => "پست الكترونيكي ثبت‌نام را نمي‌توانم ارسال كنيم. با سرپرست تماس بگيريد",
"Unable to send mail. User has not configured email" => "امكان ارسال پست الكترونيكي وجود ندارد. كاربر پست الكترونيكي خود را پيكربندي نكرده است",
"A password and your IP address reminder email has been sent " => "پست الكتروينيكي يادآور كلمه‌ب عبور و آدرس IP شما ارسال شد ",
"A new password and your IP address has been sent " => "آدرس Ip شما و يك كلمه‌ب عبور جديد ارسال شد",
"to the registered email address for" => "به آدرسي‌هاي پست الكترونيكي ثبت شده براي",
"Invalid or unknown username" => "نام كاربري نامعتبر يا ناشناخته است",
"Permission denied you cannot remove versions from this page" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد نسخ اين صفحه را حذف كنيد",
"Permission denied you cannot rename this page" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد نام اين صفحه را تغيير دهيد",
"Cannot rename page because the new name begins with reserved prefix" => "از آن‌جايي كه اين نام صفحه با پيشوند اندوخته شده(reserved) آغاز مي‌‍شود، نمي‌توان نام آن را تغيير داد",
"Cannot rename page maybe new page already exists" => "نمي‌توانم صفحه را تغيير نام بدهم، احتمالا صفحه‌اي با اين نام وجود دارد.",
"changed '%s' from '%s' to '%s'" => "'%s' از '%s' به '%s' تغيير كرد",
"Non-existent version" => "نسخه وجود ندارد",
"Permission denied you cannot rollback this page" => "دسترسي ممنوع است: متاسفانه شما حق برگرداندن اين صفحه با حالت قبل را نداريد",
"Error Message" => "پيغام‌ها خطا",
"Tiki RSS Feed Error Message" => "پيغام‌هاي خطاي تغذيه‌ي RSS تيكي",
"You have to type a searchword" => "شما بايد يك كلمه براي جستجو وارد كنيد",
"Post recommendation at" => "الصاق توصيه شده در",
" successfully sent" => "با موفقيت ارسال شد",
" not sent" => " ارسال نشد",
"Invalid variable value : " => "مقدار متغيير نامعتبر است : ",
"You do not have permission to edit messages" => "متاسفانه شما حقوق دسترسي كافي براي ويرايش پيام‌ها را نداريد",
"This feature is for admins only" => "اين خصيصه تنها براي سرپرستان است",
"Page must be defined inside a structure to use this feature" => "صفحه بايد درون يك ساختار تعريف شده باشد تا بتوان از اين خصيصه استفاده كرد",
"You cannot take this quiz twice" => "نمي‌توانيد در اين آزمون دوبار شركت كنيد",
"Quiz time limit exceeded quiz cannot be computed" => "زمان آزمون به سر آمده است. آزمون به حساب نخواهد آمد",
"You cannot take this survey twice" => "شما نمي‌توانيد دوبار در اين نظرخواهي شركت كنيد",
"Please create a category first" => "لطفا ابتدا يك طبقه ايجاد كنيد",
"Upload was not successful" => "بارگذاري موفق نبود(Upload was not successful)",
"Invalid filename (using filters for filenames)" => "نام تصوير معتبر نيست (به دليل استفاده از فيلترها براي نام پرونده‌ها",
"No permission to upload zipped file packages" => "حقوق دسترسي براي بارگذاري بسته‌هاي تصاوير فشرده شده(zipped) وجود ندارد",
"Cannot read file" => "نمي‌توانم پرونده را بخوانم",
"File update was succesful" => "پرونده با موفقيت به‌روز رساني شد",
"Permission denied you cannot upload files" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد پرونده‌اي بارگذاري كنيد",
"Could not find the file requested" => "نمي‌توانم پرونده‌ي درخواستي را پيدا كنم",
"Permission denied you can upload files but not to this file gallery" => "دسترسي ممنوع است: شما مي‌توانيد پرونده بارگذاري كنيد، اما نه به اين سرسرا",
"Invalid imagename (using filters for filenames)" => "نام تصوير معتبر نيست (به دليل استفاده از فيلترها براي نام پرونده‌ها)",
"Error processing zipped image package" => "خطا در پردازش بسته‌ي تصاوير فشرده شده",
"No permission to upload zipped image packages" => "حقوق دسترسي براي بارگذاري بسته‌هاي تصاوير فشرده شده(zipped) وجود ندارد",
 "The uploaded file ist not recognized as a image" => "The uploaded file is not recognized as an image",
"Permission denied you cannot upload images" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد تصويري بارگذاري كنيد.",
"Permission denied you can upload images but not to this gallery" => "دسترسي ممنوع است: شما مي‌توانيد تصوير بارگذاري كنيد، اما نه در اين سرسرا",
"Cannot get image from URL" => "نمي‌توانم از اين URL تصوير را بگيرم",
"That is not an image (or you have php < 4.0.5)" => "اين يك تصوير نيست (يا نسخه‌ي PHP شما قديمي‌تر از 4.0.5 است)",
"cannot process upload" => "اشكال در بارگذاري تصوير(cannot process upload)",
"You have to provide a name to the image" => "بايد براي اين تصوير يك نام فراهم كنيد",
"Usage" => "استفاده",
"Feature" => "خصيصه",
 "No url indicated" => "No URL indicated",
"You are not logged in and no user indicated" => "شما وارد سامانه نشده اين و هيچ كاربري مشخص نشده است.",
"The user has chosen to make his information private" => "كاربر اين اطلاعات را جزو اطلاعات شخصي خود قرار داده است",
"Invalid password.  Your current password is required to change administrative information" => "كلمه‌ي عبور نامعتبر. براي تغيير اطلاعات سرپرستي كلمه‌ي عبور كنوني شما مورد نياز است",
"Email is set to %s" => "پست الكترونيكي تنظيم شده است به %s",
"The passwords did not match" => "كلمه‌ي عبور هم‌خواني ندارد",
"unicode" => "unicode",
"was moved into trash" => "به خاكروبه منتقل شد",
"trashed by" => "منتقل شده به خاكروبه به‌وسيله‌ي",
"Rights by creator" => "حقوق به‌وسيله‌ي ايجاد كننده",
"END" => "پايان",
"Percentage" => "درصد",
"Task accepted by creator" => "وظيفه به‌وسيله‌ي ايجاد كننده پذيرفته شد",
"Task accepted by task user" => "وظيفه از طرف كاربر موظف پذيرفته شد",
"Task NOT accepted by creator" => "وظيفه به‌وسيله‌ي ايجاد كننده پذيرفته نشد",
"Task NOT accepted by task user" => "وظيفه از طرف كاربر موظف پذيرفته نشد",
"Sorry this task does not exist or you have no rights to view this task" => "متاسفانه چنين وظيفه‌اي وجود ندارد، يا شما حقوق دسترسي كافي براي ديدن آن را نداريد",
"Task entries:" => "اقلام وظايف:",
"Changes:" => "تغييرات:",
"Info message" => "پيغام اطلاعات",
"NEW Task" => "وظيفه‌ي جديد",
"Changes on Task" => "تغييرات در وظايف",
"You received a new task" => "شما يك وظيفه‌ي جديد دريافت كرده‌ايد",
"The priority is" => "اولوست",
"very low" => "very low",
"low" => "low",
"high" => "بالا",
"very high" => "خيلي بالا",
"You've to start your work at least on" => "شما بايد حداقل تا اين موقع كار خود را آغاز كنيد",
"You've to finish your work on" => "شما بايد كارتان را تا اين موقع تمام كنيد",
"Login and click the link below" => "وارد سامانه شده و روي پيوند زير كليك كنيد",
"Please read the task and work on it!" => "لطفا وظيفه را بخوانيد و رويش كار كنيد!",
"Sorry this problems by writing into the database" => "متاسفانه در نوشتن در بانك اطلاعات با اشكال روبرو شدم",
"forum_post_topic" => "عنوان الصاق انجمن",
"wiki_page_changed" => "صفحه‌ي ويكي تغيير كرده است",
"forum_post_thread" => "رگه‌ي الصاق انجمن",
"Cannot upload this file not enough quota" => "نمي‌توانم اين پرونده را بارگذاري كنم. محدوديت حجم شما پر خواهد شد",
"Non-existent user" => "كاربر وجود ندارد",
"No banner indicated" => "هيچ درفشي مشخص نشده است.",
"No blog indicated" => "هيچ بلاگي مشخص نشده است.",
"Permission denied you cannot remove the post" => "دسترسي ممنوع است: متاسفانه شما نمي‌توانيد اين الصاق را حذف كنيد",
"No cache information available" => "اطلاعات cache در دسترس نيست",
"No faq indicated" => "هيچ FAQاي مشخص نشده است.",
"You are not permitted to remove someone else\\'s post!" => "شما حق حذف الصاقات شخص ديگر را نداريد!",
"Wrong password. Cannot post comment" => "كلمه‌ي عبور اشتباه است. نمي‌توانم نظر را الصاق كنم",
"Please wait 2 minutes between posts" => "لطفا بين هر دو الصاق، 2دقيقه صبر كنيد‌",
"No thread indicated" => "هيچ رگه‌اي مشخص نشده است",
"A SheetId is required." => "يك شناسه‌ي ورق لازم است.",
"Your email address has been removed from the list of addresses monitoring this tracker" => "آدرس پست الكترونيكي شما از فهرست ديده‌بانان اين tracker حذف شد",
"Your email address has been added to the list of addresses monitoring this tracker" => "آدرس پست الكترونيكي شما به فهرست ديده‌بانان اين tracker اضافه شد",
"Cancel monitoring" => "لغو ديده‌باني",
"Monitor" => "ديده‌باني",
"Your email address has been removed from the list of addresses monitoring this item" => "آدرسي الكترونيكي شما از فهرست ديده‌بانان اين فقره حذف شد",
"Your email address has been added to the list of addresses monitoring this item" => "آدرس پست الكترونيكي شما به فهرست ديده‌بانان اين فقره اضافه شد",
 "That tracker don't use extras." => "That tracker doesn't use extras.",
"No subject" => "بدون موضوع",
"Your email was sent" => "پست الكترونيكي شما ارسال شد",
"Top pages" => "برترين صفحات",
"Last pages" => "آخرين صفحات",
"Tiki RSS feed for the wiki pages" => "تغذيه‌ي RSS تيكي براي صفحات ويكي",
"Last modifications to the Wiki." => "آخرين تغييرات ويكي",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "صفحه‌ي {\$mail_page} به‌وسيله‌ي {\$mail_user} در {\$mail_date|tiki_short_datetime} تغيير كرد.",
// ----------------- Manually added  --------------------
"Go to group homepage only if login from default homepage" => "تنها در صورتي كه از صفحه‌ي پيش‌فرض وارد شدند، به صفحه‌ي مبدا گروه برو",
"Favicon icon file name:" => "نام پروندهي تمثال(Icon) پايگاه(favicon filename):‌",
"Favicon icon MIME type:" => "نوع MIME تمثال پايگاه:",
"Locations separator" => "جداساز مكان‌ها",
"Other sections" => "ساير بخش‌ها",
"Navigation features" => "خصيصه‌هاي ناوبري",
"Administration features" => "خصيصه‌هاي مديريتي",
"Crosslinks to other features and settings" => "دسترسي مستقيم به ساير خصيصه‌ها و تنظيمات",
"entire site" => "تمام پايگاه",
"wiki pages" => "صفحات ويكي",
"Edit Summary" => "خلاصه‌ي ويرايش",
"Most viewed objects" => "پربيننده‌ترين اشياء",
"Most viewed objects in the last 7 days" => "پربيننده‌ترين اشياء در هفته‌ي گذشته",
"permanency" => "قطعيت",
"User Preferences" => "تنظيمات كاربر",
"Allow trackback pings" => "اجازه‌ي pingهاي مسيريابي معكوس را بده(trackback pings)",
"Admin mods" => "مديريت ماژول‌ها",
"remove users and their userpages" => "كاربران و صفحات آن‌ها را حذف كن",
"Tiki Logs" => "ثبت وقايع تيكي",
"structure" => "",
"Random active poll" => "راي‌گيري فعال تصادفي",
"Random current poll" => "راي‌گيري جاري تصادفي",
"Must be wiki parsed" => "بايد توسط ويكي تجزيه شده باشد",
"Redirect On Error" => "هنگام بروز خطا، كاربر را Redirect كن",
"Bottom bar icons" => "تمثال‌هاي نوار پايين",
"Bottom bar debug" => "رفع اشكال نوار پايين",
"always" => "همواره",
"never" => "هرگز",
"user decides" => "بنا به تصميم كاربر",
"SysLogs" => "ثبت وقايع",
"Security" => "امنيت",
"System" => "سامانه",
"Transversal features" => "خصيصه‌هاي نوسنجي",
"which apply to more than one section" => "آن‌هايي كه به بيش از يك‌بخش اعمال مي‌شوند",
"Text area features" => "خصيصه‌هاي فضاي متني",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "خصيصه‌هايي كه مي‌توانيد در تمام فضاهاي متني مانند صفحات ويكي، بلاگ‌ها، مقالات، انجمن‌ها و غيره، استفاده كنيد",
"Users can Shade Modules" => "كاربران مي‌توانند ماژول‌ها را زير و بم كنند",
"module decides" => "بنا به ماژول",
"Administration:" => "مديريت:",
"must be turned on and notification is sent to the admin's" => "بايد روشن باشد، آگاه‌سازها براي سرپرستان ارسال مي‌شود",
"inter-user message inbox" => "صندوق پستي بين كاربري",
"Stats &amp; banners" => "آمارها و درفش‌ها",
"themes" => "قيافه‌ها",
"Look &amp; feel" => "ببين و حس كن",
"Users accept internal messages by default" => "به‌صورت پيش‌فرض، كاربران پيغام‌هاي داخلي را دريافت كنند",
"Users can opt-out internal messages" => "كاربران بتوانند پيغام‌هاي داخلي را دست‌چين كنند",
"Maximum mailbox size (messages, 0=unlimited)" => "بيشينه فضاي صندوق پستي)تعداد پيغام، 0 به معني بدون محدوديت)",
"Maximum mail archive size (messages, 0=unlimited)" => "بيشينه فضاي صندوق بايگاني)تعداد پيغام، 0 به معني بدون محدوديت)",
"Maximum sent box size (messages, 0=unlimited)" => "بيشينه فضاي صندوق پيگيري(sent box))تعداد پيغام، 0 به معني بدون محدوديت)",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "اگر 'نگهداري كلمات عبور به‌صورت كدنشده' فعال است، كلمات‌عبور را بنا به درخواست به پست الكترونيكي بفرست، در غير اين صورت، به كمك پست الكترونيكي آن‌ها را عوض كن",
"Auth Type" => "گونه‌ي تصديق هويت",
"IMAP/POP3/LDAP Host" => "ميزبان IMAP/POP3/LDAP",
"IMAP/POP3/LDAP Port" => "درگاه IMAP/POP3/LDAP",
"IMAP/POP3 BaseDSN" => "DSN پايه درIMAP/POP3/LDAP",
"i18n" => "بين‌الملل سازي(i18n)",
"Owner of the gallery" => "مالك سرسرا",
"Dec" => "دسامبر",
"Nov" => "نوامبر",
"list galleries" => "فهرست سرسراها",
"Available Newsletters" => "خبرنامه‌هاي موجود",
"No newsletters available." => "هيچ خبرنامه‌اي موجود نيست.",
"Apply content template" => "اين الگوي محتوا را به خبرنامه اعمال كن",
"Home Gallery" => "سرسراي مبدا",
"Directory Batch Loading" => "باركردن دسته‌اي پوشه‌ها",
"Enable directory batch loading" => "باركردن دسته‌اي پوشه‌ها فعال باشد",
"Batch loading directory" => "پوشه‌ي باركردن دسته‌اي",
"Enable cache images to all galleries" => "براي تمام سرسراها، نهانگاه(cache) تصاوير فعال باشد",
"Images cache directory" => "پوشه‌ي نهانگاه تصاوير(cache dir)",
"Move images from filesystem storage to database storage" => "تصاوير را به بانك اطلاعاتي منتقل كن",
"Mover" => "انتقال",
"Change configuration" => "تغيير پيكربندي",
"Change settings" => "تغيير تنظيمات",
"Wiki Administration" => "مديريت ويكي",
"Wiki attachments preferences" => "تنظيمات ضمايم ويكي",
"Load page on navigation" => "هنگام مرور صفحه را بار كن",
"Camera distance" => "فاصله‌ي دوربين",
"Camera distance adjusted relative to nearest node" => "فاصله‌ي دوربين باتوجه به نزديك‌ترين گره",
"Field of view" => "ميدان ديد",
"Node size" => "حجم گره",
"Text size" => "حجم متن",
"Eletrostatic constant" => "ثابت الكترواستاتيك",
"Friction constant" => "ثابت اصطحكاك",
"Elastic constant" => "ثابت ارتجاعي",
"Spring (connection) size" => "حجم ارتباط",
"Node mass" => "جرم گره",
"Node charge" => "هزينه‌ي گره",
"Wysiwyg editor" => "ويرايش‌گر Wysiwyg",
"Wiki syntax used when a page contains HTML" => "نحو ويكي، هنگامي كه صفحه‌اي شامل كدهاي HTML است",
"full" => "كامل",
"partial" => "ناقص",
"Similar" => "مشابهات",
"Show page ID" => "شناسه‌ي صفحه را نمايش بده",
"Footnotes" => "تبصره‌ها",
"List authors" => "مؤلفان را فهرست كن...",
"Business style" => "سبك تجاري",
"Collaborative style" => "سبك همكاري",
"no (disabled)" => "هيچكدام (غيرفعال)",
"as Creator &amp; Last Editor" => "به‌عنوان ايجادكننده و آخرين ويراستار",
"Print Page" => "چاپ صفحه",
"Search and replace" => "جستجو و جايگزيني",
"IP not displayed in history" => "آدرس اينترنتي(IP) در تاريخچه نمايش داده نشود",
"Post level trackback pings" => "pingهاي مسيريابي معكوس در سطح هر الصاق",
"Referer Search Highlighting" => "علامت‌زدن اطلاعات جستجو شده",
"Refresh wiki search index now" => "راهنماي جستجوي ويكي را بازيابي كن",
"Meta Tags settings" => "تنظيمات فرابرچسب‌ها",
"Geourl" => "آدرس جغرافيايي",
"Robots" => "ماشين‌هاي خودكار",
"Caching time :" => "زمان Cache",
"seconds (0 = cache inactive)" => "ثانيه (0 معادل غيرفعال است) ",
"Distance" => "فاصله",
"Site Identity features" => "خصيصه‌هاي عينيت پايگاه",
"Custom Code" => "كد متناسب‌سازي",
"Site Breadcrumbs" => "خرده نان‌هاي پايگاه",
"Site breadcrumbs" => "خرده نان فعال باشد",
"at top of page" => "بالاي صفحه",
"at top of center column" => "بالاي ستون مركزي",
"Prefix breadcrumbs with 'Location:' label?" => "آيا برچسب 'مكان:' پيشوند خرده‌نان‌ها باشد؟",
"Larger font for" => "قلم درشت‌تر براي",
"entire location" => "تمام محل",
"Use page description:" => "از توضيحات صفحه استفاده كن",
"page name" => "نام صفحه",
"Site Search" => "جستجوي پايگاه",
"Site search bar" => "نوار جستجوي پايگاه",
"Site Logo" => "نماد پايگاه",
"Site Ads and Banners" => "نشان‌ها و تبليغات پايگاه",
"Site Menu" => "منو پايگاه",
"Site menu bar" => "نوار منو پايگاه",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => " نكته: اين خصيصه نياز به فعال بودن لايه‌هاي PHP يا همان PHPLayers در بخش 'مديريت->خصيصه‌ها' نيز دارد.",
"I18n setup" => "برپاسازي i18n",
"Print article" => "امكان چاپ مقالات",
"Settings for page articles home" => "تنظيمات صفحه‌ي مبدا مقالات",
"Home Forum" => "مبدا انجمن‌ها",
"User Watches Translations" => "ديده‌بان‌هاي كاربران را ترجمه كن",
"Forums features" => "خصيصه‌هاي انجمن‌ها",
"enable cool sites" => "پايگاه‌هاي بامزه فعال باشد",
"MIME Type" => "نوع MIME",
"System command" => "فرمان",
"FAQ comments settings" => "تنظيمات مربوط به 'نظرات' FAQها",
"Maps configuration" => "پيكربندي نقشه‌ها",
"Trackers attachments preferences" => "تنظيمات ضمايم Trackerها",
"Trackers with mirror tables" => "Trackerها با جداول آيينه‌اي",
"Use trackers with mirror tables" => "از Trackerها با جداول آيينه‌اي استفاده كن",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "مقادير در جداول اختصاصي براي هر tracker نگهداري مي‌شوند. بنابراين شما مي‌توانيد به راحتي آن‌ها را خارج از تيكي‌ويكي دستكاري كنيد",
"Validate choice" => "انتخاب‌ها را تاييد اعتبار كن",
"Trackers attachments" => "ضمايم trackerها",
"Calendar settings" => "تنظيمات تقويم",
"Unlimited" => "نامحدود",
"InterTiki" => "بين تيكي(Inter tiki)",
"Intertiki" => "بين تيكي(Inter tiki)",
"Tiki Unique key" => "كليد يكتاي تيكي",
"InterTiki Slave mode" => "حالت برده در بين‌تيكي",
"Warning: overrides manually registered local users" => "اخطار: اين گزينه جايگزين كاربران ثبت‌نام كرده‌ي محلي(local) كه به‌صورت دستي وارد شده‌اند خواهد شد.",
"Intertiki client" => "ارباب‌رجوع(client) بين‌تيكي",
"Intertiki server" => "خدمتگزار(server) بين‌تيكي",
"as master" => "به عنوان كارفرما",
"Add new server" => "اضافه كردن يك سرور جديد",
"host" => "ميزبان",
"Intertiki settings" => "تنظيمات بين تيكي",
"Intertiki Server enabled" => "سرور بين‌تيكي فعال است",
"Access Log file" => "پرونده‌ي ثبت وقايع دسترسي",
"Errors Log file" => "پرونده‌ي ثبت خطاها",
"New" => "جديد",
"Key" => "كليد",
"Contact" => "تماس",
"You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :" => "براي اين پايگاه احتياج به درخواست يك 'كليد نقشه‌ي گوگل' داريد. به سادگي مي‌توانيد براي اين domain يكي در اين آدرس تهيه كنيد:",
"Google Maps" => "نقشه‌هاي گوگل",
"Google Map Key" => "كليد نقشه گوگل",
"Default x for map center" => "طول پيش‌فرض براي مركز نقشه",
"Default y from map center" => "عرض پيش‌فرض براي مركز نقشه",
"Default zoom level" => "مقدار پيش‌فرض بزرگ‌نمايي(zoom)",
"whole earth" => "تمام جهان",
"country size" => "اندازه‌ي كشور",
"city size" => "اندازه‌ي شهر",
"max zoom" => "بيشينه بزرگنمايي",
"Enable/disable Tiki features here, but configure them elsewhere" => "خصيصه‌هاي ويكي را در اين محل فعال/غيرفعال كنيد، اما آن‌ها را جاهاي ديگر پيكربندي نماييد.",
"User registration, login and authentication" => "ثبت‌نام كاربران، ورود و تصديق هويت",
"Configuration options for all blogs on your site" => "تنظيمات پيكربندي براي تمام بلاگ‌ها در پايگاه شما",
"Directory settings" => "تنظيمات پوشه",
"Trackers settings" => "تنظيمات Trackerها",
"RSS settings" => "تنظيمات RSS",
"Internationalization" => "بين‌الملل‌سازي",
"Group calendar item view tab" => "برگ مشاهده‌ي اقلام تقويم را گروه‌‌بندي كن",
"Calendar manual selection of time/date" => "انتخاب دستي زمان/تاريخ تقويم",
"comment" => "ايراد نظر",
"Send mails even when the post is generated by inbound mail" => "حتي هنگامي كه خود الصاق به وسيله‌ي پست الكترونيكي ايجاد شده است، پست الكترونيكي را ارسال كن!؟",
"Append a reply link to outbound mails" => "يك پيوند 'پاسخ' به پست‌هاي الكترونيكي خروجي اضافه كن؟",
"risky" => "خطرناك",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen ممكن است به‌صورت بالقوه براي بارگذاري اطلاعات يا دستخط(script) از راه دور مورد استفاده قرار گيرد. اگر از بلاگ‌ها استفاده نمي‌كنيد، مي‌توانيد اين خصيصه را خاموش كنيد.",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "خصيصه‌ي 'ويرايش الگوها' روشن است. به كساني كه اطمينان نداريد، امكان استفاده از اين خصيصه را ندهيد، زيرا به راحتي براي تزريق دستور به PHP مورد استفاده قرار مي‌گيرد.",
"Mods Configuration" => "پيكربندي حالت",
"Active?" => "فعال؟",
"add a category" => "اضافه كردن يك طبقه",
"image gallery" => "سرسراي تصوير",
"Send copies of all activity in this tracker to this e-mail address" => "ارسال رونوشت تمام فعاليت‌ها در اين tracker به اين آدرس:",
"Use simplified e-mail format" => "از شكل ساده شده‌ي پست الكترونيكي استفاده كن",
"The tracker needs a text field named Subject" => "(tracker احتياج به يك رشته‌ي متني به‌نام Subject دارد)",
"The tracker needs a group field with the option 1" => "(tracker به يك رشته‌ي گروه كاربري option برابر 1 نياز دارد)",
"country selector" => "انتخاب كشور",
"Country Selector options: 1|2 where 1 show only country name and 2 show only country flag. By default show both country name and flag" => "اختيارات: 1و2 كه 1 تنها نمايش دهنده‌ي نام كشور و 2 تنها نمايش دهنده‌ي پرچم كشور. به‌صورت پيش‌فرض، هم نام و هم پرچم نمايش داده مي‌شود.",
"not hidden" => "مخفي نيست",
"visible by admin only" => "تنها به‌وسيله‌ي سرپرست قابل مشاهده است",
"editable by admin only" => "تنها به‌وسيله‌ي سرپرست قابل تغيير است",
"No processes defined or activated yet" => "هنوز هيچ فرايندي تعريف ويا فعال نشده است.",
"Instance Id" => "شناسه‌ي نمونه",
"Instance Name" => "نام نمونه",
"Instance Status" => "وضعيت نمونه",
"Elapsed time" => "زمان صرف شده",
"n" => "خير",
"y" => "بله",
"users registered" => "كاربر ثبت‌نام كرده است",
"list view" => "نمايش فهرستي",
"Custom Participants" => "شركت‌كننده‌هاي متناسب",
"Custom Subscription List" => "فهرست اشتراك متناسب",
"participants" => "شركت‌كنندگان",
"subscription" => "اشتراك",
"Subscription List" => "فهرست اشتراك",
"Trackers Items" => "اقلامtrackerها",
"phplayers are not available on this site" => "لايه‌هاي PHP در اين پايگاه فعال نيستند.",
"offline" => "خارج خط",
"Mobile" => "سيار",
"Upload File" => "بارگذاري پرونده",
"Trackbacks Pings" => "pingهاي trackbackها",
"hits last 7 days" => "ضربت در هفت روز گذشته",
"Layer Management" => "مديريت لايه‌ها",
"as well as assign or edit many others." => "همان‌گونه كه مي‌توانيد بسياري ماژول‌هاي ديگر را تخصيص دهيد يا ويرايش كنيد.",
"Parameters" => "پارامترها",
"Send a message" => "ارسال پيغام",
"Current events" => "رويدادهاي جاري",
"Pages:" => "صفحات:",
"move to archive" => "انتقال به بايگاني",
"Sent" => "ارسال شده‌ها",
"Archive" => "بايگاني",
"find replied message" => "پاسخ ارسالي را بياب",
"reply to" => "پاسخ داده‌شده",
"receiver" => "گيرنده",
"Sent Messages" => "پيغام‌هاي ارسال شده",
"Message Archive" => "بايگاني پيغام‌ها",
"admin mode" => "حالت سرپرستي",
"use start date and time" => "از تاريخ و ساعت شروع استفاده كن",
"use end date and time" => "از تاريخ و ساعت پايان استفاده كن",
"Sorry, there was an error while trying to write data into the database" => "متاسفم، هنگام نوشتن در پايگاه داده با اشكال مواجه شدم.",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "متاسفم، شما اجازه‌ي ارسال وظيفه به ساير كاربران را نداريد، يا كاربر انتخابي اجازه‌ي دريافت وظيفه را ندارد!",
"trackers" => "Trackerها",
"use google map locator" => "از نقشه‌ياب گوگل استفاده كن",
"file_galleries" => "سرسراهاي پرونده",
"html_pages" => "صفحات HTML",
"user_messages" => "پيغام‌هاي كاربر",
"mytiki" => "تيكي من",
"surveys" => "نظرسنجي‌ها",
"featured_links" => "پيوندهاي خاص",
"newsreader" => "اخبارگو",
"workflow" => "گردش كار",
"webmail" => "پست تحت وب",
"wiki page" => "صفحه‌ي ويكي",
"offline since" => "از اين زمان روي خط نيامده است",
"messages" => "پيغام‌ها",
"taskId" => "شناسه‌ي وظيفه",
"Jan" => "ژانويه",
"Note author when reading his mail" => "هنگامي كه پست الكترونيكي مولف خوانده مي‌شود، به وي خبر بده",
"Auto-archive read messages after x days" => "پس از چند پيغام‌هاي خوانده شده را به‌صورت خودكار بايگاني كنم؟",
"cms" => "سامانه‌ي مديريت محتوا",
"mn" => "دقيقه",
"save only in the theme:" => "ذخيره فقط براي قيافه‌ي ",
"Friendship request sent to %s" => "درخواست رفاقت به %s ارسال شد.",
"Usage chart" => "نمودار استفاده",
"Usage chart image" => "تصوير نمودار استفاده",
"Daily Usage" => "استفاده روزانه",
"Spreadsheet" => "صفحه‌گسترده",
"Import From File" => "پرونده را از اين وارد كن",
"Grab Wiki Tables" => "جداول ويكي را بگير",
"Down" => "پايين",
"Up" => "بالا",
"Right" => "راست",
"Left" => "چپ",
"None" => "هيچ‌كدام",
"currency" => "پول",
"currency_us" => "پول_كانادا",
"currency_ca" => "پول_آمريكا",
"To" => "به",
"Errors:" => "خطاها:",
"Activity start is interactive so it must use the \$instance->complete() method" => "فعاليت آغاز تعاملي است، لذا بايد بدين شكل باشد: \$instance->complete() method",
"Note: It is not possible to delete an active process. To delete a process, deactivate it first." => "نكته: يك فرايند فعال را نمي‌توانيد حذف كنيد. براي حذف يك فرايند بايد ابتدا آن را غيرفعال سازيد.",
"optional" => "اختياري",
"UserPageadmin" => "مديريت صفحه‌ي كاربر",
"Note: You have to import security data via installation process (tiki-install.php). Import the *secdb* update files in your database" => "نكته: شما بايد داده‌هاي امنيتي را با فرايند نصب وارد كنيد (tiki-install.php). پرونده‌هاي به‌روز رسان *secdb* را به بانك اطلاعات خود وارد كنيد.",
"Group calendar sticky popup" => "popupهاي پسبان تقويم را در گروه قرار بده",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely." => "اخطار: trackerهاي جديد و قديمي، همزمان نمي‌توانند وجود داشته باشند. Trackerهايي كه با كتابخانه‌هاي جديد ساخته مي‌شوند با كتابخانه‌هاي قديمي كار نخواهند كرد، و برعكس.",
"System Gallery" => "سرسراي سامانه(system gallery)",
"Php GD library required" => "PHP GD مورد نياز است",
"GZIP Disabled" => "GZIP غيرفعال است",
"Any wiki page is changed, even minor changes" => "هر صفحه‌ي ويكي كه تغيير مي‌كند، حتي اگر تغييرات اندك باشند",
"Exact match" => "دقيقا مانند",
"Tiki initialization" => "آماده‌سازي تيكي",
"###end###"=>"###end###");
?>
